package p12f.exe.file.utils.filters;

import java.io.File;
import java.io.FilenameFilter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class FileFilterEarlyDateUtils implements FilenameFilter {
	String filterDate;
    SimpleDateFormat sdf;

    public FileFilterEarlyDateUtils(String filterDate) {
        this.filterDate = filterDate;
        sdf = new SimpleDateFormat("yyyy-MM-dd");
    }

    public boolean accept(File dir, String name) {
        Date d = new Date(new File(dir, name).lastModified());
        String current = sdf.format(d);
        return (filterDate.compareTo(current) >= 0);
    }
}
