package p12f.exe.file.utils.filters;

import java.io.File;
import java.io.FilenameFilter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class FileFilterEarlyDateWithoutExtensionUtils implements FilenameFilter {
	String filterDate;
    SimpleDateFormat sdf;
    String extension;

    public FileFilterEarlyDateWithoutExtensionUtils(String filterDate, String extension) {
        this.filterDate = filterDate;
        this.extension = extension;
        sdf = new SimpleDateFormat("yyyy-MM-dd");
    }

    public boolean accept(File dir, String name) {
    	File aux = new File(dir, name);
        Date d = new Date(aux.lastModified());
        String current = sdf.format(d);
        String ext = "";
        if (aux.isFile()) {
        	if (aux.getName().lastIndexOf(".")>=0){
        		ext = aux.getName().substring(aux.getName().lastIndexOf(".")+1);
        		ext = ext.toLowerCase();
        	}
        }
        return ((filterDate.compareTo(current) >= 0)
        	&& (!extension.equals(ext)));
    }
}
