package p12f.exe.holdercert.objects.config.query;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class BaseHolderCertQueryResultGroupItem implements Serializable, Initializable {
	
	public String id;
	public String nombreLote;
	public String packageId;
	public String finantialOrgId;
	public String adminId;
	public int numValidaciones;
	public int numValidacionesRealizadas;
	public Map datosAdicionales;
	public String holderCertTypeId;
	
	public BaseHolderCertQueryResultGroupItem(){
        ObjectUtils.initialize(this);
    }
	
	/**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static BaseHolderCertQueryResultGroupItem getObject( String xml) throws XOMarshallerException {
        return (BaseHolderCertQueryResultGroupItem)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto BaseConfigQueryResult a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }

}
