package p12f.exe.holdercert.objects.config.query;

import java.io.Serializable;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.HolderCertData;
import p12f.exe.pasarelapagos.objects.HolderCertDataList;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos bancarios a certificar.
 */

public class HolderCertForwardQueryResult implements Serializable, Initializable{

	public String resultId; // OID
	public String id; // ID del paquete o de la validacin individual, segn corresponda
	public String finantialOrg;
	public int retries;
	public HolderCertData holderCertData;
	public HolderCertDataList holderCertDataList;
	public Map aditionalDataList;
	
	/**
	 * Constructor vaco
	 */
	public HolderCertForwardQueryResult(){
	    ObjectUtils.initialize(this);
	}
	
	
	/**
	 * Convierte un objeto HolderCertStatusQueryResult a XML.
	 * @return String con el XML que representa al HolderCertStatusQueryResult
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
	
    /**
	 * Convierte un XML en un objeto HolderCertStatusQueryResult.
	 * @return Objeto HolderCertStatusQueryResult construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static HolderCertForwardQueryResult getObject(String xml) throws XOMarshallerException {    
	    return (HolderCertForwardQueryResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
