package p12f.exe.holdercert.utils;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.HolderCertData;
import p12f.exe.pasarelapagos.objects.HolderCertDataList;

public class HolderCertDataListAgrupator {
	
	/**
	 * Devuelve un mapa de HolderCertDataList agrupados por Entidad Financieras.
	 * @param list
	 * @return
	 * @throws Exception
	 */
	public static Map  groupByFinantialOrg(HolderCertDataList list ) throws Exception{
		
		Map mapFinantialOrgs  = new HashMap();
		for ( Iterator it = list.dataList.iterator();it.hasNext();) {
			HolderCertData certData = (HolderCertData)it.next();
			String finantialOrgData = getFinantialOrgCode(certData);
			if (!mapFinantialOrgs.containsKey(finantialOrgData)) {
				HolderCertDataList newHolderCertDataList = new HolderCertDataList();
				newHolderCertDataList.packageID = list.packageID;
				newHolderCertDataList.dataList.add(certData);
				mapFinantialOrgs.put(finantialOrgData, newHolderCertDataList);
			} else {
				HolderCertDataList holderCertDataListToUpdate = (HolderCertDataList)mapFinantialOrgs.get(finantialOrgData);
				holderCertDataListToUpdate.dataList.add(certData);
				mapFinantialOrgs.put(finantialOrgData, holderCertDataListToUpdate);
			}
		}
		return mapFinantialOrgs;
	}

	
	
	
	
	
	/**
	 * Obtiene el cdigo de entidad financera de los datos a validar.
	 * @param holderCertData
	 * @return
	 */
	public static String getFinantialOrgCode(HolderCertData holderCertData)throws Exception {
	
		
		String itemToCert = holderCertData.itemToCertNumber;		
		if (holderCertData.type.equalsIgnoreCase(HolderCertData.TYPE_CREDITCARDATA))
			return null;
		else {
			try {
			if (holderCertData.accountNumberFormat.equalsIgnoreCase(HolderCertData.ACCOUNT_NUMBER_FORMAT_CC)){
				return  itemToCert.substring(0, 4);
			}
				
			else if (holderCertData.accountNumberFormat.equalsIgnoreCase(HolderCertData.ACCOUNT_NUMBER_FORMAT_IBAN)){
				return  itemToCert.substring(4, 8);
			}
			
		   } catch (Exception ex) {
			   throw new Exception("Error en el formato de cuenta :, pe. Cdigo IBAN: ES7620770024003102575766 (formato electrnico).\n \n  :"+ ex.getLocalizedMessage() + "@ itemToCert=" + itemToCert);
		   }
			
			
		}
		return null;
				
	}
}
