package p12f.exe.holdercert.utils;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import p12f.exe.pasarelapagos.objects.HolderCertCertifiedData;
import p12f.exe.pasarelapagos.objects.HolderCertCertifiedDataList;

/**
 * 
 * @author iolabaro
 *
 */
public class HolderCertDataListZipper {
	
    /**
     * Comprime en un zip el fichero pasado como parmetro.
     * @param bytes Array de bytes correspondientes al fichero a comprimir.
     * @return byte[] Array de bytes correspondientes al fichero comprimido.
     * @throws IOException
     */
    public static byte[] zip(byte[] bytes) throws IOException {  
        ByteArrayOutputStream bos = new ByteArrayOutputStream();  
        ZipOutputStream zipfile = new ZipOutputStream(bos);  
        String fileName = "" + System.currentTimeMillis();
        ZipEntry zipentry = new  ZipEntry(fileName);
        zipfile.putNextEntry(zipentry);  
        zipfile.write((byte[]) bytes);  
        zipfile.close();  
        return bos.toByteArray();  
    }
	
    /**
     * Recoge un zip y devuelve el fichero descomprimido.
     * Vlido para zips con un solo fichero.
     * @param bytes InputStream correspondientes al ZIP
     * @return byte[] Array de bytes correspondientes al fichero descomprimido
     * @throws IOException
     */
    public static byte[] unzip(InputStream bytes) throws IOException {  
    	
    	ZipInputStream zipinputstream = new ZipInputStream(bytes); 
    	ByteArrayOutputStream output = null;
    	while( zipinputstream.getNextEntry() != null ) {
    		output = new ByteArrayOutputStream();
    		int data = 0;
    		while( ( data = zipinputstream.read() ) != - 1 ) {
    			output.write( data );
    		}
    		output.close();
    	}
    	zipinputstream.close();
    	return output.toByteArray();
    }
	
	
	/**
	 * GenerateCompletedHolderCerResult
	 * @param filePath
	 * @return HolderCertCertifiedDataList
	 * @throws Exception
	 */
    public static HolderCertCertifiedDataList generateCompletedHolderCerResult(String filePath) throws Exception {
    	/********************  ZIP ****************************/
    	File dir = new File(filePath);
    	File[] dirs = dir.listFiles();    	
    	ArrayList list = new  ArrayList();    	
    	for (int i = 0; i< dirs.length; i ++ ){    		
    		File[] resultFiles = dirs[i].listFiles();
    		for (int j = 0; j< resultFiles.length; j ++ ){
    			String pathZip  = resultFiles[j].getAbsolutePath();
    		    FileInputStream fisZIP = new FileInputStream(pathZip);
    		    byte[] responseBytes=  unzip( fisZIP); 
    			String xml = "";
    			BufferedReader in = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(responseBytes)));
    		    String inputLine=null;
    		    while ((inputLine = in.readLine()) != null) xml += inputLine;
    		    in.close();	 
    		    HolderCertCertifiedDataList cert = HolderCertCertifiedDataList.getObject(xml);
    		    list.add(cert);
    		}
    	}
    	//Add
    	HolderCertCertifiedDataList sumHolderCertCertifiedDataList = new HolderCertCertifiedDataList();
    	for (Iterator it = list.iterator(); it.hasNext();){
    		 HolderCertCertifiedDataList cert  =(HolderCertCertifiedDataList) it.next();    		 
    		 for (Iterator ix = cert.certCertifiedDataList.iterator();ix.hasNext();){
    			 HolderCertCertifiedData certdata =(HolderCertCertifiedData) ix.next();
    			 sumHolderCertCertifiedDataList.certCertifiedDataList.add(certdata);
    			 sumHolderCertCertifiedDataList.itemCount++;
    		 }
    	}
    	return sumHolderCertCertifiedDataList;
    }
}
