package p12f.exe.holdercert.utils.errors;

import java.io.Serializable;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.HolderCertData;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * EVENTOS DE ERROR INTERNOS.
 *
 */
public class HolderCertInternalError implements Serializable, Initializable {
	
	
	public static String GENERAL_ERROR_INITIALIZING_HOLDERCERT = "01" ;
	public static String GENERAL_ERROR_SENDING_HOLDERCERT = "02" ;
	public static String GENERAL_ERROR_RECEIVING_HOLDERCERT_RESPONSE = "03" ;
	
	public static String NON_EXISTENT_FINANTIAL_ORG = "04" ;
	public static String NON_EXISTENT_ADMINISTRATION = "05" ;
	public static String FINANTIAL_ORG_WITHOUT_KEYS = "06" ;
	public static String FINANTIAL_ORG_WITH_WRONG_KEYS = "07" ;
	
	public String code;
	
	public Map description;
	
	public HolderCertData holderCertData;

	/**
	 * Convierte un Objeto Tercero a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Tercero.
	 * @return Objeto Tercero construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static HolderCertInternalError getObject(String xml) throws XOMarshallerException {    
	    return (HolderCertInternalError)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
    
}
