package p12f.exe.ikus;

import java.io.Serializable;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class IKUSThirdRegistry implements Serializable {

	private static final long serialVersionUID = 4405108003159472663L;
	
	public String thirdID;
	
	public String ikusID;
	
	public String address;
	
	public String city;
	
	public String postalCode;
	
	public String iban;
	
	public String name;
	
	public String email;
	
	public String phoneNumber;
	
	
	public IKUSThirdRegistry(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte un Objeto PaymentTypeConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
 
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml: XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static IKUSThirdRegistry getObject( String xml) throws XOMarshallerException {
        return (IKUSThirdRegistry) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

}
