package p12f.exe.otp.objects;

import java.io.Serializable;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class OTPData implements Serializable {
	
	/**
	 * Identificador de la aplicacin solicitante del OTP.
	 */
	public String aplicationId;
	/**
	 * Identificador del servicio solicitante del OTP.
	 */
	public String serviceId;
	/**
	 * Identificador del tercero solicitante del OTP.
	 */
	public String oid;
	/**
	 * Identificador del OTP
	 */
	public String otpId;
	
	public OTPData() {
		
	}
	
	/**
	 * Convierte un Objeto OTPData a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OTPData.
	 * @return Objeto OTPData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OTPData getObject(String xml) throws XOMarshallerException {
		return (OTPData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
