package p12f.exe.otp.objects;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.AditionalData;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class OTPPresentationData implements Serializable {
	
	public static final int PRESENTATION_DATA_MAIL = 1;
	public static final int PRESENTATION_DATA_SMS = 2;
	
	public int presentationDataType = PRESENTATION_DATA_MAIL;
	
	public Map datosAdicionales = new HashMap();
	
	public OTPPresentationData() {
		
	}
	
	/**
	 * Convierte un Objeto OTPPresentationData a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OTPPresentationData.
	 * @return Objeto OTPPresentationData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OTPPresentationData getObject(String xml) throws XOMarshallerException {
		return (OTPPresentationData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	
	protected void _setAditionalData(String id, String value) {
		AditionalData datoAdicional = new AditionalData();
		datoAdicional.name = id;
		datoAdicional.value = value;
		this.datosAdicionales.put(id, datoAdicional);
	}
	
	protected String _getAditionalData(String id) {
		if (this.datosAdicionales.containsKey(id)) {
			return ((AditionalData)this.datosAdicionales.get(id)).value;
		}
		return null;
	}
	
	protected boolean _isFillAditionalData(String id) {
		if (this.datosAdicionales.containsKey(id) && !"".equals(((AditionalData)this.datosAdicionales.get(id)).value)) {
			return true;
		}
		return false;
	}
	
}
