package p12f.exe.otp.objects;

public class OTPPresentationDataMail extends OTPPresentationData {
	
	private static final String MAIL_ADDRESS = "mailAddress";
	private static final String MAIL_SUBJECT = "mailSubject";
	private static final String MAIL_TEMPLATE = "mailTemplate";
	private static final String MAIL_TEXT = "mailText";
	
	public OTPPresentationDataMail() {
		this.presentationDataType = PRESENTATION_DATA_MAIL;
	}
	
	public OTPPresentationDataMail(OTPPresentationData presentationData) {
		this();
		if (presentationData._isFillAditionalData(MAIL_ADDRESS)) {
			this.setMailAddress(presentationData._getAditionalData(MAIL_ADDRESS));
		}
		if (presentationData._isFillAditionalData(MAIL_SUBJECT)) {
			this.setMailSubject(presentationData._getAditionalData(MAIL_SUBJECT));
		}
		if (presentationData._isFillAditionalData(MAIL_TEMPLATE)) {
			this.setMailTemplate(presentationData._getAditionalData(MAIL_TEMPLATE));
		}
		if (presentationData._isFillAditionalData(MAIL_TEXT)) {
			this.setMailText(presentationData._getAditionalData(MAIL_TEXT));
		}
	}
	
	public OTPPresentationDataMail(String mail, String subject) {
		this();
		this.setMailAddress(mail);
		this.setMailSubject(subject);
	}
	
	public String getMailAddress() {
		return _getAditionalData(MAIL_ADDRESS);
	}
	public void setMailAddress(String mail) {
		_setAditionalData(MAIL_ADDRESS, mail);
	}
	public boolean isFillMailAddress() {
		return _isFillAditionalData(MAIL_ADDRESS);
	}
	
	public String getMailSubject() {
		return _getAditionalData(MAIL_SUBJECT);
	}
	public void setMailSubject(String subject) {
		_setAditionalData(MAIL_SUBJECT, subject);
	}
	public boolean isFillMailSubject() {
		return _isFillAditionalData(MAIL_SUBJECT);
	}
	
	public String getMailTemplate() {
		return _getAditionalData(MAIL_TEMPLATE);
	}
	public void setMailTemplate(String template) {
		_setAditionalData(MAIL_TEMPLATE, template);
	}
	public boolean isFillMailTemplate() {
		return _isFillAditionalData(MAIL_TEMPLATE);
	}
	
	public String getMailText() {
		return _getAditionalData(MAIL_TEXT);
	}
	public void setMailText(String text) {
		_setAditionalData(MAIL_TEXT, text);
	}
	public boolean isFillMailText() {
		return _isFillAditionalData(MAIL_TEXT);
	}

}
