package p12f.exe.otp.objects;

public class OTPPresentationDataSms extends OTPPresentationData {
	
	private static final String SMS_NUMBER = "smsNumber";
	private static final String SMS_TEXT = "smsText";
	private static final String SMS_ACK = "smsAck";
	private static final String SMS_EXPIRE_TIME = "smsExpireTime";
	
	public OTPPresentationDataSms() {
		this.presentationDataType = PRESENTATION_DATA_SMS;
	}
	
	public OTPPresentationDataSms(OTPPresentationData presentationData) {
		this();
		if (presentationData._isFillAditionalData(SMS_NUMBER)) {
			this.setSmsNumber(presentationData._getAditionalData(SMS_NUMBER));
		}
		if (presentationData._isFillAditionalData(SMS_TEXT)) {
			this.setSmsText(presentationData._getAditionalData(SMS_TEXT));
		}
	}
	
	public OTPPresentationDataSms(String number) {
		this();
		this.setSmsNumber(number);
	}
	
	public OTPPresentationDataSms(String number, String text) {
		this(number);
		this.setSmsText(text);
	}
	
	public String getSmsNumber() {
		return _getAditionalData(SMS_NUMBER);
	}
	public void setSmsNumber(String mail) {
		_setAditionalData(SMS_NUMBER, mail);
	}
	public boolean isFillSmsNumber() {
		return _isFillAditionalData(SMS_NUMBER);
	}
	
	public String getSmsText() {
		return _getAditionalData(SMS_TEXT);
	}
	public void setSmsText(String subject) {
		_setAditionalData(SMS_TEXT, subject);
	}
	public boolean isFillSmsText() {
		return _isFillAditionalData(SMS_TEXT);
	}
	
	public String getSmsAck() {
		return _getAditionalData(SMS_ACK);
	}
	public void setSmsAck(String ack) {
		_setAditionalData(SMS_ACK, ack);
	}
	public boolean isFillSmsAck() {
		return _isFillAditionalData(SMS_ACK);
	}
	
	public String getSmsExpireTime() {
		return _getAditionalData(SMS_EXPIRE_TIME);
	}
	public void setSmsExpireTime(String expireTime) {
		_setAditionalData(SMS_EXPIRE_TIME, expireTime);
	}
	public boolean isFillSmsExpireTime() {
		return _isFillAditionalData(SMS_EXPIRE_TIME);
	}
	
}
