package p12f.exe.otp.objects;

import java.io.Serializable;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class OTPValidationRequest implements Serializable {
	
	/**
	 * Aplicacin que solicita el OTP.
	 */
	public String aplicationId;
	/**
	 * Servicio para el que se solicita el OTP.
	 */
	public String serviceId;
	/**
	 * Identificador del tercero solicitante.
	 */
	public String oid;
	/**
	 * Identificador del OTP.
	 */
	public String otpId;
	/**
	 * OTP a validar.
	 */
	public String otpToValidate;
	
	public OTPValidationRequest() {
		
	}
	
	/**
	 * Convierte un Objeto OTPValidationRequest a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OTPValidationRequest.
	 * @return Objeto OTPValidationRequest construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OTPValidationRequest getObject(String xml) throws XOMarshallerException {
		return (OTPValidationRequest)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
