package p12f.exe.otp.objects;

import java.io.Serializable;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class OTPValidationResponse implements Serializable {
	
	public boolean validOtp = false;
	
	public OTPError otpError = null;
	
	public Integer otpValidationRetriesToExpire = null;
	
	public Long otpValidationExpireTime = null;
	
	public OTPValidationResponse() {
		
	}
	
	/**
	 * Convierte un Objeto OTPValidationResponse a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OTPValidationResponse.
	 * @return Objeto OTPValidationResponse construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OTPValidationResponse getObject(String xml) throws XOMarshallerException {
		return (OTPValidationResponse)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
