/*
 * Created on 01-jul-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.helpers;

import java.util.HashMap;
import java.util.Iterator;

import p12f.exe.pasarelapagos.exceptions.PaymentException;
import p12f.exe.pasarelapagos.objects.Pago;
import p12f.exe.pasarelapagos.objects.PaymentData;
import p12f.exe.pasarelapagos.objects.Tercero;
import p12f.exe.pasarelapagos.paymentrequest.PaymentRequestData;
import p12f.exe.pasarelapagos.paymentrequest.PeticionPago;

/**
 * Clase de ayuda para el manejo de estructuras PaymentData.
 */
public class PaymentDataHelper {
	
	/**
	 * Metodo que devuelve un objeto PaymentData a partir de un objeto PaymentRequestData 
	 * @param paymentRequestData 
	 * @return
	 */
	public static PaymentData composePaymentData(PaymentRequestData paymentRequestData){
		
		try{
			// Creamos un objeto PaymentData
			PaymentData paymentData = new PaymentData();
			
			// Recogemos los pagos de la peticion de pago
			paymentData.pagos = new HashMap();
			for(Iterator it = paymentRequestData.peticionesPago.keySet().iterator(); it.hasNext();){
				Pago pago = new Pago((PeticionPago)paymentRequestData.peticionesPago.get(it.next()));
				
				// Se eliminan los campos que molestan del objeto Tercero (Primer y Segundo Apellido)
				if (pago.expediente!=null && pago.expediente.tercero!=null) {
					Tercero tercero = pago.expediente.tercero;
					if (tercero.primerApellido!=null) {
						tercero.razonSocial += " " + tercero.primerApellido;
						tercero.primerApellido = null;
						if (tercero.segundoApellido!=null) {
							tercero.razonSocial += " " + tercero.segundoApellido;
							tercero.segundoApellido = null;
						}
					}
					tercero.tipoTercero = null;
					// se elmina el backend ya que es un objeto que las EF no estn preparadas para recibir por ahora (15/10/2013)
					//tercero.backend = null;
				}
				paymentData.pagos.put(pago.id, pago);
			}
			
			// Recogemos los datos adicionales
			paymentData.datosAdicionales = paymentRequestData.datosAdicionales;
			
			return paymentData;
		}catch(PaymentException ex){
			ex.printStackTrace();
			return null;
		}
	}
	
}
