package p12f.exe.pasarelapagos.helpers;

import java.util.Iterator;

import p12f.exe.pasarelapagos.paymentrequest.PaymentGatewayData;
import p12f.exe.pasarelapagos.paymentrequest.PaymentRequestData;
import p12f.exe.pasarelapagos.paymentrequest.PeticionPago;

import com.ejie.r01f.log.R01FLog;
import com.ejie.r01f.rpcdispatcher.RPCCall;
import com.ejie.r01f.rpcdispatcher.RPCFunction;
import com.ejie.r01f.rpcdispatcher.RPCParameter;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;

public class SenderHelper {

    /**
     * @param args
     */
    public static void main(String[] args) {
        // TODO Auto-generated method stub

    }

    /**
     * Obtiene el codigo html para hacer un post
     * @param data
     * @return
     */
    public static String getHTMLPostCode(PaymentGatewayData data , String url ){
        
        StringBuffer code  = new StringBuffer();
   
        try {
            PaymentRequestData  paymentRequestData =  data.paymentRequestData;
               
            String oids = "";
            for(Iterator it = paymentRequestData.peticionesPago.keySet().iterator(); it.hasNext();){
                PeticionPago peticionPago = (PeticionPago)paymentRequestData.peticionesPago.get(it.next());
                
                // Se comprueba si la peticion de pago ha superado la validacion
                if(peticionPago.validacion!=null && !peticionPago.validacion.valido) {
                    // La peticion de pago no ha superado la validacion
                    R01FLog.to("p12d.clientPaymentAPI").info("ERROR: La peticion de pago " + peticionPago.id + " no ha superado la validacion.");
                    R01FLog.to("p12d.clientPaymentAPI").info("Error de validacion: " + peticionPago.validacion.mensaje);
                } else {
                    // La peticion de pago se ha validado correctamente y se incluye su oid
                    oids += peticionPago.id + ",";
                }
            }
   
            code.append("<html>");
            code.append("<head>");            
            code.append("<meta http-equiv='Expires'content='Tue, 01 Jan 1980 1:00:00 GMT'>");
            code.append("<meta http-equiv='Pragma' content='no-cache'>");            
            code.append("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />");
            code.append("</head>");
            code.append("<body>");
            code.append("<form name='p12FormOids' id='p12FormOids' method='POST' action='" + url + "'>");
            code.append("<input type='hidden' name='module' value='IU'>");
            code.append("<input type='hidden' name='p12iOidsPago' value=\"" + oids + "\">");
            code.append("<input type='hidden' name='p12iPresentationRequestData' value=\"" + data.presentationData.toXML() + "\">");
            code.append("<input type='hidden' name='p12iProtocolData' value=\"" + data.protocolData.toXML() + "\">");
            code.append("</form>");
            code.append("<script language='JavaScript'>");   
            code.append("document.getElementById('p12FormOids').submit();");
            code.append("</script>");
            code.append("</body>");
            code.append("</html>");
        } catch (XOMarshallerException xox){
            xox.printStackTrace();   
        } 
        return code.toString();   
    }
    
    
    /**
     * Obtiene el codigo html para hacer un post para la Solicitud de Justificante.
     * @param data
     * @return
     */
    public static String getHTMLJustificantePostCodeByOids(String oids,String idioma ,String url ){
        
        StringBuffer code  = new StringBuffer();
   
        try {

            
            System.out.println("Function getHTMLJustificantePostCodeByOids");
            System.out.println("===========================================");
            
           // (String oids, String idioma, String CPR, String lotes)
            
            
            RPCCall rpcCall = new RPCCall();
            RPCFunction rpcFuncion = new RPCFunction();
            rpcCall.setModule("IJ");
            rpcFuncion.setName("iniciarPago");
            rpcFuncion.putParameter(new RPCParameter("oids","String",oids));
            rpcFuncion.putParameter(new RPCParameter("idioma","String",idioma));
            rpcFuncion.putParameter(new RPCParameter("CPR","String",""));
            rpcFuncion.putParameter(new RPCParameter("lotes","String","true"));
                       
            rpcCall.addFunction(rpcFuncion);
            
            
            System.out.println("rpcCall="+rpcCall.toXML());
            
            code.append("<html>");
            code.append("<head>");            
            code.append("<meta http-equiv='Expires'content='Tue, 01 Jan 1980 1:00:00 GMT'>");
            code.append("<meta http-equiv='Pragma' content='no-cache'>");            
            code.append("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />");
            code.append("</head>");
            code.append("<body>");
            code.append("<form name='p12FormOids' id='p12FormOids' method='POST' action='" + url + "' enctype='application/x-www-form-urlencoded;charset=ISO-8859-1'> ");
            code.append("<input type='hidden' name='xmlRPC' value=\""+rpcCall.toXML()+"\"");
            code.append("<input type='hidden' name='function' value='iniciarPago'>");           
           
            code.append("</form>");
            code.append("<script language='JavaScript'>");
            code.append("document.getElementById('p12FormOids').submit();");
            code.append("</script>");
            code.append("</body>");
            code.append("</html>");
        } catch (Exception xox){
            xox.printStackTrace();   
        }
        System.out.println(code);
        return code.toString();   
    }
    
    
    /**
     * Obtiene el codigo html para crear una pagina http que redirija al cliente 
     * a la entidad financiera con los parametros necesarios, segun la version 1 de l Pasarela	
     * @param paymentDataXML Estructura XML que contiene la informacion sobre los pagos 
     * @param presentationDataXML Estructura XML que contiene informacion de presentacion
     * @param protocolDataXML Estructura XML que contiene datos de protocolo
     * @param url URL de la entidad a la que enviar los pagos
     * @return
     */
    public static String redirigirEntidadV1(String pagoXML,
            String url ){
        
        StringBuffer code  = new StringBuffer();
            
        code.append("<html>");
        code.append("<head>");
        code.append("<meta http-equiv='Expires'content='Tue, 01 Jan 1980 1:00:00 GMT'>");
        code.append("<meta http-equiv='Pragma' content='no-cache'>");        
        code.append("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />");
        code.append("</head>");
        code.append("<body>");
        code.append("<form name='pagoForm' id='pagoForm' method='post' action='" + url + "' target='_self' enctype='application/x-www-form-urlencoded;charset=ISO-8859-1'>");
        code.append("<input type='hidden' name='xmlPago' value=\"" + pagoXML + "\">");
        code.append("<input type='hidden' name='idOrigen' value='EJ'>");
        code.append("</form>");
        code.append("<script language='JavaScript'>");	
        code.append("document.getElementById('pagoForm').submit();");
        code.append("</script>");
        code.append("</body>");
        code.append("</html>");		
        
        return code.toString();   
    }
    
    /**
     * Obtiene el codigo html para crear una pagina http que redirija al cliente 
     * a la entidad financiera con los parametros necesarios, segun la version 2 de la Pasarela	
     * @param paymentDataXML Estructura XML que contiene la informacion sobre los pagos 
     * @param presentationDataXML Estructura XML que contiene informacion de presentacion
     * @param protocolDataXML Estructura XML que contiene datos de protocolo
     * @param url URL de la entidad a la que enviar los pagos
     * @return
     */
    public static String redirigirEntidadV2(String paymentDataXML,
            String presentationDataXML,
            String protocolDataXML, 
            String url ){
        
        StringBuffer code  = new StringBuffer();
            
        code.append("<html>");
        code.append("<head>");
        code.append("<meta http-equiv='Expires'content='Tue, 01 Jan 1980 1:00:00 GMT'>");
        code.append("<meta http-equiv='Pragma' content='no-cache'>");
        code.append("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />");
        code.append("</head>");
        code.append("<body>");
        code.append("<form name='pagoForm' id='pagoForm' method='post' action='" + url + "' target='_self' enctype='application/x-www-form-urlencoded;charset=ISO-8859-1'>");
        // El parametro module se indicara en la URL del banco si es necesario
        //code.append("<input type='hidden' name='module' value='EF'>");
        code.append("<input type='hidden' name='function' value='setPaymentData'>");
        code.append("<input type='hidden' name='paymentData' value=\"" + paymentDataXML + "\">");
        code.append("<input type='hidden' name='presentationData' value=\"" + presentationDataXML + "\">");
        code.append("<input type='hidden' name='protocolData' value=\"" + protocolDataXML + "\">");
        code.append("</form>");
        code.append("<script language='JavaScript'>");	        
        code.append("document.getElementById('pagoForm').submit();");
        code.append("</script>");
        code.append("</body>");
        code.append("</html>");
        
        return code.toString();   
    }
    
    public static String redirigirEntidadV2conAlert(String paymentDataXML,
            String presentationDataXML,
            String protocolDataXML, 
            String url,
            String mensaje){
        
        StringBuffer code  = new StringBuffer();
            
        code.append("<html>");
        code.append("<head>");
        code.append("<meta http-equiv='Expires'content='Tue, 01 Jan 1980 1:00:00 GMT'>");
        code.append("<meta http-equiv='Pragma' content='no-cache'>");
        code.append("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />");
        code.append("</head>");
        code.append("<body>");
        code.append("<form name='pagoForm' id='pagoForm' method='post' action='" + url + "' target='_self' enctype='application/x-www-form-urlencoded;charset=ISO-8859-1'>");
        // El parametro module se indicara en la URL del banco si es necesario
        //code.append("<input type='hidden' name='module' value='EF'>");
        code.append("<input type='hidden' name='function' value='setPaymentData'>");
        code.append("<input type='hidden' name='paymentData' value=\"" + paymentDataXML + "\">");
        code.append("<input type='hidden' name='presentationData' value=\"" + presentationDataXML + "\">");
        code.append("<input type='hidden' name='protocolData' value=\"" + protocolDataXML + "\">");
        code.append("</form>");
        code.append("<script language='JavaScript'>");          
        code.append("alert('" + mensaje + "');");
        code.append("document.getElementById('pagoForm').submit();");
        code.append("</script>");
        code.append("</body>");
        code.append("</html>");
        
        return code.toString();   
    }
    
}
