package p12f.exe.pasarelapagos.helpers;


import com.ejie.r01f.xmlproperties.XMLProperties;

import p12f.exe.pasarelapagos.security.crypto.CryptoHelperException;
import p12f.exe.pasarelapagos.security.crypto.ICryptoHelper;


/**
 * Clase de ayuda en la gestion gestion de tokens.
 * @author ie00191m
 *
 */
public class TokenHelper {
    
    
    private ICryptoHelper _cH = null ; // Instancia de Crypto para una pass concreta.
    
    
    public TokenHelper(String pwd ){        
        _cH = p12f.exe.pasarelapagos.security.crypto.DESCryptoHelper.getInstance(pwd);        
    }
        
    /**
     * Devuelve un token encriptado.
     * @param token
     * @return
     * @throws CryptoHelperException
     */
    public String getEncryptedToken(String token) throws CryptoHelperException {      
        return _cH.encrypt(token);        
    }
    
    /**
     * Devuelve un token desencriptado.
     * @param token
     * @return
     * @throws CryptoHelperException
     */
    public String getDesencryptedToken(String token) throws CryptoHelperException {    
        return _cH.decrypt(token);        
    }

    
    public static void main(String[] argv) throws Exception{
    	String token = "EmQaS20gI4t0qaIP+Q0Wl9bQiq74ED/0VFbHnygqZom5X511xk9LKQ==";
    	
    	String tokenKeyGen = XMLProperties.getProperty("p12j","crypto/keyGen");   
    	 
    	System.out.println(tokenKeyGen);
    	TokenHelper  helper = new TokenHelper(tokenKeyGen);
    	String desencriptToken = helper.getDesencryptedToken(token);
    	
    	System.out.println(desencriptToken);
    	
    }


}
