/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos del ORGManager responsanle de Entidades Emisoras o Entidades Financieras.
 */
public class AppManager implements Serializable, Initializable {

   /**
	 * DNI / NIF
	 */
	public String dni;
	/**
	 * Razn Social del tercero.
	 */
	public String  nombre;
	/**
	 * Domicilio.
	 */
	public String calle;
	/**
	 * Municipio.
	 */
	public String municipio;
	/**
	 * Territorio.
	 */
	public String territorio;
	/**
	 * Pas.
	 */
	public String pais;
	/**
	 * Cdigo Postal.
	 */
	public String codigoPostal;
	
	
	/**
	 * Primer Apellido.
	 */
	public String primerApellido;
	/**
	 * Segundo Apellido.
	 */
	public String segundoApellido;
	
	/**
	 * Cargo
	 */
	public String cargo;
	
	/**
	 *  Mail
	 */
		
	public String mail;
	
	
	/**
	 *  Telefono
	 */
		
	public String telefono;
	
	
	
	/**
	 *  Localizacin
	 */

	public String geoLocation;
	
	
	
	/**
	 * Datos Adicionales
	 */
	public List datosAdicionales;
	
	public AppManager(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ORGManager a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto ORGManager.
	 * @return Objeto ORGManager construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static AppManager getObject(String xml) throws XOMarshallerException {    
	    return (AppManager)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
    
    
	
	public static void main(String argv[]) throws XOMarshallerException {
		
		AppManager manager = new AppManager();
		
		manager.dni = "78882020T";
		manager.nombre = "Francesco";
		manager.primerApellido = "Morosini";
		manager.segundoApellido = "Peloponnesiaco";
		manager.cargo = "gonfaloniere";
		manager.municipio = "Venezia";
		manager.pais = "Italia";
		manager.calle = "Arte Di Calimala 9";
		manager.codigoPostal = "48410";
		manager.municipio = "Venecia";
		manager.mail  = "francesco.morosini@calimala.it";
		manager.telefono = "616178968";
		System.out.println(manager.toXML());
		
	}
	
		
 }
    
