package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class BackendEvent implements Serializable {
	
	/**
	 * Tipo de evento lanzado (ver tabla anterior)
	 */
	public String tipo;
	/**
	 * Momento en el que se ha lanzado el evento en la Pasarela de Pagos
	 */
	public long timeStamp;
	/**
	 * Mensajes asociados al evento
	 */
	public Map mensajes;
	/**
	 * Identificador del objeto pago al que se refiere el evento 
	 */
	public String id;
	/**
	 * Fichero en el que ha venido el resultado
	 */
	public String fileName;
	/**
	 * Operacion de SIPCA
	 */
	public String operacionSipca;
	/**
	 * Datos del pago que ha dado lugar al evento
	 */
	public DatosPago datosPago;
	
	/**
	 * Expediente (si lo hubiera)
	 * 
	 */
	public Expediente expediente;
	/**
	 * Estado del pago que ha dado lugar al evento
	 * 
	 */
	public Estado estado;
	
	public BackendEvent() {
		
	}
	
	/**
	 * Convierte un Objeto BackendEvent a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto BackendEvent.
	 * @return Objeto BackendEvent construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static BackendEvent getObject(String xml) throws XOMarshallerException {
		return (BackendEvent)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
