package p12f.exe.pasarelapagos.objects;

import java.lang.reflect.Field;
import java.util.Arrays;

import com.ejie.r01f.util.ArrayUtils;

public class BackendEventConstants {
	
	private BackendEventConstants() { }
	
	public final static String EVENT_SIMPLE = "simple";
	public final static String EVENT_GROUPED = "grouped";
	
	/* Cobros */
	public final static String PAY_OK = "onPayOK";
	public final static String PAY_NO_OK = "onPayNOK";
	/* Devoluciones */
	public final static String REFUND_OK = "onRefundOK";
	public final static String REFUND_APPROVED_OK = "onRefundApprovedOK";
	public final static String REFUND_APPROVED_NO_OK = "onRefundApprovedNOK";
	/* Ejecuciones */
	public final static String ENFORCED_OK = "onEnforcedOK";
	public final static String ENFORCED_APPROVED_OK = "onEnforcedApprovedOK";
	public final static String ENFORCED_APPROVED_NO_OK = "onEnforcedApprovedNOK";
	
	/* Estados */
	/* Cobros */
	public final static String[] STATUS_CODE_PAY_OK = {"06"};
	public final static String[] STATUS_CODE_PAY_NO_OK = {"03","04","08"};
	/* Devoluciones */
	public final static String[] STATUS_CODE_REFUND_OK = {"31"};
	public final static String[] STATUS_CODE_REFUND_APPROVED_NO_OK = {"09"};
	public final static String[] STATUS_CODE_REFUND_APPROVED_OK = {"14"};
	/* Ejecuciones */
	public final static String[] STATUS_CODE_ENFORCED_OK = {"31"};
	public final static String[] STATUS_CODE_ENFORCED_APPROVED_NO_OK = {"09"};
	public final static String[] STATUS_CODE_ENFORCED_APPROVED_OK = {"14"};
	
	/* Ficheros eventos*/
	public final static String FILE_PENDIGN = "0";
	public final static String FILE_DONE = "1";
	/* Eventos */
	public final static String EVENT_PENDIGN = "0";
	public final static String EVENT_DONE = "1";
	
	/* Usos */
	public final static String USE_GENERAL = "00";
	public final static String USE_REFUND = "01";
	public final static String USE_ENFORCE = "02";
	
	public final static String LISTENER_PARAM_MODULE = "module";
	public final static String LISTENER_PARAM_FUNCTION = "function";
	public final static String LISTENER_PARAM_TYPE_GROUP = "group";
	public final static String LISTENER_PARAM_EVENT = "backendEvent";
	public final static String LISTENER_PARAM_EVENT_LIST = "backendEventList";
	
	public static String[] getStatusCodes() {
		String[] resultado = {};
		Field[] fields = BackendEventConstants.class.getDeclaredFields();
		for (int i=0; i<fields.length; i++) {
			if (fields[i].getName().startsWith("STATUS_CODE_")) {
				try {
					String[] actStatus = (String[])fields[i].get(new Object());
					resultado = (String[])ArrayUtils.addAll(resultado, actStatus);
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				}
			}
		}
		return resultado;
	}
	public static String getComputedEvent(String status, String use) {
		if (Arrays.asList(STATUS_CODE_PAY_OK).contains(status)) {
			return PAY_OK;
		} else if (Arrays.asList(STATUS_CODE_PAY_NO_OK).contains(status)) {
			return PAY_NO_OK;
		} else if (USE_REFUND.equals(use)) {
			if (Arrays.asList(STATUS_CODE_REFUND_OK).contains(status)) {
				return REFUND_OK;
			} else if (Arrays.asList(STATUS_CODE_REFUND_APPROVED_NO_OK).contains(status)) {
				return REFUND_APPROVED_NO_OK;
			} else if (Arrays.asList(STATUS_CODE_REFUND_APPROVED_OK).contains(status)) {
				return REFUND_APPROVED_OK;
			}
		} else if (USE_ENFORCE.equals(use)) {
			if (Arrays.asList(STATUS_CODE_ENFORCED_OK).contains(status)) {
				return ENFORCED_OK;
			} else if (Arrays.asList(STATUS_CODE_ENFORCED_APPROVED_NO_OK).contains(status)) {
				return ENFORCED_APPROVED_NO_OK;
			} else if (Arrays.asList(STATUS_CODE_ENFORCED_APPROVED_OK).contains(status)) {
				return ENFORCED_APPROVED_OK;
			}
		}
		return null;
	}
	
}
