package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;


/**
 * 
 * Estructura que contiene los datos de solicitud de un procesamiento batch.
 *
 */
public class Base64Content implements Serializable, Initializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5250654110404855116L;

	/**
	 * Nombre del fichero
	 */
	public String fileName;
	
	/**
	 * Contenido del fichero codificado en Base64
	 */
	public String content;
	
	
	/******************************************/
	/* Metodos Getter / Setter   
	 * ****************************************
	 ******************************************/
	public String getContent(){		
		return content;		
	}
	
	public void setContent(String content){
		this.content = content;
	}
	
	/**
	 * Constructor sin argumentos.
	 */
	public Base64Content(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Base64Content a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Base64Content.
	 * @return Objeto Base64Content construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Base64Content getObject(String xml) throws XOMarshallerException {    
	    return (Base64Content)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}