package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import p12f.exe.pasarelapagos.paymentrequest.PeticionPago;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * 
 * Estructura que contiene los datos de solicitud de un procesamiento batch.
 *
 */
public class BatchProcessRequest implements Serializable, Initializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7930135960206169137L;

	/**
	 * Identificativo de todo el lote
	 */
	public PaymentOFFLineGenerationMetadata metadata;
	
	/**
	 * Peticin de pago
	 */
	public PeticionPago peticionPago;
	
	/**
	 * Flag que indica si el elemento actual es el ltimo del lote 
	 */
	public boolean eof;
	
	/**
	 * Nmero de pagos en el batch
	 */
	public int numeroPagos;
	
	/**
	 * Constructor sin argumentos.
	 */
	public BatchProcessRequest(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto BatchProcessRequest a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto BatchProcessRequest.
	 * @return Objeto BatchProcessRequest construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static BatchProcessRequest getObject(String xml) throws XOMarshallerException {    
	    return (BatchProcessRequest)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
