/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

import p12f.exe.pasarelapagos.exceptions.PaymentException;
import p12f.exe.pasarelapagos.paymentrequest.ConceptoPeticion;

/**
 * Estructura que contiene los datos sobre un concepto de pago.
 */
public class Concepto implements Serializable, Initializable {
    
	/**
	 * Nmero del concepto.
	 */
	public int numeroLinea;
	/**
	 * Importe individual del concepto (lnea).
	 */
	public long importe;
	/**
	 * Descripcin del concepto en diferentes idiomas.
	 */
	public Map descripcion;
	/**
	 * Cantidad de elementos iguales que componen el concepto.
	 */
	public int unidades;
	/**
	 * Flag que indica se el IVA es o no repercutido (true/false). 
	 */
	public boolean IVARepercutido = false;
	/**
	 * Flag que indica se tiene IVA repercutido (true/false). 
	 */
	public boolean tieneIVARepercutido = false;
	/**
	 * Base imponible del precio del concepto.
	 */
	public long baseImponible = 0;
	/**
	 * Importe del IVA.
	 */
	public long importeIVA = 0;
	/**
	 * Tipo del IVA.
	 */
	public long tipoIVA = 0;
	
	/**
	 * Constructor sin argumentos.
	 */
	public Concepto(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Constructor que obtiene un objeto Concpeto a partir de un objeto  Concepto Peticion de Pago.
	 * @param  peticionPago Objeto ConceptoPeticion a partir del cual se construye el objeto Concepto.
	 * @throws PaymentException
	 **/
	public Concepto (ConceptoPeticion peticionPago) throws PaymentException {
		
		Field[] fieldsThis = this.getClass().getDeclaredFields();
		Field thisField = null;
		Field otherField = null;
		try {
			for (int i = 0 ; i< fieldsThis.length ; i++){
				thisField = fieldsThis[i];
				otherField = peticionPago.getClass().getField(thisField.getName());
				Object objValue = otherField.get(peticionPago);
				otherField.set(this,objValue);				
			}
		} catch (SecurityException e) {
			e.printStackTrace();
			throw new PaymentException("Concepto (ConceptoPeticion peticionPago)::No se pueden obtener el BackEndDataMap para los Conceptos de Peticion de Pago.Revisa la configuracion de los campos");
        } catch (NoSuchFieldException e) {
			e.printStackTrace();
			throw new PaymentException("Concepto (ConceptoPeticion peticionPago).NoSuchFieldException::No se pueden obtener el BackEndDataMap para los Conceptos de Peticion de Pago.Revisa la configuracion de los campos");
		} catch (IllegalAccessException e) {
			e.printStackTrace();
			throw new PaymentException("Concepto (ConceptoPeticion peticionPago).IllegalAccessException::No se pueden obtener el BackEndDataMap para los Conceptos de Peticion de Pago.Revisa la configuracion de los campos");
		}
	}
	
	/**
	 * Convierte un Objeto Concepto a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Concepto.
	 * @return Objeto Concepto construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Concepto getObject(String xml) throws XOMarshallerException {    
	    return (Concepto)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
