/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene un dato adicional.
 */
public class DatoAdicional implements Serializable, Initializable {
	
	/**
	 * Identificacin del dato auxiliar.
	 */
	public String id;
	/**
	 * Texto del dato auxiliar en distintos idiomas.
	 */
	public Map texto;
	/**
	 * Valor del dato auxiliar.
	 */
	public String valor;
	
	public DatoAdicional(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto DatoAdicional a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto DatoAdicional.
	 * @return Objeto DatoAdicional construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static DatoAdicional getObject(String xml) throws XOMarshallerException {    
	    return (DatoAdicional)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	public static void main(String[] argv) throws XOMarshallerException{
		
		
		DatoAdicional datoAdicional = new DatoAdicional();
		datoAdicional.id = "organoExpedidor";
		datoAdicional.texto.put("es", "Direccin de Innovacin y Administracin Electrnica");
		datoAdicional.texto.put("eu", "Direccin de Innovacin y Administracin Electrnica_eu");
		
		System.out.println(datoAdicional.toXML());
	}
}
