/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos de un pago.
 */
public class DatosResolucion implements Serializable, Initializable {

	private static final long serialVersionUID = 2976048980581592195L;

	public long importe;
	
	public String motivo;
	
	public ResolutionHolder resolutionHolder;
	
	public DatosResolucion(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto DatosPago a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto DatosPago.
	 * @return Objeto DatosPago construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static DatosResolucion getObject(String xml) throws XOMarshallerException {    
	    return (DatosResolucion)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
    
   
}