/*
 * Created on 19-sep-2005
 *
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene informacion referente a la domiciliacion del pago.
 */
public class Domiciliacion implements Serializable, Initializable{

    /**
     * Permitir la domiciliacion de este pago.
     */
    public boolean permitir;

    public Domiciliacion(){
        ObjectUtils.initialize(this);
    }
    
    /**
	 * Convierte un Objeto Domiciliacion a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Domiciliacion.
	 * @return Objeto Domiciliacion construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Domiciliacion getObject(String xml) throws XOMarshallerException {    
	    return (Domiciliacion)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
