package p12f.exe.pasarelapagos.objects.ERPI;

import java.io.Serializable;
//import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos sobre un evento ERPI.
 */

public class ERPIEventContext implements Serializable, Initializable {

	public static final String ENTIDAD       = "EventEntity";
	public static final String SISTEMA       = "EventWho";
	public static final String TIPOLOGIA     = "EventTipology";
	public static final String WHAT          = "EventWhat";
	public static final String TIMESTAMP     = "EventTimeStamp";
	public static final String CORRELATIONID = "EventCorrelationId";
	public static final String TOKEN_SESION  = "TokenSesion";

	public String ns; // xmlns:ns="com/ejie/notification/xml

	// Propiedades fundamentales de un evento ERPI
	public String eventEntity;
	public String eventWho;
	public String eventTipology;
	public String eventWhat;
	public long   eventTimeStamp;
	public String eventCorrelationId;
	public String tokenSesion;

	/**
	 * Constructor sin argumentos.
	 */
	public ERPIEventContext(){
	    ObjectUtils.initialize(this);
		this.ns = XMLProperties.getProperty("p12f","configERPIEvents/xmlNamespace");
	}
		
	/**
	 * Convierte un Objeto ERPIEvent a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto ERPIEvent.
	 * @return Objeto ERPIEvent construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static ERPIEventContext getObject(String xml) throws XOMarshallerException {    
	    return (ERPIEventContext)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
