package p12f.exe.pasarelapagos.objects.ERPI;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.TextMessage;

import com.ejie.r01f.xml.marshalling.XOMarshallerException;

public class ERPIEventJMSHelper {

    public static ERPIEvent initializeFromTextMessage(Message msg) {
        
    	ERPIEvent ev = new ERPIEvent();

    	if (msg instanceof TextMessage) {
            TextMessage tm = (TextMessage)msg;
            
            try {
                ev.context = new ERPIEventContext();

                String strTimestamp = tm.getStringProperty(ERPIEventContext.TIMESTAMP);
                
                if (strTimestamp==null || strTimestamp.equalsIgnoreCase("")) strTimestamp = "0";

                ev.context.eventEntity        = tm.getStringProperty(ERPIEventContext.ENTIDAD);
                ev.context.eventWho           = tm.getStringProperty(ERPIEventContext.SISTEMA);
                ev.context.eventTipology      = tm.getStringProperty(ERPIEventContext.TIPOLOGIA);
                ev.context.eventWhat          = tm.getStringProperty(ERPIEventContext.WHAT);
                ev.context.eventTimeStamp     = Long.parseLong(strTimestamp);
                ev.context.eventCorrelationId = tm.getStringProperty(ERPIEventContext.CORRELATIONID);
                ev.context.tokenSesion        = tm.getStringProperty(ERPIEventContext.TOKEN_SESION);

                ev.notificationBody = ERPIEventNotificationBody.getObject(tm.getText().replaceFirst("<[?]{1}xml .*[?]{1}>", ""));

                //this.traza(); // TRAZA... *************************

            } catch (JMSException e) {
                e.printStackTrace();
            } catch (XOMarshallerException e) {
				e.printStackTrace();
			}
        }
        else {
        	System.out.println("*** ERROR: msg no es un TextMessage");
        }
		return ev;
    }

}
