package p12f.exe.pasarelapagos.objects.ERPI;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos sobre un evento ERPI.
 */

public class ERPIEventProperty implements Serializable, Initializable {

	// Propiedades dinmicas de un evento ERPI
	public String name;
	public String value;

	/**
	 * Constructor sin argumentos.
	 */
	public ERPIEventProperty(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Constructor
	 * @param name
	 * @param value
	 */
	public ERPIEventProperty(String name, String value){
	    ObjectUtils.initialize(this);
	    this.name  = name;
	    this.value = value;
	}
	
	/**
	 * Convierte un Objeto ERPIEvent a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto ERPIEvent.
	 * @return Objeto ERPIEvent construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static ERPIEventProperty getObject(String xml) throws XOMarshallerException {    
	    return (ERPIEventProperty)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
