/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos del emisor de un pago.
 */
public class Emisor implements Serializable, Initializable {
	
	/**
	 * Code identificativo CSB.
	 */
	public String codigo;	
	/**
	 * CIF completo del emisor.
	 */
	public String cif;
	/**
	 * Nombre del emisor en diferentes idiomas.
	 */
	public Map nombre;
	/**
	 * Domicilio.
	 */
	public String calle;
	/**
	 * Municipio.
	 */
	public String municipio;
	/**
	 * Territorio.
	 */
	public String territorio;
	/**
	 * Pas.
	 */
	public String pais;
	/**
	 * Cdigo Postal.
	 */
	public String codigoPostal;
	/**
	 * Entidad Tesorera.
	 */
	public String entidadTesorera;
	
	public Emisor(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Emisor a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Emisor.
	 * @return Objeto Emisor construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Emisor getObject(String xml) throws XOMarshallerException {    
	    return (Emisor)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
    
}
