/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos del expediente al que pertenece un pago.
 */
public class Expediente implements Serializable, Initializable {

	/**
	 * Cdigo del expediente.
	 */
	public String codigo;
	/**
	 * Familia del expediente.
	 */
	public String familia;
	/**
	 * Descripcin del expediente en diferentes idiomas.
	 */
	public Map descripcion;
	/**
	 * Datos del tercero al que hay que imputar el pago.
	 */
	public Tercero tercero;
	
	/**
	 * Datos Adicionales
	 */
	public List datosAdicionales;
	
	
	public Expediente (){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Expediente a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Expediente.
	 * @return Objeto Expediente construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Expediente getObject(String xml) throws XOMarshallerException {    
	    return (Expediente)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
