package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que encapsula una cuenta y el resultado de su validacin
 */

public class HolderCertCertifiedData implements Serializable, Initializable{
	
	/*****************************************************************
	 * Miembros ******************************************************
	 *****************************************************************/

	// Elementos
	public HolderCertData holderCertData;
	public HolderCertResponse holderCertResponse;
	
	
	/**
	 * Constructor vaco
	 */
	public HolderCertCertifiedData(){
	    ObjectUtils.initialize(this);
	}
	
	
	/**
	 * Convierte un objeto HolderCertData a XML.
	 * @return String con el XML que representa al HolderCertData
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
	
    /**
	 * Convierte un XML en un objeto HolderCertData.
	 * @return Objeto HolderCertData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static HolderCertCertifiedData getObject(String xml) throws XOMarshallerException {    
	    return (HolderCertCertifiedData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	
	// Prueba
	public static void main(String[] argv) throws XOMarshallerException {
		
		HolderCertData  holderCertData = new HolderCertData();
		holderCertData.type = HolderCertData.TYPE_ACCOUNTNUMBER;
		holderCertData.accountNumberFormat = HolderCertData.ACCOUNT_NUMBER_FORMAT_IBAN;
		holderCertData.citizenId = "78802525T";
		holderCertData.itemToCertNumber = "209444444444444444444444";
		holderCertData.encType = HolderCertData.ENC_TYPE_NONE;
		
		AditionalData aditionaData  = new AditionalData();
		aditionaData.name = "datoAdicional 1";
		aditionaData.value = "valor x";
		 
		holderCertData.aditionalDataList.put(aditionaData.name, aditionaData);
		
		HolderCertResponse  response = new HolderCertResponse();
		response.certCode = HolderCertResponse.CERTCODE_VALID; 
		response.timeStamp  = "" + System.currentTimeMillis();
		response.finantialOrgCode = "2095";
		
		HolderCertCertifiedData holderCertCertifiedData = new HolderCertCertifiedData();
		holderCertCertifiedData.holderCertData = holderCertData;
		holderCertCertifiedData.holderCertResponse = response;
		
		System.out.println(holderCertCertifiedData.toXML());
	}
	
}
