package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;

/**
 * Estructura que contiene los datos sobre un evento de Validacin de cuentas.
 */
public class HolderCertGatewayEvent implements Serializable, Initializable {
    
	/** @deprecated use {@link HolderCertConstants} */
	public static final String onInitializeHolderCert = "00";
	/** @deprecated use {@link HolderCertConstants} */
	public static final String onInitializeMultipleHolderCert = "01";
	/** @deprecated use {@link HolderCertConstants} */
	public static final String onInitializeMultipleHolderCertBatch = "02";

	/** @deprecated use {@link HolderCertConstants} */
	public static final String onSendHolderCertToFinantialORG = "03";
	/** @deprecated use {@link HolderCertConstants} */
    public static final String onSendMultipelHolderCertToFinantialORG = "04";
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSendMultipelHolderCertToFinantialORGBatch = "05";
    
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSetHolderCertResult = "06";
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSetMultipleHolderCertResult = "07";
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSetMultipleHolderCertResultBatch = "08";
    
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onError= "09";
    
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSetMultipleHolderCertPartialResult = "10";
    /** @deprecated use {@link HolderCertConstants} */
    public static final String onSetMultipleHolderCertPartialResultBatch = "11";
    	
	/**
	 * Tipo de evento lanzado (ver tabla anterior)
	 */
	public String tipo;
	
	/**
	 * Momento en el que se ha lanzado el evento en la Pasarela de Pagos
	 */
	public long timeStamp;
	
	/**
	 * Mensajes asociados al evento
	 */
	public Map mensajes;
	
	/**
	 * Identificador del objeto pago al que se refiere el evento 
	 */
	public String id;
	
	/**
	 * Datos del pago que ha dado lugar al evento;
	 */
	public Map eventData; 
	
	/**
	 * Administracin asociada al evento
	 */
	public String admin;
	
	/**
	 * Tipo de administrain asociado al evento
	 */
	public String adminType;
	
	public HolderCertGatewayEvent(){
	    ObjectUtils.initialize(this);
	    eventData = new HashMap();
	}

}