/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos de una imagen.
 */
public class Imagen implements Serializable, Initializable {

	/**
	 * Identificador de la imgen.
	 */
	public String id;
	/**
	 * Texto alternativo de la imgen.
	 */
	public Map alt;
	/**
	 * Url donde encontrar la imgen.
	 */
	public String url;
	/**
	 * Imgen en formato binario codificada en base 64;
	 */
	public String bin;
	
	public Imagen(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Imagen a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Imagen.
	 * @return Objeto Imagen construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Imagen getObject(String xml) throws XOMarshallerException {    
	    return (Imagen)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
