/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene un mensaje.
 */
public class Mensaje implements Serializable, Initializable {
	
	/**
	 * Identificador del mensaje.
	 */
	public String id;
	/**
	 * Texto del mensaje en distintos idiomas.
	 */
	public Map texto; 
	
	public Mensaje(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Mensaje a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Mensaje.
	 * @return Objeto Mensaje construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Mensaje getObject(String xml) throws XOMarshallerException {    
	    return (Mensaje)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
