package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;


/**
 * Clase que devuelve el resultado de una VALIDACIN NRC.
 * @author ie00191m
 *
 */
public class NRCValidationResponse implements Serializable, Initializable{
	
	
	public boolean isValid = false; 
	public String timeStamp = "0";
	
	public NRCValidationResponse(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Estado a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
	
    /**
	 * Convierte un XML en un objeto estado.
	 * @return Objeto Estado construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static NRCValidationResponse getObject(String xml) throws XOMarshallerException {    
	    return (NRCValidationResponse)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
