/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene datos sobre la llamada de una operacin.
 */
public class OperationData implements Serializable, Initializable {
	
	/**
	 * Mdulo llamado.
	 */
	public String module;
	/**
	 * Funcin (operacin llamada).
	 */
	public String function;
	/**
	 * Parmetros de la funcin llamada.
	 */
	public Map parameters;
	
	public OperationData(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto OperationData a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OperationData.
	 * @return Objeto OperationData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OperationData getObject(String xml) throws XOMarshallerException {    
	    return (OperationData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
