/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que encapsula el resultado de una operacion de la pasarela.
 */
public class OperationResult implements Serializable, Initializable {

	/**
	 * Resultado de la operacin.
	 */
	public Resultado resultado;
	/**
	 * Datos sobre la llamada. 
	 */
	public OperationData operationData;	
	
	
	public Map aditionalDataList;
	
    public OperationResult() {
        ObjectUtils.initialize(this);
    }
	
	/**
	 * Convierte un Objeto OperationResult a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto OperationResult.
	 * @return Objeto OperationResult construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static OperationResult getObject(String xml) throws XOMarshallerException {    
	    return (OperationResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}	
	
	public static void main(String[] argv) throws XOMarshallerException{
	
		//String xmlOperationResulb="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><operationResult><resultado><resultadoOK>true</resultadoOK><returnValue><paymentData><pagos><pago id='9050704833001800445454545456410050900000001000'><domiciliacion><permitir>false</permitir></domiciliacion><mensajes><mensaje id='1'><texto><es>El pago de esta liquidacin se acredita mediante validacin mecnica o justificante del ingreso de la Entidad Financiera colaboradora</es><eu>Kitapen honen ordainketa balioztatze mekanikoaren bitartez egiaztatzen da, edota Finantza-erakunde laguntzaileak egindako diru sarreraren ziurtagiriaren bidez</eu></texto></mensaje></mensajes><imagenes><imagen id='2'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='logoEmisor'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='1'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen></imagenes><datosPago><cpr>9050794</cpr><referencia>4454545454564</referencia><formato>507</formato><emisor>04833001-800</emisor><periodosPago><periodoPago id='periodoNormal'><fechaFin>100509</fechaFin><validarFechaFin>true</validarFechaFin><identificacion>100509</identificacion><importe>100</importe><activo>true</activo></periodoPago></periodosPago><validar>0</validar><tipo>800</tipo><codigo>9050704833001800445454545456410050900000001000</codigo></datosPago><descripcion><es>Aplicacion de Prueba</es><eu>Aplicacion de Prueba</eu></descripcion><emisor><cif>04833001</cif><nombre><es>Eusko Jaurlaritza / Gobierno Vasco</es><eu>Eusko Jaurlaritza / Gobierno Vasco</eu></nombre><territorio>ALAVA-ARABA</territorio><municipio>VITORIA-GASTEIZ</municipio><codigoPostal>01010</codigoPostal><codigo>04833001</codigo><calle>DONOSTIA-SAN SEBASTIAN, 1</calle></emisor><conceptos><concepto><numeroLinea>1</numeroLinea><baseImponible>0</baseImponible><descripcion><es>Matriculas de seminarios, congresos, jornadas y cursos</es><eu>Matriculas de seminarios, congresos, jornadas y cursos_eu</eu></descripcion><unidades>0</unidades><tieneIVARepercutido>false</tieneIVARepercutido><IVARepercutido>false</IVARepercutido><tipoIVA>0</tipoIVA><importe>116</importe><importeIVA>0</importeIVA></concepto></conceptos></pago></pagos></paymentData></returnValue><returnCode>0</returnCode></resultado><aditionalDataList><aditionalData><value><![CDATA[http://www.euskadi.ejiedes.net:8080/p12pWar/EFVentanillaServlet]]></value><description>Caja Laboral</description><name>efMobilePaymentURL_3037</name></aditionalData></aditionalDataList></operationResult>";
	    //String xmlOperationResult="<operationResult><resultado><resultadoOK>true</resultadoOK><returnValue><paymentData><pagos><pago id='9050704833001800445454545456410050900000001000'><domiciliacion><permitir>false</permitir></domiciliacion><mensajes><mensaje id='1'><texto><es>El pago de esta liquidacin se acredita mediante validacin mecnica o justificante del ingreso de la Entidad Financiera colaboradora</es><eu>Kitapen honen ordainketa balioztatze mekanikoaren bitartez egiaztatzen da, edota Finantza-erakunde laguntzaileak egindako diru sarreraren ziurtagiriaren bidez</eu></texto></mensaje></mensajes><imagenes><imagen id='2'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='logoEmisor'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='1'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen></imagenes><datosPago><cpr>9050794</cpr><referencia>4454545454564</referencia><formato>507</formato><emisor>04833001-800</emisor><periodosPago><periodoPago id='periodoNormal'><fechaFin>100509</fechaFin><validarFechaFin>true</validarFechaFin><identificacion>100509</identificacion><importe>100</importe><activo>true</activo></periodoPago></periodosPago><validar>0</validar><tipo>800</tipo><codigo>9050704833001800445454545456410050900000001000</codigo></datosPago><descripcion><es>Aplicacion de Prueba</es><eu>Aplicacion de Prueba</eu></descripcion><emisor><cif>04833001</cif><nombre><es>Eusko Jaurlaritza / Gobierno Vasco</es><eu>Eusko Jaurlaritza / Gobierno Vasco</eu></nombre><territorio>ALAVA-ARABA</territorio><municipio>VITORIA-GASTEIZ</municipio><codigoPostal>01010</codigoPostal><codigo>04833001</codigo><calle>DONOSTIA-SAN SEBASTIAN, 1</calle></emisor><conceptos><concepto><numeroLinea>1</numeroLinea><baseImponible>0</baseImponible><descripcion><es>Matriculas de seminarios, congresos, jornadas y cursos</es><eu>Matriculas de seminarios, congresos, jornadas y cursos_eu</eu></descripcion><unidades>0</unidades><tieneIVARepercutido>false</tieneIVARepercutido><IVARepercutido>false</IVARepercutido><tipoIVA>0</tipoIVA><importe>116</importe><importeIVA>0</importeIVA></concepto></conceptos></pago></pagos></paymentData></returnValue><returnCode>0</returnCode></resultado><aditionalDataList><aditionalData><value><![CDATA[http://www.euskadi.ejiedes.net:8080/p12pWar/EFVentanillaServlet        ]]></value><description>Caja Laboral</description><name>efMobilePaymentURL_3037</name></aditionalData></aditionalDataList></operationResult>";
		
	    //String xmlOperationResultc = "<operationResult><resultado><resultadoOK>true</resultadoOK><returnValue><paymentData><pagos><pago id='9050704833001800445454545456410050900000001000'><domiciliacion><permitir>false</permitir></domiciliacion><imagenes><imagen id='2'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='logoEmisor'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen><imagen id='1'><url><![CDATA[https://www.ej-gv.net/mipago/images/p72EJGVbilingueSmall.gif]]></url></imagen></imagenes><datosPago><cpr>9050794</cpr><referencia>4454545454564</referencia><formato>507</formato><emisor>04833001-800</emisor><periodosPago><periodoPago id='periodoNormal'><fechaFin>100509</fechaFin><validarFechaFin>true</validarFechaFin><identificacion>100509</identificacion><importe>100</importe><activo>true</activo></periodoPago></periodosPago><validar>0</validar><tipo>800</tipo><codigo>9050704833001800445454545456410050900000001000</codigo></datosPago><descripcion><es>Aplicacion de Prueba</es><eu>Aplicacion de Prueba</eu></descripcion><emisor><cif>04833001</cif><nombre><es>Eusko Jaurlaritza / Gobierno Vasco</es><eu>Eusko Jaurlaritza / Gobierno Vasco</eu></nombre><territorio>ALAVA-ARABA</territorio><municipio>VITORIA-GASTEIZ</municipio><codigoPostal>01010</codigoPostal><codigo>04833001</codigo><calle>DONOSTIA-SAN SEBASTIAN, 1</calle></emisor><conceptos><concepto><numeroLinea>1</numeroLinea><baseImponible>0</baseImponible><descripcion><es>Matriculas de seminarios, congresos, jornadas y cursos</es><eu>Matriculas de seminarios, congresos, jornadas y cursos_eu</eu></descripcion><unidades>0</unidades><tieneIVARepercutido>false</tieneIVARepercutido><IVARepercutido>false</IVARepercutido><tipoIVA>0</tipoIVA><importe>116</importe><importeIVA>0</importeIVA></concepto></conceptos></pago></pagos></paymentData></returnValue><returnCode>0</returnCode></resultado><aditionalDataList><aditionalData><value><![CDATA[http://www.euskadi.ejiedes.net:8080/p12pWar/EFVentanillaServlet        ]]></value><description>Caja Laboral</description><name>efMobilePaymentURL_3037</name></aditionalData></aditionalDataList></operationResult>";

	   //String xmlOperationResultd="<operationResult><resultado><resultadoOK>true</resultadoOK><returnValue><paymentData><pagos><pago id='9050704833001800445454545456410050900000001000'><domiciliacion><permitir>false</permitir></domiciliacion><datosPago><cpr>9050794</cpr><referencia>4454545454564</referencia><formato>507</formato><emisor>04833001-800</emisor><periodosPago><periodoPago id='periodoNormal'><fechaFin>100509</fechaFin><validarFechaFin>true</validarFechaFin><identificacion>100509</identificacion><importe>100</importe><activo>true</activo></periodoPago></periodosPago><validar>0</validar><tipo>800</tipo><codigo>9050704833001800445454545456410050900000001000</codigo></datosPago><descripcion><es>Aplicacion de Prueba</es><eu>Aplicacion de Prueba</eu></descripcion><emisor><cif>04833001</cif><nombre><es>Eusko Jaurlaritza / Gobierno Vasco</es><eu>Eusko Jaurlaritza / Gobierno Vasco</eu></nombre><territorio>ALAVA-ARABA</territorio><municipio>VITORIA-GASTEIZ</municipio><codigoPostal>01010</codigoPostal><codigo>04833001</codigo><calle>DONOSTIA-SAN SEBASTIAN, 1</calle></emisor><conceptos><concepto><numeroLinea>1</numeroLinea><baseImponible>0</baseImponible><descripcion><es>Matriculas de seminarios, congresos, jornadas y cursos</es><eu>Matriculas de seminarios, congresos, jornadas y cursos_eu</eu></descripcion><unidades>0</unidades><tieneIVARepercutido>false</tieneIVARepercutido><IVARepercutido>false</IVARepercutido><tipoIVA>0</tipoIVA><importe>116</importe><importeIVA>0</importeIVA></concepto></conceptos></pago></pagos></paymentData></returnValue><returnCode>0</returnCode></resultado><aditionalDataList><aditionalData><value><![CDATA[http://www.euskadi.ejiedes.net:8080/p12pWar/EFVentanillaServlet        ]]></value><description>Caja Laboral</description><name>efMobilePaymentURL_3037</name></aditionalData></aditionalDataList></operationResult>";

	   
	   String xmlOperationResultz="<operationResult>" + 
	   									"<resultado>" + 
	   										"<resultadoOK>true</resultadoOK>" + 
	   										"<returnValue>" + 
	   											"<paymentData>" + 
	   												"<pagos>" + 
	   													"<pago id='9050704833001800445454545456410050900000001000'>" + 
	   														"<domiciliacion><permitir>false</permitir></domiciliacion>" + 
	   														"<datosPago>" + 
	   															"<cpr>9050794</cpr>" + 
	   															"<referencia>4454545454564</referencia>" + 
	   															"<formato>507</formato>" + 
	   															"<emisor>04833001-800</emisor>" + 
	   															"<periodosPago>" + 
	   																"<periodoPago id='periodoNormal'><fechaFin>100509</fechaFin><validarFechaFin>true</validarFechaFin><identificacion>100509</identificacion><importe>100</importe><activo>true</activo></periodoPago>" + 
	   															"</periodosPago>" +
	   															"<validar>0</validar>" +
	   															"<tipo>800</tipo>" +
	   															"<codigo>9050704833001800445454545456410050900000001000</codigo>" +
	   														"</datosPago>" +
	   														"<descripcion>" +
	   															"<es>Aplicacion de Prueba</es>" +
	   															"<eu>Aplicacion de Prueba</eu>" +
	   														"</descripcion>" +
	   														"<emisor>" +
	   															"<cif>04833001</cif>" +
	   															"<nombre><es>Eusko Jaurlaritza / Gobierno Vasco</es><eu>Eusko Jaurlaritza / Gobierno Vasco</eu></nombre>" +
	   															"<territorio>ALAVA-ARABA</territorio><municipio>VITORIA-GASTEIZ</municipio><codigoPostal>01010</codigoPostal><codigo>04833001</codigo><calle>DONOSTIA-SAN SEBASTIAN, 1</calle>" +
	   														"</emisor>" +
	   														"<conceptos>" +
	   															"<concepto>" +
	   																"<numeroLinea>1</numeroLinea>" +
	   																"<baseImponible>0</baseImponible>" +
	   																"<descripcion>" +
	   																	"<es>Matriculas de seminarios, congresos, jornadas y cursos</es><eu>Matriculas de seminarios, congresos, jornadas y cursos_eu</eu>" +
	   																"</descripcion>" +
	   																"<unidades>0</unidades>" +
	   																"<tieneIVARepercutido>false</tieneIVARepercutido>" +
	   																"<IVARepercutido>false</IVARepercutido>" +
	   																"<tipoIVA>0</tipoIVA>" +
	   																"<importe>116</importe>" +
	   																"<importeIVA>0</importeIVA>" +
	   															"</concepto>" +
	   														"</conceptos>" +
	   													"</pago>" +
	   												"</pagos>" +
	   											"</paymentData>" +
	   										"</returnValue>" + 
	   										"<returnCode>0</returnCode>" + 
	   									"</resultado>" + 
	   								"</operationResult>";
	    
	 //  System.out.println(xmlOperationResultd);
	    
	    System.out.println(OperationResult.getObject(xmlOperationResultz));
	}
	
	
}
