/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene un parmetro de una operacin de la pasarela.
 */
public class Parameter implements Serializable, Initializable {
	
	/**
	 * Nombre del parmetro llamado.
	 */
	public String name;
	/**
	 * Valor del parmetro: puede ser cualquier tipo de
	 * datos, incluido un XML. 
	 */
	public String value;
	
	public Parameter(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Convierte un Objeto Parameter a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Parameter.
	 * @return Objeto Parameter construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Parameter getObject(String xml) throws XOMarshallerException {    
	    return (Parameter)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
