package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class PaymentOFFLineGenerationMetadata implements Serializable, Initializable {
	
	public String author;
	public String timestamp;
	public String idToken;
	public String adminOID;
	public String description;
	
	/**
	 * Datos adicionales para utilizaciones futuras.
	 */
	public Map datosAdicionales;
	
	public PaymentOFFLineGenerationMetadata(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Metadata a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Metadata.
	 * @return Objeto Metada construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static PaymentOFFLineGenerationMetadata  getObject(String xml) throws XOMarshallerException {    
	    return (PaymentOFFLineGenerationMetadata)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	public static void main( String[]  argv ) throws XOMarshallerException{
		
		PaymentOFFLineGenerationMetadata  metadata = new PaymentOFFLineGenerationMetadata();
		metadata.adminOID = "04833001";
		metadata.author  = "John Galt";
		metadata.timestamp  = "" + System.currentTimeMillis();
		metadata.idToken  = "11761761761";
		metadata.description = "Prueba";
		
		
		DatoAdicional datoAdicional = new DatoAdicional();		
		datoAdicional.id="aaa";
		datoAdicional.valor="Prueba";
		
		metadata.datosAdicionales.put("aaa", datoAdicional);
		
		System.out.println(metadata.toXML());
		
	}

}
