package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class PaymentQueryData implements Serializable, Initializable {
	
	/**
	 * NRC del pago que se quiere recuperar.
	 */
	public String nrc;
	/**
	 * CSB del pago que se quiere recuperar.
	 */
	public String csb;
	
	/**
	 * Constructor sin argumentos.
	 */
	public PaymentQueryData(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Convierte un Objeto PaymentQueryData a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto PaymentData.
	 * @return Objeto PaymentData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static PaymentQueryData getObject(String xml) throws XOMarshallerException {    
	    return (PaymentQueryData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
