/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene informacin sobre el resultado de una operacin de pago
 * en una Entidad Financiera. 
 */
public class PaymentResult implements Serializable, Initializable{

	/**
	 * Mltiples indicadores del estado de un pago (uno slo
	 * si es un pago sencillo y varios si es un pago mltiple).
	 */
	public Map paymentStateDatas;
	
    public PaymentResult() {
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto PaymentResult a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto PaymentResult.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static PaymentResult getObject(String xml) throws XOMarshallerException {    
	    return (PaymentResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
