/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Esta estructura contiene la informacin sobre el estado de un pago.
 */
public class PaymentStateData implements Serializable, Initializable {
    
	/**
	 * Identificador del pago.
	 */
	public String id;
	/**
	 * Trama en el formato correspondiente 57 / 60.
	 */
	public DatosPago datosPago;
	/**
	 * Estado del pago.
	 */
	public Estado estado;
	
	public PaymentStateData(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto PaymentStateData a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto PaymentData.
	 * @return Objeto PaymentData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static PaymentStateData getObject(String xml) throws XOMarshallerException {    

		return (PaymentStateData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
