/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Esta estructura contiene datos de presentacion en pantalla, obtencin de justificantes, etc...
 */
public class PresentationData implements Serializable, Initializable {
	
	/**
	 * Cdigo del idioma:
	 * 		es=castellano
	 * 		eu=euskera	
	 */
	public String idioma;
	/**
	 * Imgenes a mostrar en pantalla y justificante.
	 */
	public Map imagenes;
	/**
	 * Mensajes a mostrar en pantalla y justificante.
	 */
	public Map mensajes;
	
	public PresentationData(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto PresentationData a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto PresentationData.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static PresentationData getObject(String xml) throws XOMarshallerException {    
	    return (PresentationData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
