/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import p12f.exe.pasarelapagos.paymentrequest.Backend;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos de un pago.
 */
public class ResolutionHolder implements Serializable, Initializable {

	private static final long serialVersionUID = 2976048980581592195L;

	public String id;
	
	public String tipoTercero;
	
	public String resolutionHoldername;

	public String resolutionHolderAccountNumber;
	
	/**
	 * Backend data (Sipca, etc.)
	 */
	public Backend backend = null;
	
	public ResolutionHolder(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto DatosPago a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto DatosPago.
	 * @return Objeto DatosPago construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static ResolutionHolder getObject(String xml) throws XOMarshallerException {    
	    return (ResolutionHolder)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}