/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene datos sobre el resultado de una operacin de la pasarela.
 */
public class Resultado implements Serializable, Initializable  {

	/**
	 * Indica si la operacin se ha podido realizar (true/false). 
	 */
	public boolean resultadoOK;
	/**
	 * Resultado de la operacin. Puede ser cualquier valor, incluido un XML. 
	 */
	public String returnValue;
	/**
	 * Cdigo numrico del resultado de la operacin: cdigo de operacin o cdigo de error.
	 */
	public int returnCode;
	/**
	 * Mensajes acerca del proceso (errores, informacin, etc.).
	 */
	public Map mensajes;
	
	public Resultado(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Resultado a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto PaymentData.
	 * @return Objeto PaymentData construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Resultado getObject(String xml) throws XOMarshallerException {    
	    return (Resultado)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
