package p12f.exe.pasarelapagos.objects;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.log.R01FLog;
import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Objecto que encapsula la firma que envia una aplicacin departamental contra la Pasarela:
 * El uso a la fecha es en la funcionalidad de Pago en cuenta.
 * @author IOLABARO
 *
 */
public class SignedAuth implements Serializable, Initializable {
	
	public String         timeStamp;
	public SignedAuthData signedAuthContent = new SignedAuthData();
	public BaseAuthData   baseAuthContent   = new BaseAuthData();

	// DEPRECATED, mantener provisionalmente --- COMPATIBILIDAD LIBRERIAS EF
	public String signedAuthData; // pasa a ser signedAuthContent
  	public Map    signature; // no se usa
	public String document;  // pasa a baseAuthContent (documento original)
	// ----------------------------------------- COMPATIBILIDAD LIBRERIAS EF

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SignedAuth getObject(String xml) throws XOMarshallerException {    
	    return (SignedAuth)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	 
    public static String getXMLStream() throws IOException{
	
    	BufferedReader in = null;
		try {
			in = new BufferedReader(new InputStreamReader(new FileInputStream("D:///datos//SignedAuth.xml")));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	String stream = "" ; String inputLine= "";
		 while ((inputLine = in.readLine()) != null){            
		    System.out.println(inputLine);
			stream += inputLine;
		 } 
		 in.close();
		 
		 return stream;
   }
    
	
	public static void main(String[] argv) throws XOMarshallerException, IOException {
		
		SignedAuth  signed = SignedAuth.getObject( getXMLStream());
		System.out.println(signed.toXML());
		
		
	}
	
}
