/*
 * Created on 18-may-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que encapsula una URL.
 */
public class Url implements Serializable, Initializable  {

	/**
	 * Identificacin de la Url.
	 */
	public String id;
	/**
	 * Url.
	 */
	public String url;
	
	public Url(){
		ObjectUtils.initialize(this);
	}
	
	public Url(String id, String url){
		this.id = id;
		this.url = url;
	}
	
	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static Url getObject(String xml) throws XOMarshallerException {    
	    return (Url)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
