package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ValidationResult implements Serializable, Initializable{
	
	
	public ValidationResultSignedAuth validationResultSignedAuth = null;
	
	/**
	 * Resultado de la validacion.
	 */
	public boolean resultado;
	/**
	 * Datos del pago (para la consulta de un pago).
	 */
	public Pago pago;
	/**
	 * Mensajes sobre la validacin, como los errores producidos en caso de error.
	 */
	public Map mensajes;
	
	public ValidationResult(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ValidationResult a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto ValidationResult.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ValidationResult getObject(String xml) throws XOMarshallerException {    
	    return (ValidationResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
