package p12f.exe.pasarelapagos.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Objecto que encapsula la firma que envia una aplicacin departamental contra la Pasarela:
 * El uso a la fecha es en la funcionalidad de Pago en cuenta.
 * @author IOLABARO
 *
 */
public class ValidationResultSignedAuth  implements Serializable, Initializable {
	
	public String timeStamp;
	
	public String signedAuthData;
	
  	public Map    signature;

	public String document; // documento original
	                         // P.ej. "Pasarela Pagos Euskadi.net verifica la autenticidad la autorizacin de Pago."

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static ValidationResultSignedAuth getObject(String xml) throws XOMarshallerException {    
	    return (ValidationResultSignedAuth)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

}
