package p12f.exe.pasarelapagos.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class BackendEventListenerImplConfig implements Serializable {

	/**
	 * Identificador de la implementacin.
	 */
	public String id;
	
	/**
	 * Mscara que indica cuales de los mtodos de respuesta a eventos deben ser invocados.
	 */
	public String eventListenerMethodBitMap;
	/**
	 * Objeto que encapsula la informacion de configuracion del listener.
	 */
	public String eventListenerClass;
	/**
	 * Propiedades de la implementacion.
	 */
	public Map properties;
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static BackendEventListenerImplConfig getObject( String xml) throws XOMarshallerException {
		return (BackendEventListenerImplConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto BackendEventListenerImplConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
