package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos basicos e configuracion de una administracion
 */

public class BasicAdminConfig extends BaseConfigObject{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/**
     * OID de la ent-.
     */
    public String oid;
    /**
     * Claves de la Entidad Financiera para la generacin del NRC.
     */
    public Map claves;
    /**
     * Datos adicionales que pueda tener la Entidad Financiera.
     */
    public Map datosAdicionales;
    
    public BasicAdminConfig(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml: XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static BasicAdminConfig getObject( String xml) throws XOMarshallerException {
        return (BasicAdminConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto FinantialOrgConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /*
    public static void main (String[] args) throws XOMarshallerException {
    	BasicFinantialOrgConfig ej = new BasicFinantialOrgConfig();
    	ej.oid = "00001";
    	Map claves = new HashMap();
    	claves.put("clave1", "1111111111");
    	claves.put("clave2", "2222222222");
    	ej.claves = claves;
    	Map datos = new HashMap();
    	DatoAdicional dato1 = new DatoAdicional();
    	dato1.id = "dato1";
    	dato1.valor = "valor dato1";
    	DatoAdicional dato2 = new DatoAdicional();
    	dato2.id = "dato2";
    	dato2.valor = "valor dato2";
    	datos.put(dato1.id, dato1);
    	datos.put(dato2.id, dato2);
    	ej.datosAdicionales = datos;
    	
    	System.out.println(ej.toXML());
    }
    */

}
