/*
 * Created on 22-dic-2005
 *
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects.config;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que proporciona el codigo de comercio de un cliente
 * en un determinado TPV Virtual.
 */
public class CodigoComercio implements Serializable, Initializable{
    /**
     * Codigo de la entidad que proporciona el TPV Virtual.
     */
    public String entidad;
    /**
     * Codigo de comercio del emisor del pago para la entidad.
     */
    public String comercio;
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static CodigoComercio getObject( String xml) throws XOMarshallerException {
        return (CodigoComercio) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto CodigoComercio a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
}
