package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ConstraintItem extends BaseConfigObject {
	public String id;
	public String value;
	public Map descripcion;

	public ConstraintItem() {
		ObjectUtils.initialize(this);
	}

	/**
	 * Convierte de un String xml a un Objeto
	 * 
	 * @param xml
	 *            : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static ConstraintItem getObject(String xml) throws XOMarshallerException {
		return (ConstraintItem) XOManager.getObject(XMLProperties.get("p12f", "objectMapPath"), xml);
	}

	/**
	 * Convierte un Objeto ConstraintItem a XML.
	 * 
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f", "objectMapPath"), this);
	}

}
