/*
 * Created on 06-jun-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import p12f.exe.pasarelapagos.objects.AccesMethod;
import p12f.exe.pasarelapagos.objects.ORGManager;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de configuracion de una entidad financiera
 */

public class FinantialOrgConfig extends BaseConfigObject{

    /**
     * OID de la entidad financiera.
     */
    public String oid;
    /**
     * Flag que indica si la entidad financiera esta activa.
     * Por defecto, la entidad financiera esta activa.
     */
    public boolean activa = true;
    /**
     * Flag que indica si la entidad es un TPV Virtual.
     */
    public boolean TPVVirtual = false;
    /**
     * Orden de presentacion en la lista de entidades financieras.
     */
    public int orden;
    /**
     * Descripcion de la entidad finaciera.
     */
    public Map descripcion;
    /**
     * Imagenes de la entidad financiera.
     */
    public Map imagenes;	
    /**
     * URLs de la entidad financiera.
     */
    public Map urls;	
    /**
     * Caracteristicas de los pagos posibles en esta entidad financiera.
     */
    public Map caracteristicas;
    /**
     * Versin de la pasarela sobre la que trabajan las entidades financieras.
     */
    public String paymentGatewayVersion;
    /**
     * Claves de la Entidad Financiera para la generacin del NRC.
     */
    public Map claves;
    
    
    /**
     * Informacion sobre el manager de la organizacion.
     */
    
    public ORGManager orgManager;
    
    
    /**
     * Informacion sobre la forma de acceso a los usaurios de este este objeto.
     */
    
    public AccesMethod accesMethod;
    
    
    /**
     * Datos relativos al ConstraintList.
     */
    public ConstraintList constraintList=null;
    
    
    public FinantialOrgConfig(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml: XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static FinantialOrgConfig getObject( String xml) throws XOMarshallerException {
        return (FinantialOrgConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto FinantialOrgConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    

}
