package p12f.exe.pasarelapagos.objects.config;

import java.util.List;
import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class HolderCertAplicationBatchConfig extends BaseConfigObject {

	/**
	 * OID del tipo de la aplicacin.
	 */
	public String codigo;
	/**
	 * Flag que indica si la aplicacin esta activa.
	 * Por defecto, la aplicacin esta activa.
	 */
	public boolean activa = true;
	/**
	 * Descripcion de la aplicacin.
	 */
	public Map descripcion;
	/**
	 * Datos Adicionales
	 */
	public List datosAdicionales;
	
	
	public HolderCertAplicationBatchConfig(){
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto HolderCertAplicationBatchConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml: XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static HolderCertAplicationBatchConfig getObject( String xml) throws XOMarshallerException {
		return (HolderCertAplicationBatchConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
}
