package p12f.exe.pasarelapagos.objects.config;

import java.io.Serializable;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.Imagen;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class HolderCertAplicationConfig implements Serializable, Initializable {

	/**
	 * Codigo de la aplicacion
	 */
	public String codigo;
	/**
	 * Nombre de la aplicacion
	 */
	public Map nombre;
	/**
	 * Persona responsable de la aplicacion
	 */
	public String responsable;
	/**
	 * Logo de la aplicacion
	 */
	public Imagen imagen;
	/**
	 * Objeto que encapsula la informacion de configuracion del listener de los eventos de validacin.
	 */
	public HolderCertEventsConfig eventListenerConfig;
	/**
	 * Mapa que almacena un conjunto de datos adicionales.
	 */
	public Map datosAdicionales;
	
	/** Constructores */
	public HolderCertAplicationConfig() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static HolderCertAplicationConfig getObject( String xml) throws XOMarshallerException {
		return (HolderCertAplicationConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto HolderCertAplicationConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
