package p12f.exe.pasarelapagos.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class HolderCertEventListenerConfig implements Serializable, Initializable{
	
	/**
	 * Identificador del evento.
	 */
	public String id;
	/**
	 * Url del evento.
	 */
	public String url;
	/**
	 * Indicador de si la url es o no interna a la red.
	 */
	public Boolean isInternal;
	/**
	 * Objeto que encapsula la informacion de configuracion del listener.
	 */
	public String eventListenerClass;
	/**
	 * Propiedades de la implementacion
	 */
	public Map properties;
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static EventListenerConfig getObject( String xml) throws XOMarshallerException {
		return (EventListenerConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto GatewayEventListenerConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
