package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class HolderCertEventsConfig extends BaseConfigObject {
	
	public static final String DEFAULT = "default";
	public static final String SIMPLE = "simple";
	public static final String MULTIPLE = "multiple";
	public static final String BATCH = "batch";
	
	/**
	 * Mscara que indica cuales de los mtodos de respuesta a eventos deben ser invocados.
	 */
	public String eventListenerMethodBitMap = null;
	/**
	 * Configuracin de cada evento.
	 */
	public Map eventListenerConfigMap = null;
	/**
	 * Variable que indica si los resultados mltiples que se enven en los 
	 * eventos van zipeados o no.
	 */
	public boolean sendEventsZipped = true;
	/**
	 * Indicador de si hay que enviar o no los datos adicionales enviados desde la EEFF
	 * asociados a un resultado de validacin.
	 */
	public boolean sendAditionalHolderData = false;
	/**
	 * Indicador de si hay que enviar o no las restricciones enviadas desde la EEFF
	 * asociados a un resultado de validacin.
	 */
	public boolean sendAccountConstraintList = false;
	
	public HolderCertEventsConfig(){
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto HolderCertEventsConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml: XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static HolderCertEventsConfig getObject( String xml) throws XOMarshallerException {
		return (HolderCertEventsConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
}
