
package p12f.exe.pasarelapagos.objects.config;


import java.util.List;
import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de confuracin del sufijo de validacin.
 */

public class HolderCertTypeConfig extends BaseConfigObject {
	
	/**
	 * OID de la configuracin del sufijo de validacin.
	 */
	public String oid;
	/**
	 * Flag que indica si el sufijo de validacin est activo.
	 */
	public boolean activa = true;
	/**
	 * Oid del emisor.
	 */
	public String emisor;
	/**
	 * Formato del sufijo.
	 */
	public String tipo;
	/**
	 * Descripcion.
	 */
	public Map descripcion;
	
	/**
	 * Mensajes auxiliares.
	 */
	public Map mensajes;
	/**
	 * Datos relativos a la aplicacion.
	 */
	public HolderCertAplicationConfig aplicacion;
	/**
	 * Datos Adicionales
	 */
	public List datosAdicionales;
	
	
	public HolderCertTypeConfig(){
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto PaymentTypeConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml: XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static HolderCertTypeConfig getObject( String xml) throws XOMarshallerException {
		return (HolderCertTypeConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
}
