/*
 * Created on 06-jun-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de configuracion de una instancia de la pasarela.
 */

public class InstanceConfig extends BaseConfigObject {

    /**
     * OID de la instancia.
     */
    public String oid;
    /**
     * Flag que indica si la instancia esta activa.
     * Por defecto, la instancia est activa.
     */
    public boolean activa = true;
    /**
     * Flag que indica si esta es la instancia por defecto.
     * Por defecto, la instancia no es la instancia por defecto
     */
    public boolean esInstanciaPorDefecto = false;
    /**
     * Descripcin de la instancia.
     */
    public Map descripcion;
    /**
     * Idioma por defecto de la instancia.
     */
    public String idioma;
    /**
     * Mapa de imagenes de la instancia.
     */
    public Map imagenes;            
    /**
     * Tipo de letra de la instancia.
     */
    public String tipoLetra;     
    /**
     * Colores de la instancia
     */
    public Map colores;        
    /**
     * URLs de la instancia.
     */
    public Map urls;
    /**
     * Path de la cabecera.
     */
    public Map headerPath;         
    /**
     * Path del pie de pgina.
     */
    public Map footerPath;  
    /**
     * Entidades financieras admitidas por la instancia.
     */
    public Map finantialOrgs;
    /**
     * Modos de pago que admiten los pagos de las entidades de esta instancia.
     */
    public Map paymentModes;
    /**
     * Administraciones admitidas por la instancia.
     * Esta informacin no se incluye en el XML.
     */
    public Map admins;

    public InstanceConfig(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml: XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static InstanceConfig getObject( String xml) throws XOMarshallerException {
        return (InstanceConfig) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto InstanceConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    


}