/*
 * Created on 30-aug-2007
 * @author co01347e
 */

package p12f.exe.pasarelapagos.objects.config;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de configuracin de un Uso de los tipos de pago
 */
public class PaymentUse implements Serializable, Initializable{

	/**
     * Administracion.
     */
    public String admin; 
    /**
     * Tipo.
     */
    public String tipo; 
    /**
     * Formato.
     */
    public String format; 
    /**
     * Uso.
     */
    public String use;       	
	        
    public PaymentUse(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static PaymentUse getObject( String xml) throws XOMarshallerException {
        return (PaymentUse)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto PaymentUse a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
}
