/*
 * Created on 29-aug-2007
 * @author co01347e
 */

package p12f.exe.pasarelapagos.objects.config;

import java.util.Map;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de configuracin de un Uso de los tipos de pago
 */
public class UseConfig extends BaseConfigObject {

	// Identificadores de los usos:
	public static final String USO_TASA = "00";

    /**
     * OID del uso.
     */
    public String oid;       	
    /**
     * Descripcion de la Administracin.
     */
    public Map descripcion;
	        
    public UseConfig(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static UseConfig getObject( String xml) throws XOMarshallerException {
        return (UseConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto UseConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
}



