package p12f.exe.pasarelapagos.objects.data;

import java.io.Serializable;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Clase que encapsula las respuestas del API de ficheros.
 * @author dbenitof
 */
public class DataFileResponse implements Serializable {
	
	private String response;
	
	private int responseCode;
	
	public DataFileResponse() {
		
	}

	/**
	 * @return the response
	 */
	public String getResponse() {
		return response;
	}

	/**
	 * @param response the response to set
	 */
	public void setResponse(String response) {
		this.response = response;
	}

	/**
	 * @return the responseCode
	 */
	public int getResponseCode() {
		return responseCode;
	}

	/**
	 * @param responseCode the responseCode to set
	 */
	public void setResponseCode(int responseCode) {
		this.responseCode = responseCode;
	}
	
	/**
	 * Convierte un Objeto DataFileResponse a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto DataFileResponse.
	 * @return Objeto DataFile construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static DataFileResponse getObject(String xml) throws XOMarshallerException {
		return (DataFileResponse)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
