package p12f.exe.pasarelapagos.objects.mail;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class MailMessage implements Serializable, Initializable {

	private static final long serialVersionUID = 1L;
	public String from;                   // Sujeto que envia
	public List to;                      //  Destinatarios
	public List toCC;                    //  Copia
	public List toCCO;                  //   Copia Oculta
	public String subject;              //   Asunto
	public String messageContentType;   //   ContentType
	public String messageText;			//   Mensaje de Texto
	public List attachListFileNames;    //   Ruta temp. de los ficheros a atachar.
	public Boolean deleteAttachFiles;   //   Borrar ficheros temporales.

	public MailMessage(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static MailMessage getObject(String xml) throws XOMarshallerException {    
	    return (MailMessage)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
