package p12f.exe.pasarelapagos.objects.mail;


import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class MailReceiverResult implements Serializable, Initializable {

	private static final long serialVersionUID = 2888027333434071015L;
	
	public List receiverID;      // Mail ID (francesco@morossini.it)
	public Boolean result;         // RESULTADO (OK/ERROR)
	public String errorMessage;   //  MENSAJE_ERROR ("Etc...")

	public MailReceiverResult(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static MailReceiverResult getObject(String xml) throws XOMarshallerException {    
	    return (MailReceiverResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
