package p12f.exe.pasarelapagos.objects.mail;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class MailRequest implements Serializable, Initializable {

	private static final long serialVersionUID = 5008275145093599813L;
	
	public List mailMessageList;
	
	public MailRequest(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Aade un mensaje SMS a la lista de mensajes de esta peticin
	 * @param sms
	 * @return
	 */
	public boolean addMessageToRequestList(MailMessage mailMessage) {
		this.mailMessageList.add(mailMessage);
		return true;
	}


	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static MailRequest getObject(String xml) throws XOMarshallerException {    
	    return (MailRequest)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	
	
	public static void main(String[] argv) throws XOMarshallerException {
		
		MailRequest request  = new MailRequest();
		
		MailMessage mailMessage  = new MailMessage();
		
		mailMessage.from = "mipago@euskadi.net";
		mailMessage.to.add("iker.olabarria@gmail.com");
		mailMessage.messageContentType = "text/plain";
		mailMessage.subject = "Pasarela de Pagos";
		mailMessage.messageText = "Esto es el texto";
		
		
		request.addMessageToRequestList(mailMessage);
		
		System.out.println(request.toXML());
		MailRequest.getObject("<mailRequest><mailMessageList><mailMessage from='mipagoeuskadi.net'><to><listElement>iker.olabarriagmail.com</listElement></to><messageText><![CDATA[Esto es el texto]]></messageText><messageContentType><![CDATA[text/plain]]></messageContentType><subject><![CDATA[Pasarela de Pagos]]></subject></mailMessage></mailMessageList></mailRequest>");
		
	}
}