package p12f.exe.pasarelapagos.objects.mail;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class MailResult implements Serializable {

	private static final long serialVersionUID = -6126177897517912483L;
	
	public List mailReciverResultList;	

	public MailResult(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Aade el resultado de un mensaje SMS
	 * @param smsResult
	 * @return
	 */
	public boolean addMessageResult(MailReceiverResult mailResult) {
		this.mailReciverResultList.add(mailResult);
		return true;
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static MailResult getObject(String xml) throws XOMarshallerException {    
	    return (MailResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
}