package p12f.exe.pasarelapagos.objects.security;

import java.io.Serializable;

import p12f.exe.pasarelapagos.objects.Base64Content;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class SecurityContext implements Serializable, Initializable {
	
	private static final long serialVersionUID = 1L;
	public static final String CUSTOM = "custom";
	public static final String XLNETS =  "xlnets";
	public static final String CTX_TYPE = "ctxType";
	
	// Variables
	public String type;
	public String appClientID;
	public String appClientSessionID;
	public String timestamp;
	public String serviceName;
	public Base64Content  tokenData;
	
	
	// Mtodos 
	public String getAppClientID() {
		return appClientID ;
	}
	
	public void setAppClientID(String appID) {
		 appClientID  = appID;
	}
	
	public String getServiceName() {
		return serviceName;
	}
	
	public void setServiceName(String srv) {
		 serviceName = srv;
	}
	
	public String getAppClientSessionID() {
		return appClientSessionID ;
	}
	
	public void setAppClientSessionID(String appSessionID) {
		 appClientSessionID  =  appSessionID;
	}
	
	public String getTimestamp() {
		return timestamp ;
	}
	
	public void setTimestamp(String tst) {
		timestamp = tst;
	}
	
	public Base64Content getTokenData() {
		return tokenData;
	}
	
	public void setType(String tp) {
		type = tp;
	}
	
	public String getType() {
		return type;
	}
	
	public void setTokenData(Base64Content tk) {
		tokenData = tk;
	}
	
	/**
	 * Convierte un Objeto Estado a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto estado.
	 * @return Objeto Estado construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SecurityContext getObject(String xml) throws XOMarshallerException {
		return (SecurityContext)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
