package p12f.exe.pasarelapagos.objects.sms;

import java.io.Serializable;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class SMSMessage implements Serializable {

	private static final long serialVersionUID = 3707683691743824854L;

	public String acuse;          // ACUSE (S/N)
	public String timeStamp;      // TS_DIFERIDO
	public String expireTime;     // TS_EXPIRE
	public String messageContent; // TEXTO
	public String receiverNumber; // GSM_DEST ("600123456,600987654") mx. 150 nmeros por mensaje

	public SMSMessage(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SMSMessage getObject(String xml) throws XOMarshallerException {    
	    return (SMSMessage)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}