package p12f.exe.pasarelapagos.objects.sms;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class SMSMessageList implements Serializable {
	
	private static final long serialVersionUID = -8328777541718912592L;
	
	public List smsMessageList;

	public SMSMessageList(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Aade un mensaje SMS a la lista de mensajes
	 * @param sms
	 * @return
	 */
	public boolean addMessage(SMSMessage sms) {
		this.smsMessageList.add(sms);
		return true;
	}

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SMSMessageList getObject(String xml) throws XOMarshallerException {    
	    return (SMSMessageList)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}