package p12f.exe.pasarelapagos.objects.sms;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class SMSMessageResult implements Serializable {

	private static final long serialVersionUID = -215975695978778554L;
	
	public String messageResultId;
	public List smsMessageReceiverResultList;

	public SMSMessageResult(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Aade el resultado de un mensaje SMS para un nmero de telfono a la
	 * lista de resultados del SMS (para cada nmero de telfono al que va
	 * dirigido un SMS habr un resultado.
	 * @param receiverResult
	 * @return
	 */
	public boolean addMessageReceiverResult(SMSMessageReceiverResult receiverResult) {
		this.smsMessageReceiverResultList.add(receiverResult);
		return true;
	}

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SMSMessageResult getObject(String xml) throws XOMarshallerException {    
		return (SMSMessageResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}