package p12f.exe.pasarelapagos.objects.sms;

import java.io.Serializable;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class SMSRequest implements Serializable {

	private static final long serialVersionUID = 5008275145093599813L;
	
	public SMSMessageList smsRequestMessageList;
	//public List smsMessageResultList;

	public SMSRequest(){
	    ObjectUtils.initialize(this);
	}

	/**
	 * Aade un mensaje SMS a la lista de mensajes de esta peticin
	 * @param sms
	 * @return
	 */
	public boolean addMessageToRequestMessageList(SMSMessage sms) {
		this.smsRequestMessageList.addMessage(sms);
		return true;
	}

	/**
	 * Aade el resultado de un mensaje SMS
	 * @param smsResult
	 * @return
	 */
	/*public boolean addResultToMessageResultList(SMSMessageResult smsResult) {
		this.smsMessageResultList.add(smsResult);
		return true;
	}*/

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static SMSRequest getObject(String xml) throws XOMarshallerException {    
	    return (SMSRequest)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}