/**
 * 
 * @author FMARTINI
 *
 */
package p12f.exe.pasarelapagos.objects.sms.latinia;

import java.io.Serializable;
import java.util.List;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class LatiniaMessageList implements Serializable, Initializable {
	public List smsMessageList;

	public LatiniaMessageList(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Aade un mensaje SMS a la lista de mensajes
	 * @param sms
	 * @return
	 */
	public boolean addMessage(LatiniaMessage sms) {
		this.smsMessageList.add(sms);
		return true;
	}

	/**
	 * Convierte un Objeto Url a XML.
	 * @return String que contiene el XML.
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto Url.
	 * @return Objeto Url construido a partir del XML.
	 * @throws XOMarshallerException
	 */
	public static LatiniaMessageList getObject(String xml) throws XOMarshallerException {    
	    return (LatiniaMessageList)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

	public static void main(String[] args) {
		/*
		SMSMessageList smsList = new SMSMessageList();

		SMSMessage sms = new SMSMessage();
		sms.acuse          = "N";
		sms.receiverNumber = "600123456";
		sms.messageContent = "Hola mundo...";
		sms.expireTime     = "30";

		//smsList.smsMessageList.add(sms);
		smsList.addMessage(sms);

		try {
			String strXML = "<MENSAJE_INFO ACUSE=\"S\"><TS_DIFERIDO>620000000</TS_DIFERIDO><TEXTO><![CDATA[Hola mundo SMS]]></TEXTO><GSM_DEST>659000001,666000001</GSM_DEST></MENSAJE_INFO>";
			SMSMessage sms1 = SMSMessage.getObject(strXML);
			smsList.addMessage(sms1);

			//System.out.println("XML(0): " + sms.toXML());
			//System.out.println("XML(1): " + sms1.toXML());
			System.out.println("XML lista mensajes: " + smsList.toXML());

		} catch (XOMarshallerException e) {
			e.printStackTrace();
		}
		*/
	}

}
