package p12f.exe.pasarelapagos.objects.users.mail;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.Serializable;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.users.P12FUsersListRequest;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class P12FMailRequest implements Serializable {

	public P12FUsersListRequest usersList;
	public String subject;
	public String body;
	public String mailTemplate;
	public Map parameters;
	
	public P12FMailRequest() {
		ObjectUtils.initialize(this);
	}

	public static P12FMailRequest getObject(String xml) throws XOMarshallerException {
		String mapFileName = XMLProperties.get("p12f", "objectMapPath");
		P12FMailRequest mailRequest = (P12FMailRequest)XOManager.getObject(mapFileName, xml);
		return mailRequest;
	}     

	public String toXML() throws XOMarshallerException {
		String mapFileName = XMLProperties.get("p12f", "objectMapPath");
		return XOManager.getXML(mapFileName, this);        	
	}
	
	public  String getMessageFromFile()throws Exception {

		System.out.println("==============================");
	    System.out.println("    getMessageFromFile		   ");
		System.out.println("==============================");
		String htmlText = "";
		FileInputStream  fis = new FileInputStream(this.mailTemplate);

		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String inputLine=null;
		while ((inputLine = in.readLine()) != null)
		htmlText += inputLine;
		in.close();
		return htmlText;    	
	}


	public  String replaceVariableValues(String inStr,String varDelim,Map varValues) {
		StringBuffer outBuff = new StringBuffer("");
        
        // Ir buscando las variables
        int p1 = 0;
        int v1 = -1;
        int v2 = -1;
        String varName = null;
        String varValue = null;
        boolean substitution = false;
        
        do {
            substitution = false;
            v1 = inStr.indexOf(varDelim,p1);
            if (v1 >= 0) v2 = inStr.indexOf(varDelim,v1+1);
            if (v2 > v1) {
                outBuff.append( inStr.substring(p1,v1) );       // Aadir el texto anterior a la variable
                varName = inStr.substring(v1+1,v2);
                if (varName.length() > 0) {
                    varValue = (String)varValues.get(varName);
                    if (varValue == null) {
                        outBuff.append( "null" );
                    } else {
                        outBuff.append( varValue );
                    }
                } else if (varName.length() == 0) {
                    outBuff.append(varDelim + varDelim);
                }
                p1 = v2 + 1;
                v1 = -1;
                v2 = -1;
                substitution = true;
            }
        } while (substitution);
        // Aadir el resto de la cadena
        if (p1 < inStr.length()) outBuff.append( inStr.substring(p1) );
        return outBuff.toString();
    }
	
}
