/*
 * Created on Mar 1, 2007
 * 
 * @author co01347e - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.pasarelapagos.objects.validation;

import p12f.exe.pasarelapagos.paymentrequest.PeticionPago;
import p12f.exe.pasarelapagos.paymentrequest.Validacion;

import com.ejie.r01f.log.R01FLog;
import com.ejie.r01f.xmlproperties.XMLLiterals;

/**
 * TODO Define the type
 */
public class ValidationHelper {
    
    public static XMLLiterals xmlLiterals = new XMLLiterals("p12f","es"); 
    
    /**
     * Clase que contiene un metodo de llamada a la validacion de una peticion de pago,
     * devolviendo un objeto Validacion en caso de error.
     * @param peticionPago
     * @return
     */
    public static boolean validatePeticionPago(PeticionPago peticionPago) {
                
        String error_validacion = peticionPago.validate();
        
        if (error_validacion!=null) { 
        	
        
            R01FLog.to("p12f.validation").finest("!!!!!! ERROR VALIDACION: " + error_validacion+ "!!!!!!!!");            
            Validacion validacion = new Validacion();
            validacion.valido = false;
            validacion.codigoError = error_validacion;                      
            // Enviar mensaje de informacion del error de validacion
            validacion.mensaje = xmlLiterals.get("validacion/" + validacion.codigoError);
            peticionPago.validacion = validacion;            
            return false;
        } 
        
        // Se pone este objeto a null para que no se parsee cuando la validacion va bien
        return true;
    }

}
