package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.AppManager;
import p12f.exe.pasarelapagos.objects.Imagen;
import p12f.exe.pasarelapagos.objects.config.BackendEventListenerConfig;
import p12f.exe.pasarelapagos.objects.config.EventListenerConfig;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Datos de una aplicacin departamental que se pasan a la pasarela de pagos
 */
public class Aplicacion implements Serializable, Initializable {
	
	/**
	 * Codigo de la aplicacion
	 */
	public String codigo;
	/**
	 * Nombre de la aplicacion
	 */
	public Map nombre;
	/**
	 * Persona responsable de la aplicacion
	 */
	public String responsable;
	/**
	 * Logo de la aplicacion
	 */
	public Imagen imagen;
	/**
	 * Objeto que encapsula la informacion de configuracion del listener de los eventos de la pasarela.
	 */
	public EventListenerConfig eventListenerConfig;
	/**
	 * Objeto que encapsula la informacion de configuracion del listener de los eventos de backend de la pasarela.
	 */
	public BackendEventListenerConfig backendEventListenerConfig;
	/**
	 * Mapa que almacena un conjunto de datos adicionales.
	 */
	public Map datosAdicionales;
	
	public Boolean isInternal = null;
	
	
	public AppManager appManger = null;
	
	/** Constructores */
	public Aplicacion() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static Aplicacion getObject( String xml) throws XOMarshallerException {
		return (Aplicacion) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto Aplicacion a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	public static void main (String[] args) throws XOMarshallerException {
		Aplicacion app = new Aplicacion();
		app.isInternal = new Boolean(true);
		EventListenerConfig conf = new EventListenerConfig();
		conf.eventListenerMethodBitMap = "00000011100";
		conf.eventListenerClass = "p12g.exe.pasarelapagos.holdercert.events.HolderCertHTTPServletGatewayEventListenerImpl";
		conf.properties = new HashMap();
		conf.properties.put("urlClient", "http://wl8vf0037.ejgvdns:7001/p12dWar/HolderCertGatewayEventListenerServlet");
		app.eventListenerConfig = conf;
		System.out.println(app.toXML());
	}
	
}
