/*
 * Created on 15-jun-2005
 * @author co00414a
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Objeto Backend que representa un sistema final concreto, por ejemplo SIPCA, 
 * y la coleccin de datos requeridos para ese backEnd.
 */
public class Backend implements Serializable, Initializable{
	
	public String systemID;				// Identificativo Backend (pe: SIPCA, SIPCAForal, etc...)
	public Map backendDataMap;			// Map con los valores del Backend.
	public boolean enabled;				// Indica si est activado
	
	public Backend(){
		ObjectUtils.initialize(this);
	}	
	
	/**
	 * Inserta un BackendData
	 * @param be
	 */
	public void put (BackendData be ){
		backendDataMap.put(be.id,be);
	}
	
	/**
	 * Obtiene un BackendData
	 * @param be
	 */
	public BackendData get (String beID ){
		return (BackendData) backendDataMap.get(beID);
	}

	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static Backend getObject( String xml) throws XOMarshallerException {
		return (Backend) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto Backend a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
