/*
 * Created on 08-jun-2005
 * @author co00414a
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene un dato de BackEnd
 */
public class BackendData implements Serializable, Initializable{
	
	public String id;			// Descripcion del atributo backend en diferentes idiomas.
	public String value;		// Value del atributte backend. Quizas pudiera implementarse un BackendDataVO
	
	// Constantes con los nombres de los campos BackendData
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String SIPCA = "SIPCA";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String GASTO_GV = "gastoGV";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String EXENTO_PAGO = "exentoPago";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String EJERCICIO_CONTABLE = "ejercicioContable";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String FECHA_OPERACION = "fechaOperacion";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String INFORMAR_SIPCA = "informarSIPCA";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String MODO_PAGO = "modoPago";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String NUMERO_REFERENCIA_ANTERIOR = "numeroReferenciaAnterior";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String NUMERO_REFERENCIA_DEPOSITO = "numeroReferenciaDeposito";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String EXPEDIENTE_ASOCIADO = "expedienteAsociado";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String NUMERO_AUTORIZACION_TPV = "numeroAutorizacionTPV";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CODIGO_INGRESO = "codigoIngreso";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String APLICACION_PRESUPUESTARIA = "aplicPresupuestaria";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String NUMERO_INMOVILIZADO = "numeroInmovilizado";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String TERRITORIO_IVA = "territorioIVA";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CONCEPTO_IVA = "conceptoIVA";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CUENTA_DOMICILIACION = "cuentaDomiciliacion";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CUENTA_PCP = "cuentaPCP";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String TIPO_COBRO = "tipoCobro";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String MOTIVO = "motivo";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CODIGO_ANULACION = "codigoAnulacion";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CODIGO_RECHAZO = "codigoRechazo";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String MOTIVO_RECHAZO = "motivoRechazo";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String DIGITO_CONTROL = "digitoControl";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String FECHA_LIMITE = "fechaLimitePago";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String IMPORTE = "importe";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String CODIGO_APLICACION = "codigoAplicacion";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String ENTIDAD_EMISORA = "entidadEmisora";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String SUFIJO = "sufijo";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String NUMERO_REFERENCIA = "numeroReferencia";
	/**
	 * @deprecated
	 * @see BackendDataConstants
	 */
	public static final String TIPO_OPERACION = "tipoOperacion";
	
	public BackendData(){
		ObjectUtils.initialize(this);
	}
	
	public BackendData(String id, String value){
		this.value = value;
		this.id = id;
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static BackendData getObject( String xml) throws XOMarshallerException {
		return (BackendData) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto BackendData a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
