package p12f.exe.pasarelapagos.paymentrequest;

/**
 * Constantes para el backend de Sipca.
 */
public class BackendDataConstants {
	
	/**
	 * Constructor privado para evitar que se instancie
	 */
	private BackendDataConstants() {
		
	}
	
	// Constantes con los nombres de los campos BackendData
	public static final String SIPCA = "SIPCA";
	public static final String GASTO_GV = "gastoGV";
	public static final String EXENTO_PAGO = "exentoPago";
	public static final String EJERCICIO_CONTABLE = "ejercicioContable";
	public static final String FECHA_OPERACION = "fechaOperacion";
	//public static final String ENTIDAD_SIPCA = "entidadSIPCA";
	public static final String INFORMAR_SIPCA = "informarSIPCA";
	public static final String MODO_PAGO = "modoPago";
	public static final String NUMERO_REFERENCIA_ANTERIOR = "numeroReferenciaAnterior";
	public static final String NUMERO_REFERENCIA_DEPOSITO = "numeroReferenciaDeposito";
	public static final String EXPEDIENTE_ASOCIADO = "expedienteAsociado";
	public static final String NUMERO_AUTORIZACION_TPV = "numeroAutorizacionTPV";
	public static final String CODIGO_INGRESO = "codigoIngreso";
	public static final String APLICACION_PRESUPUESTARIA = "aplicPresupuestaria";
	public static final String APLICACION_PRESUPUESTARIA_DEVOLUCION = "aplicPresupuestariaDevolucion";
	public static final String NUMERO_INMOVILIZADO = "numeroInmovilizado";
	public static final String TERRITORIO_IVA = "territorioIVA";
	public static final String CONCEPTO_IVA = "conceptoIVA";
	public static final String CUENTA_DOMICILIACION = "cuentaDomiciliacion";
	public static final String CUENTA_PCP = "cuentaPCP";
	public static final String TIPO_COBRO = "tipoCobro";
	public static final String MOTIVO = "motivo";
	public static final String MOTIVO_DEVOLUCION = "motivoDevolucion";
	public static final String CODIGO_ANULACION = "codigoAnulacion";
	public static final String CODIGO_RECHAZO = "codigoRechazo";
	public static final String MOTIVO_RECHAZO = "motivoRechazo";
	public static final String DIGITO_CONTROL = "digitoControl";
	public static final String FECHA_LIMITE = "fechaLimitePago";
	public static final String IMPORTE = "importe";
	public static final String CODIGO_APLICACION = "codigoAplicacion";
	public static final String ENTIDAD_EMISORA = "entidadEmisora";
	public static final String SUFIJO = "sufijo";
	public static final String NUMERO_REFERENCIA = "numeroReferencia";
	public static final String TIPO_OPERACION = "tipoOperacion";
	public static final String TERCERO_TIPO = "terceroTipo";		// No se usa, ya est en los datos del tercero
	public static final String TERCERO_CODIGO = "terceroCodigo";	// No se usa, ya est en los datos del tercero
	public static final String TERCERO_VERSION = "terceroVersion";	// Versin del tercero en IKUS
	public static final String TERCERO_NOMBRE = "terceroNombre";	// Nombre o razn social del tercero
	public static final String TERCERO_CUENTA = "terceroCuenta";	// Nmero de cuenta del tercero
	public static final String TERCERO_IKUS = "terceroIkus";
}
