/*
 * Created on 13-jun-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos de una entidad financiera.
 */
public class FinantialOrg implements Serializable, Initializable {
    
    /**
     * Oid de la entidad financiera.
     */
    public String oid;
    /**
     * Boolean que indica si se activa la EF.
     */
    public boolean def;
    /**
     * Texto descriptivo para facilitar la lectura del XML.
     */
    public String text;
    
    public FinantialOrg(){
        ObjectUtils.initialize(this);
    }

    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static FinantialOrg getObject( String xml) throws XOMarshallerException {
        return (FinantialOrg) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto FinantialOrg a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
}
