package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;
import java.util.Map;

import p12f.exe.pasarelapagos.objects.DatosPago;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class InitializeCSBPaymentResult implements Serializable, Initializable{

	/**
	 * Resultado de la operacin.
	 */
	public boolean resultadoOK;
	/**
	 * Objeto Peticion de Pago que contiene la informacin sobre el pago a realizar.
	 */
	public DatosPago datosPago = null;
	/**
	 * Flag que indica si la Peticion de Pago ha sido modificada.
	 */
	public boolean modificado = false;
    /**
     * Flag que indica si la Peticion de Pago ha sido cancelada.
     */
    public boolean cancelado = false;
	/**
	 * Mensajes sobre la operacin, como las modificaciones producidas.
	 */
	public Map mensajes;	
	
	public InitializeCSBPaymentResult(){
	    ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto InitializeCSBPaymentResult a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto InitializeCSBPaymentResult.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static InitializeCSBPaymentResult getObject(String xml) throws XOMarshallerException {    
	    return (InitializeCSBPaymentResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
