package p12f.exe.pasarelapagos.paymentrequest;


import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Datos de presentacion de una peticion de pago en la pasarela de pagos
 */
public class Liquidacion implements Serializable, Initializable {
	
    public Map imagenes;
    public String paymentGatewayVersion;
    public String urlPlantilla;
    
    
    /**
     * Mensajes auxiliares.
     */
    public Map mensajes;
	//public String id;  // identificativo.
	//public String idCartaPago;
	//public Map textoPie;
	//public Map lugarFirma;
	//public String numeroLiquidacion;
	//public Map plantillasLiquidacion;	 // Plantilla XSL:FO para obtener el PDF
    
    
    /** Constructores */
    public Liquidacion(){
        ObjectUtils.initialize(this);
    }   
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static Liquidacion getObject( String xml) throws XOMarshallerException {
        return (Liquidacion) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto Liquidacion a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }

}
