/*
 * Created on 13-jun-2005
 *
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

import p12f.exe.pasarelapagos.objects.ProtocolData;

/**
 * Objeto que engloba el PaymentRequestData + PaymentProtocolData + PaymentPresentationData
 */
public class PaymentGatewayData implements Serializable, Initializable {
	
	public PaymentRequestData paymentRequestData = null; // Conjunto de pagos para una peticion
	public ProtocolData protocolData = null ; // Datos de Protocolo.
	public PresentationRequestData presentationData = null ; // Datos de Protocolo.
	
	public PaymentGatewayData(){
	    ObjectUtils.initialize(this);
	}
	
	/**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static PaymentGatewayData getObject( String xml) throws XOMarshallerException {
        return (PaymentGatewayData) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto PaymentGatewayData a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
}
