/*
 * Created on 13-jun-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que contiene los datos de un tipo de pago.
 */
public class PaymentMode implements Serializable, Initializable {
	
	public static final String LIQUIDACION = "01";
	public static final String BANCA_ONLINE = "02";
	public static final String BANCA_ONLINE_VENTANILLA = "03";
	public static final String MOVIL = "05";
	public static final String PAGO_DIRECTO_CUENTA = "07";
	
	/**
	 * Oid del modo de pago.
	 */
	public String oid;
	/**
	 * Texto descriptivo para facilitar la lectura del XML.
	 */
	public String text;
	
	public PaymentMode(){
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte de un String xml a un Objeto 
	 * @param xml : XML de objeto.
	 * @return Objeto convertido.
	 * @throws XOMarshallerException
	 */
	public static PaymentMode getObject( String xml) throws XOMarshallerException {
		return (PaymentMode) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);
	}
	
	/**
	 * Convierte un Objeto PaymentMode a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
}
