/*
 * Created on 13-jun-2005
 * @author co01347e
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que encapsula los datos de presentacion de una peticion de pago.
 */
public class PresentationRequestData  implements Serializable, Initializable{

    
	/**
	 * Cdigo del idioma:
	 * 		es=castellano
	 * 		eu=euskera	
	 */
	public String idioma;
	/**
	 * Imgenes a mostrar en pantalla y justificante.
	 */
	public Map imagenes;
	/**
	 * Mensajes a mostrar en pantalla y justificante.
	 */
	public Map mensajes;
	
	public Map paymentModes; // Modos de pago permitidos para este pago.
    public Map finantialOrgs; //Entidades financieras permitidas para este pago.
    //public Map liquidaciones ;    // Liquidacion . Map de objetos Liquidacion, como clave el PaymentType.

    public PresentationRequestData(){
        ObjectUtils.initialize(this);
    }
    
    /**
	 * Convierte un Objeto PresentationRequestData a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    
    /**
	 * Convierte un XML en un objeto PresentationRequestData.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static PresentationRequestData getObject(String xml) throws XOMarshallerException {    
	    return (PresentationRequestData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
}
