/*
 * Created on Feb 14, 2007
 * 
 * @author co01347e - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.pasarelapagos.paymentrequest;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * TODO Define the type
 */
public class Validacion implements Serializable, Initializable {
    
    /**
     * Indica si el pago ha superado o no la validacin.
     */
    public boolean valido = true;    
    /**
     * Codigo del error en la validacin
     */
    public String codigoError;
    /**
     * Mensaje sobre el error en la validacin. 
     */
    public String mensaje;

    public Validacion(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static Validacion getObject( String xml) throws XOMarshallerException {
        return (Validacion) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto Aplicacion a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
}
