package p12f.exe.pasarelapagos.security;

/**
 Interfaz que utilizaremos para el control de seguridad de la aplicacion.
 La implementan dos clases: 1.SecurityHelpperDefault que devuelve una
 configuracion de seguridad por defecto ( no basada en XLnets )
 2.SecurityHelpperXLNets qque devuelve una configuracion de seguridad basada en
   XLnets.	        
**/   

import javax.servlet.http.*;

public interface ISecurityInfo {
	
 /* Obtener los perfiles asociados al Usuario que realiza Login.*/
 public String[] getPerfiles()throws SecurityHelperException;	;
 
 /* Comprobar si el usuario tiene permiso para la funcin dada*/ 
 public boolean hasPermission (String uidFunction)throws SecurityHelperException;	
 
 /* Asociar la request de la sesin */
 //public boolean init(HttpServletRequest request)throws SecurityHelpperException;
 public boolean init (HttpServletRequest request, HttpServletResponse response)  throws SecurityHelperException;
 
 /* Obtener el Objeto de Seguridad que se utilizar a lo largo de la aplicacin */
 public SecurityObject getSecurityObject(String uidFuncion)throws SecurityHelperException;	
 
 /* Rdirecciona a  la pgina de login cuando la Sesin no es vlida **/
 public void redirectToLogin(String finalURI) throws SecurityHelperException ;


}	
	
