package p12f.exe.pasarelapagos.security;

import java.util.*;

import com.ejie.r01f.xmlproperties.XMLProperties;

public class SecurityObject {
	
    public String[] perfiles;
    public String puesto;
    public String persona;
    public String dni;

    public SecurityObject(String puesto) {
        this.puesto = puesto;
    }

    public void setPerfiles(String[] perfiles) { 
        this.perfiles = perfiles;
    }

    // Devuelve true si el perfil que se le pasa como parametro lo tiene el objeto
    public String[] getPerfiles() { 
        return perfiles	; 
    }
    public void setPersona(String persona) {
        this.persona = persona;
    }

    public String getPersona() {
        return persona;
    }

    public String getPuesto() {
        return puesto;	
    }
    public boolean hasPermission(String perfil) {
        for (int i=0; i < perfiles.length;i++)
            if (perfiles[i].equalsIgnoreCase(perfil)) return true;
        return false;	
    }	
    
    public boolean hasPermission(Map perfiles) {   
        // Primero comprobar si es super-usuario
        if ( this.hasPermission(XMLProperties.getProperty("p01","xlnets/superUsuario"))) return true;
        // Si no es super-usuario, comprobar uno a uno los perfiles
        // del proyecto y ver si el usuario tiene alguno de ellos
        if ( perfiles != null ) {
            for (Iterator it = perfiles.entrySet().iterator(); it.hasNext(); ) {
                Map.Entry me = (Map.Entry)it.next();
                String currPerfilOID = (String)me.getKey();
                //PerfilVO currPerfilVO = (PerfilVO)me.getValue();
                //String perfilCod = currPerfilVO.valor;
                //if (this.isExcluded(perfilCod)) continue;	 
                //if (this.hasPermission(currPerfilVO.valor) == true) return true;
            }
        }
        return false;
    }
         
    public boolean isExcluded(String profile) {  
        List excluded = XMLProperties.getPropertyList("p85","xlnets/perfilesExcluir/perfil");
        return excluded.contains(profile); 
   }
	
}