package p12f.exe.pasarelapagos.security.app.custom;

import com.ejie.r01f.util.encoders.BASE64Encoder;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;


public class DefaultXMLToken {	
	
	public String value;	

	/***********************************************************************************/
    /*  Metodos Pblicos Auxiliares para manejar el Objeto.
   /************************************************************************************/
	
	
	public String getValue(){
		return value;	
	}
	
	public void setValue(String v){
		 value = v;
	}
	
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static DefaultXMLToken getObject( String xml) throws XOMarshallerException {
        return (DefaultXMLToken) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto Aplicacion a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
	
    
	/**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static DefaultXMLToken getObjectFromBase64( String base64Data) throws XOMarshallerException {
    	
    	try {
    	   com.ejie.r01f.util.encoders.BASE64Decoder decoder = new com.ejie.r01f.util.encoders.BASE64Decoder();
           byte[]  decodedBytes = decoder.decodeBuffer(base64Data);           
           String xml = new String(decodedBytes);    	
           return (DefaultXMLToken)getObject(xml);  
          
    	} catch(Exception ex){
    		throw new XOMarshallerException(ex.getMessage());
    	}
    }


    
    /**
     * Convierte un Objeto ORGConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toBase64() throws Exception { 
    	
    	BASE64Encoder base64Encoder = new BASE64Encoder();
	    String xmlToken = this.toXML();
        String base64Data = base64Encoder.encodeBuffer(xmlToken.getBytes());    	
        return base64Data;
    }
    
    
    
    

}
