/*
 * Created on 13-jun-2005
 * @author co00414a
 */
package p12f.exe.pasarelapagos.transformer;

import p12f.exe.pasarelapagos.paymentrequest.PaymentGatewayData;
import p12f.exe.pasarelapagos.v1.objects.PeticionPago;
import p12f.exe.pasarelapagos.transformer.ObjectTransformerException;

/**
 * 
 */
public interface ObjectTransformerAPI {
	
	
	/**
	 * Mtodo que obtiene un Map de los datos de la pasarela (Paymentgateway):
	 * PaymentData + ProtocolData + PresentationData
	 * @param  PeticionPago : PeticionPago Pasarela Antigua
	 * @return Map PaymentGateway Data : PaymentData + ProtocolData + PresentationData
	 **/
	public PaymentGatewayData transformToNewPaymentData(PeticionPago oldPeticionPago) throws ObjectTransformerException ;
	
	/**
	 * Mtodo que obtiene un objeto PeticionPago antiguo a partir de
	 * los PaymentGateway Data : PaymentData + ProtocolData + PresentationData
	 * @param  Map : PaymentGateway Data : PaymentData + ProtocolData + PresentationData
	 * @return PeticionPago : PeticionPago Pasarela Antigua
	 **/
	public  p12f.exe.pasarelapagos.v1.objects.PeticionPago transformToOldPaymentData(PaymentGatewayData paymentGatewayData) throws ObjectTransformerException ;

	
	/**
	 * Devuelve un OID nuevo a partir de un OID viejo.
	 * @param oldOid
	 * @return
	 * @throws ObjectTransformerException
	 */
	public String getNewOIDFormat(String oldOid)throws ObjectTransformerException ;
	
	

	/**
	 * Devuelve un OID nuevo a partir de un OID viejo.
	 * @param oldOid
	 * @return
	 * @throws ObjectTransformerException
	 */
	public String getOldOIDFormat(String oldOid)throws ObjectTransformerException ;




}
