/*
 * Created on 09-jun-2005
 * @author co00414a
 */
package p12f.exe.pasarelapagos.transformer.test;

/**
 * 
 *
 */
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

import p12f.exe.pasarelapagos.objects.ProtocolData;
import p12f.exe.pasarelapagos.paymentrequest.PaymentGatewayData;
import p12f.exe.pasarelapagos.paymentrequest.PaymentRequestData;
import p12f.exe.pasarelapagos.paymentrequest.PresentationRequestData;
import p12f.exe.pasarelapagos.transformer.ObjectTransformer;
import p12f.exe.pasarelapagos.transformer.ObjectTransformerAPI;
import p12f.exe.pasarelapagos.transformer.ObjectTransformerException;


import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class TestConverterPaymentToPeticionPago {
	
	public static String PATH_PETICIONPAGO_ORIGINAL = "d:\\eAdmin\\config\\p12f\\PeticionPagoOldOriginal.xml";
	public static String PATH_PAYMENT_REQUEST = "d:\\eAdmin\\config\\p12f\\PaymentRequestData.xml";
	public static String PATH_PROTOCOL_REQUEST = "d:\\eAdmin\\config\\p12f\\ProtocolData.xml";
    public static String PATH_PRESENTATION_REQUEST = "d:\\eAdmin\\config\\p12f\\PresentationData.xml";
    public static String PATH_PETICIONPAGO_FINAL = "d:\\eAdmin\\config\\p12f\\PeticionPagoOldFinal.xml";			
	
	public static void main(String args[]) throws ObjectTransformerException, XOMarshallerException, IOException{
		
		
		FileInputStream fis = null;
		
		/// Obtener una Peticion de Pago Actual
		
		PaymentRequestData paymentRequestData = null;
		ProtocolData protocolData = null;
		PresentationRequestData presentationData = null;
      
		fis = new FileInputStream (PATH_PAYMENT_REQUEST);
		try {
			System.out.println("Leer y convertir PaymentRequestData");
			paymentRequestData = (PaymentRequestData) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),fis);
			System.out.println("Leido y convertido");
		} catch ( Exception ex){
			System.out.println("Error al convertir de XML:paymentRequestData a Objeto");
			ex.printStackTrace();
		}
			
		fis = new FileInputStream (PATH_PROTOCOL_REQUEST);
		try {	
			System.out.println("Leer y convertir ProtocolData");
			protocolData = (ProtocolData) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),fis);
			System.out.println("Leeido y convertido.");
		} catch ( Exception ex){
			System.out.println("Error al convertir de XML:protocolData a Objeto");
			ex.printStackTrace();
		}
		
		fis = new FileInputStream (PATH_PRESENTATION_REQUEST);
		try {
			System.out.println("Leer y convertir PresentationRequestData");
			presentationData = (PresentationRequestData) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),fis);
			System.out.println("Leeido y convertido.");
		} catch ( Exception ex){
			System.out.println("Error al convertir de XML:presentationData a Objeto");
			ex.printStackTrace();
		}
			
	
		// Instanciar Object Transformer.
		
		 ObjectTransformerAPI transformer = new ObjectTransformer();
		
	
	     // Prueba 2 :  Obtener los datos para la Pasarela Vieja a partir de objetos nuevos
	
		 PaymentGatewayData paymentGatewayData2 = new PaymentGatewayData();
		 paymentGatewayData2.paymentRequestData = paymentRequestData;
		 paymentGatewayData2.protocolData = protocolData;
		 paymentGatewayData2.presentationData = presentationData;
		 
		 System.out.println("proceso de conversion......");
		 p12f.exe.pasarelapagos.v1.objects.PeticionPago oldPeticionPago = transformer.transformToOldPaymentData(paymentGatewayData2);
		 System.out.println("Conversion OK.......");
		 System.out.println(oldPeticionPago.toXML());
		 
		 _writeToFile(PATH_PETICIONPAGO_FINAL,oldPeticionPago.toXML());
		
	}
	
	
	private static void _writeToFile(String path, String xmlStr) throws IOException{	 	
 	    FileOutputStream fos=new FileOutputStream (path,false);
        PrintStream ps = new PrintStream(fos);	      
        ps.print(xmlStr);
        fos.close();
        ps.close();	 
	 }
	

}
