/*
 * Created on 09-jun-2005
 * @author co00414a
 */
package p12f.exe.pasarelapagos.transformer.test;

import java.util.HashMap;

import p12f.exe.pasarelapagos.objects.DatoAdicional;
import p12f.exe.pasarelapagos.objects.DatosPago;
import p12f.exe.pasarelapagos.objects.Pago;
import p12f.exe.pasarelapagos.objects.PeriodoPago;
import p12f.exe.pasarelapagos.paymentrequest.Aplicacion;
import p12f.exe.pasarelapagos.paymentrequest.Backend;
import p12f.exe.pasarelapagos.paymentrequest.BackendData;
import p12f.exe.pasarelapagos.paymentrequest.ConceptoPeticion;
import p12f.exe.pasarelapagos.paymentrequest.PaymentRequestData;
import p12f.exe.pasarelapagos.paymentrequest.PeticionPago;

import com.ejie.r01f.xml.marshalling.XOMarshallerException;


/**
 * 
 *
 */
public class TestPaymentRequestData {
	
	/*
    <!-- Instancia de Peticion de Pago. -->
	<class name='PeticionPago' package='p12f.exe.pasarelapagos.paymentrequest' fromElement='peticionPago'>
		<member name='id' dataType='String' fromAttribute='id' isOID='true'/>
		<member name='datosPago' dataType='DatosPago' fromElement='datosPago'/>
		<member name='descripcion' dataType='Descripcion' fromElement='descripcion'/>
		<member name='conceptos' dataType='Concepto' collection='Map' fromElement='conceptos'/>
		<member name='emisor' dataType='Emisor' fromElement='emisor'/>
		<member name='expediente' dataType='Expediente' fromElement='expediente'/>
	</class>
	 */
	public static void main(String args[]){
		
		
		/*****************  DATOS PETICION PAGO ************************* */
		
		DatosPago datosPeticionPago = new DatosPago();
		datosPeticionPago.formato = "507";
		datosPeticionPago.emisor = "04833001-501"; // En caso de 507 emisor + sufijo
		datosPeticionPago.codigo = "codigo completo en formato 57 o 60";
        datosPeticionPago.cpr     = "900507"; // Codigo procedimiento recaudatorio		
		datosPeticionPago.validar = DatosPago.NO_VALIDAR;
		datosPeticionPago.referencia = "0005026673427";
		datosPeticionPago.periodosPago = new HashMap();	
		PeriodoPago periodoPago = new PeriodoPago();
		
		periodoPago.fechaFin =    "010505";
		periodoPago.fechaInicio = "010605";
		periodoPago.importe = 100; 
		periodoPago.identificacion = "100"; // Identificacin del pago en este periodo
		
		
		/***************** CONCEPTOS PETICION DE PAGO *****************/
	
		java.util.List conceptosPeticionEjemplo = _getConceptosPeticionPago();
		
		/*****************DATOS BACKEND(SIPCA) PETICION DE PAGO ******/
		
		Backend datosBackendEjemplo = _getDatosBackendPeticionPago();
		
		/**************  DESCRIPCION APLICACION ********************************/
		Aplicacion app = new Aplicacion();
		app.codigo = "z99";
	
		/**************  DESCRIPCION PETICION DE PAGO **************************/
		
		
		
		/********************** PETICION DE PAGO COMPOSE FINAL *******************/
		PeticionPago peticionPago = new PeticionPago();
		peticionPago.id = "012345678";
		
		peticionPago.aplicacion = app;
		peticionPago.datosPago = datosPeticionPago;
		peticionPago.conceptos = conceptosPeticionEjemplo;
		peticionPago.backend = datosBackendEjemplo;
		
		/*peticionPago.liquidacion = new Liquidacion();
		peticionPago.liquidacion.plantillasLiquidacion = new HashMap();
	    Plantilla	pdfPreview = new Plantilla();
		pdfPreview.id = "pdfPreview";
		Url newUrles = new Url("es", "http://www.kie.es");
		Url newUrleu = new Url("eu", "http://www.kie.eu");
		
		pdfPreview.url.put(newUrles.id,newUrles);
		pdfPreview.url.put(newUrles.id,newUrleu);
		peticionPago.liquidacion.plantillasLiquidacion.put(pdfPreview.id,pdfPreview);
		
		
		peticionPago.liquidacion.plantillasLiquidacion.put(new String("pdfPreview"),pdfPreview);
		*/
		
		/************************** PAYMENT REQUEST DATA *******************/
		
		PaymentRequestData paymentRequestData = new PaymentRequestData();
		paymentRequestData.peticionesPago = new HashMap();
		paymentRequestData.peticionesPago.put(peticionPago.id,peticionPago);
		paymentRequestData.datosAdicionales = new java.util.HashMap();
		DatoAdicional dt = new DatoAdicional();
		dt.id= "1";
		dt.valor = "Dato Adicional 1";
		dt.valor = "Dato Adicional 2";
		paymentRequestData.datosAdicionales.put(dt.id,dt);
		
		
		
		
		try {
			System.out.println(paymentRequestData.toXML());
			Pago pago = new Pago(peticionPago);
			System.out.println(pago.toXML());
			
		} catch (XOMarshallerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (p12f.exe.pasarelapagos.exceptions.PaymentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	/**********************************  FUNCIONES PRIVADAS **********************************************/
	
	
	
	/*
	 *  Funcion : _getDatosBackendPeticionPago
	 *  Devuelve un map con los datos de sipca para la Peticion de Pago.
	 */
	private static Backend  _getDatosBackendPeticionPago(){
    /*
		public boolean informarSIPCA;	// Indica
		public String entidadSIPCA;         // Entidad emisora de dos posiciones (de momento siempre es 01)
		public boolean exentoPago;          // SIPCA
		public boolean gastoGV;             // SIPCA
		public String modoPago;             // Pago Fraccionado
		* */
		
		Backend backEnd = new Backend();
		backEnd.systemID = "SIPCA";
		backEnd.put( new BackendData("gastoGV","true"));
		backEnd.put( new BackendData("entidadSIPCA","true"));
		
		return backEnd;
		
	}
	/* Funcion _getConceptosPeticionPago ()
	 * @author co00414a
	 * Funcion que devuelve un MAP de dos Conceptos de Pago para el siguiente ejemplo :
	 *  *  Concepto de Matricula + Concepto IVA Matricula
		 *  El IVA por s mismo, constituye un concepto, para SIPCA.
		 * 
		 *  <concepto>
                <castellano>Matriculas de seminarios, congresos, jornadas y cursos</castellano>
                <euskara>Matrculas de seminarios, congresos, jornadas y cursos_eu</euskara>
                <aplicacionPresupuestaria>05020213000013215142223001Q</aplicacionPresupuestaria>
                <codigoIngreso>002004</codigoIngreso>
                <importe>145</importe>
                <numeroLinea>1</numeroLinea>
                <territorioIVA>1</territorioIVA>
            </conceptoPPIngreso>
		 * 
		 * <concepto>
                    <ivaRepercutido>true</ivaRepercutido>
                    <castellano>IVA matriculas</castellano>
                    <euskara>IVA Matriculas</euskara>
                    <tipoIVA>16.0</tipoIVA>
                    <codigoIngreso></condigoIngreso>
                    <baseImponible>145</baseImponible>
                    <numeroLinea>2</numeroLinea>
                    <importeIVA>4.0</importeIVA>
                    <importe>4.0</importe>
                    <territorioIVA>1</territorioIVA>
                    <conceptoIVA>002004</conceptoIVA>                   
           </conceptoPPIVA>
	 */
	private static java.util.List _getConceptosPeticionPago(){
		
		java.util.List conceptosPeticionPagoMap = new java.util.ArrayList();
		
		ConceptoPeticion conceptoPeticionMatricula  = new ConceptoPeticion();
		conceptoPeticionMatricula.descripcion = new HashMap();
	//	conceptoPeticionMatricula.descripcion.put(new String("es"),"Matriculas de seminarios, congresos, jornadas y cursos";
	//	conceptoPeticionMatricula.descripcion.eu = "Matrculas de seminarios, congresos, jornadas y cursos_eu";
		conceptoPeticionMatricula.importe =145;
		conceptoPeticionMatricula.numeroLinea =1;
		/* Datos  Backend : Sipca */
		conceptoPeticionMatricula.backendDataMap = new HashMap();
		conceptoPeticionMatricula.backendDataMap.put(new String("oidBackEnd1"),new BackendData("aplicacionPresupuestaria","05020213000013215142223001Q"));
		conceptoPeticionMatricula.backendDataMap.put(new String("oidBackEnd2"),new BackendData("codigoIngreso","002004"));
		conceptoPeticionMatricula.backendDataMap.put(new String("oidBackEnd3"),new BackendData("territorioIVA","1"));
	
		ConceptoPeticion conceptoPeticionMatriculaIVA  = new ConceptoPeticion();
		//conceptoPeticionMatriculaIVA.descripcion = new Descripcion();
		conceptoPeticionMatriculaIVA.importe =400;
		conceptoPeticionMatriculaIVA.numeroLinea =2;		
		//conceptoPeticionMatricula.descripcion.es = "IVA Matriculas";
		//conceptoPeticionMatricula.descripcion.eu = "IVA Matriculas_es";
	
		/* Datos  Backend : Sipca */
		/*
        <ivaRepercutido>true</ivaRepercutido>
        <castellano>IVA matriculas</castellano>
        <euskara>IVA Matriculas</euskara>
        <tipoIVA>16.0</tipoIVA>
        <codigoIngreso></condigoIngreso>
        <baseImponible>145</baseImponible>
        <numeroLinea>2</numeroLinea>
        <importeIVA>4.0</importeIVA>
        <importe>4.0</importe>
        <territorioIVA>1</territorioIVA>
        <conceptoIVA>002004</conceptoIVA>-->     */
		
		conceptoPeticionMatriculaIVA.backendDataMap = new HashMap();
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd1"),new BackendData("ivaRepercutido","true"));
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd2"),new BackendData("tipoIVA","16.0"));
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd3"),new BackendData("baseImponible","145"));
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd4"),new BackendData("importeIVA","4.0"));
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd4"),new BackendData("territorioIVA","1"));
		conceptoPeticionMatriculaIVA.backendDataMap.put(new String("oidBackEnd4"),new BackendData("conceptoIVA","02004"));
		
	
		conceptosPeticionPagoMap.add(conceptoPeticionMatricula);
		conceptosPeticionPagoMap.add(conceptoPeticionMatriculaIVA);
				
		
		
		return	conceptosPeticionPagoMap;
		
	}
	
}
