/*
 * p12/exe/listados/p12CListado.java
 * 
 */
package p12f.exe.pasarelapagos.utils.fop;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.io.Reader;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.avalon.framework.logger.ConsoleLogger;
import org.apache.avalon.framework.logger.Logger;
import org.apache.fop.apps.Driver;
import org.apache.fop.apps.FOPException;
import org.apache.fop.apps.InputHandler;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Clase que representa a un listado
 */
public class XMLTransformerNoJDK {
	
	private static int logLevel;
	
    static {     
    	logLevel = Integer.parseInt( XMLProperties.get("p12f","pdfLogLevel"));
    }
        
    /**
     * Genera un listado 
     */ 
    public static byte[] getPDF(Reader xmlReader,File xsltFile) throws XMLTransformerException {    	
        try {
        	ByteArrayOutputStream baos = new ByteArrayOutputStream();
        	
			//Using a Configuration File To access an external configuration: 
			//File userConfigFile = new File("/aplic/p01/html/datos/userconfig.xml");
			//Options options = new Options(userConfigFile);
            // Obtener un parser del XML utilizando el fichero XSLT		
            InputHandler xsltInputHandler = new XSLTInputHandlerNoJDK(xmlReader,xsltFile);
            XMLReader parser = xsltInputHandler.getParser();
            //System.out.println(parser.getClass().getName());
            if (parser == null) throw new XMLTransformerException("No se ha podido obtener el parser (filtro XSLT al XML de entrada");
                        
            // Aplicar fop aplicando al parser (filtro) el xml de entrada
            Driver driver = new Driver();  
            
            // Generar el log con el nivel que se quiera
            Logger log = new ConsoleLogger(logLevel);
            driver.setLogger(log);
            
            driver.setRenderer(Driver.RENDER_PDF);      
            driver.setOutputStream(baos);
            driver.render( xsltInputHandler.getParser(), new InputSource(xmlReader) );
          
            return baos.toByteArray();
        } catch (FOPException fopEx) {
        	fopEx.printStackTrace();
            throw new XMLTransformerException(fopEx.toString());
        } catch (Exception fopEx) {
        	fopEx.printStackTrace();
            throw new XMLTransformerException(fopEx.toString());
        } 
    }
    
    public static void getHTML(OutputStream out,Reader xmlReader,File xsltFile) throws XMLTransformerException {
        try {
            TransformerFactory tFactory = TransformerFactory.newInstance();
            Transformer transformer = tFactory.newTransformer( new StreamSource(xsltFile) );
            transformer.transform( new StreamSource(xmlReader),new StreamResult(out) );
        } catch (Exception ex) {
            throw new XMLTransformerException(ex.toString());
        }
    }
   
}