package p12f.exe.pasarelapagos.utils.pif;

import java.net.*;
import java.io.*;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class PIFSessionTokenHelper {

	private String _appId; // "P12G"
	private String _sessionToken;

	/**
	 * getter _appId
	 * @return
	 */
	public String getAppId() {
		return _appId;
	}

	/**
	 * getter _sessionToken
	 * @return
	 */
	public String getSessionToken() {
		return _sessionToken;
	}

	/**
	 * setter _appId
	 * @param appId
	 */
	public void setAppId(String appId) {
		_appId = appId;
	}

	/**
	 * setter _sessionToken
	 * @param strToken
	 */
	public void setSessionToken(String strToken) {
		_sessionToken = strToken;
	}

	/**
	 * Obtiene un token de sesin y lo asigna a este SignHelper
	 * @param appId id de aplicacin (p.ej. P12G)
	 * @param simulateXLNets true si el token es simulado (p.ej. para pruebas en local)
	 * @return
	 */
	public boolean setSessionToken(String appId, boolean simulateXLNets) {

		boolean resulTokenOk = false;

		_appId = appId;

		// http://svc.intra.integracion.jakina.ejiedes.net/ctxapp/Y31JanoServiceXlnetsTokenCreatorServlet?login_app=p12g
		// poner en properties...

		if (!simulateXLNets) { // Obtener el token XLNets de XLNets
			//R01FLog.to("p12f.session").info("[P12H] SessionTokenHelper() Obteniendo token de sesin... (XLNETS)");
			System.out.println("[P12F] PIFSessionTokenHelper() Obteniendo token de sesin... (XLNETS)");

			_sessionToken = "";

			try {
				String tokenURL = XMLProperties.get("p12f","pif/token/url");
				//String tokenURL = "http://svc.intra.integracion.jakina.ejiedes.net/ctxapp/Y31JanoServiceXlnetsTokenCreatorServlet?login_app="+appId;
				//URL url = new URL("http://svc.intra.integracion.jakina.ejiedes.net/ctxapp/Y31JanoServiceXlnetsTokenCreatorServlet?login_app="+appId);
				URL url = new URL(tokenURL+appId);
		        URLConnection urlCon;
				urlCon = url.openConnection();
		        BufferedReader in = new BufferedReader(new InputStreamReader(urlCon.getInputStream()));
		        String inputLine;

		        while ((inputLine=in.readLine())!=null) _sessionToken+=inputLine;
			        	
		        System.out.println(_sessionToken);

		        in.close();

		        resulTokenOk = true;

			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		else { // apa... para probar, sacamos el token de aqu como P12 (login de aplicacin):
			   //         https://xlnets.servicios.jakina.ejiedes.net/xlnets/serviciosLoginApp.htm
			   //R01FLog.to("p12f.session").info("[P12H] SessionTokenHelper() Obteniendo token de sesin... (SIMULADO)");
			System.out.println("[P12F] PIFSessionTokenHelper() Obteniendo token de sesin... (SIMULADO)");

			_sessionToken =
				"<n38><elementos tipo=\"n38APISesionCrearToken\"><elemento subtipo=\"N38Sesion\"><parametro id=\"n38fhum\"><valor>1354612153989</valor></parametro><parametro id=\"cn\"><valor>P121291035045446</valor></parametro><parametro id=\"n38uidsesion\"><valor>1291040952330</valor></parametro><parametro id=\"n38login\"><valor>P12</valor></parametro><parametro id=\"n38perfiles\"><valor>Publico</valor><valor>P12-PF-0002</valor><valor>P12-PF-0001</valor></parametro><parametro id=\"n38organizacion\"><valor>400</valor></parametro><parametro id=\"iphostnumber\"><valor>10.190.8.101</valor></parametro><parametro id=\"n38reintentossesion\"><valor>1</valor></parametro><parametro id=\"n38sexpiracion\"><valor>988999999999</valor></parametro><parametro id=\"n38tiposesion\"><valor>C/S</valor></parametro><parametro id=\"n38puestouid\"><valor>P12</valor></parametro><parametro id=\"n38fechacreacion\"><valor>1291035045446</valor></parametro><parametro id=\"n38personauid\"><valor>P12</valor></parametro><parametro id=\"n38fechalogoff\"><valor/></parametro><parametro id=\"n38valorhash\"><valor>MZrok7Ph8nTBBeWN7TldZpdGRc8=</valor></parametro><parametro id=\"n38fechainicio\"><valor>1291035045446</valor></parametro><parametro id=\"n38idioma\"><valor>1</valor></parametro><parametro id=\"dni\"><valor>P12</valor></parametro><parametro id=\"n38comportamientoip\"><valor>ipv</valor></parametro><parametro id=\"n38idcontexto\"><valor>intranet</valor><valor>internet</valor></parametro><parametro id=\"n38loginasociado\"><valor>https://xlnets.servicios.jakina.ejiedes.net:443/n38a/N38LoginInicioServlet</valor></parametro><parametro id=\"n38listacede\"><valor>x_cddes01:48880:1000</valor><valor>x_cddes02:48880:1000</valor></parametro><parametro id=\"n38comportamientofirma\"><valor>False</valor></parametro><parametro id=\"n38exclusivo\"><valor>False</valor></parametro><parametro id=\"n38dominiouid\"><valor>D0_Servidores11</valor></parametro><parametro id=\"n38urlsredireccion\"><valor>http://xlnets.servicios.jakina.ejiedes.net/n38nWar/N38NodoEstrellaServlet</valor></parametro><parametro id=\"n38listags\"><valor>x_ssdes01:47770:1000</valor><valor>x_ssdes02:47770:1000</valor></parametro><parametro id=\"n38rangoip\"><valor>10.200.56.11</valor><valor>10.170.9.109</valor><valor>10.170.8.4</valor><valor>10.170.8.5</valor><valor>10.170.9.4</valor><valor>10.170.9.5</valor><valor>10.170.9.137</valor><valor>10.170.9.79</valor><valor>10.200.56.57</valor><valor>10.170.17.114</valor><valor>10.200.8.216</valor><valor>10.200.8.217</valor><valor>10.200.8.218</valor><valor>10.190.8.14</valor><valor>10.170.17.105</valor><valor>192.168.56.231</valor><valor>192.168.56.233</valor><valor>192.168.56.242</valor><valor>192.168.56.241</valor><valor>10.190.20.25</valor><valor>10.190.24.15</valor><valor>192.168.56.234</valor><valor>10.190.8.101</valor><valor>10.190.20.20</valor><valor>192.168.56.21</valor><valor>192.168.56.13</valor><valor>192.168.56.17</valor><valor>192.168.56.11</valor><valor>192.168.56.228</valor><valor>10.170.8.216</valor><valor>192.168.56.58</valor><valor>10.190.20.14</valor><valor>10.170.17.201</valor><valor>555.</valor><valor>10.190.20.43</valor><valor>10.190.20.47</valor><valor>10.190.20.32</valor><valor>10.190.20.40</valor><valor>10.190.20.11</valor><valor>10.190.20.56</valor><valor>10.190.20.38</valor><valor>10.190.8.69</valor><valor>10.190.8.70</valor><valor>10.170.17.200</valor><valor>10.190.20.50</valor><valor>10.190.40.15</valor><valor>10.190.40.16</valor><valor>10.190.40.18</valor><valor>10.190.40.19</valor><valor>10.190.20.69</valor><valor>10.190.20.70</valor><valor>10.170.9.21</valor><valor>10.190.20.67</valor><valor>10.170.16.172</valor><valor>10.190.20.100</valor><valor>10.190.20.102</valor><valor>10.190.20.63</valor><valor>10.190.20.64</valor><valor>10.170.17.203</valor></parametro><parametro id=\"n38dominioscookies\"><valor>.jakina.ejgvdns</valor></parametro><parametro id=\"n38listamsservidores\"><valor>hola Aitzi</valor></parametro><parametro id=\"n38servidoraudit\"><valor>x_auddes01:4560</valor></parametro><parametro id=\"n38subjectcert\"><valor>NO</valor></parametro><parametro id=\"n38certificadopoliticas\"><valor>NO</valor></parametro><parametro id=\"n38oleserver\"><valor>false</valor></parametro><parametro id=\"n38cadescripciondominio\"><valor>ras internete</valor></parametro><parametro id=\"n38eudescripciondominio\"><valor>rak Interneta</valor></parametro><parametro id=\"n38crearsesionapp\"><valor>true</valor></parametro><parametro id=\"n38urlportal\"><valor>https://xlnets.servicios.jakina.ejiedes.net/n38a/N38servletPortal</valor></parametro><parametro id=\"n38urldispatcher\"><valor>http://xlnets.servicios.jakina.ejiedes.net/n38nWar/N38DispatcherEstrellaServlet</valor></parametro><parametro id=\"n38urlsgsd\"><valor>https://xlnets.servicios.jakina.ejiedes.net/n38nCDominioWar/N38GestorCDominioServlet</valor></parametro><parametro id=\"n38dominiocomuncookie\"><valor>.jakina.ejgvdns</valor></parametro><parametro id=\"n38sistemaxlnetsuid\"><valor>desarrollo-produccion</valor></parametro><parametro id=\"n38direccionproxy\"><valor>http://www.servicios.comunes.ejiedes.net/proxy</valor></parametro><parametro id=\"n38direcciongrc\"><valor>http://xlnets.servicios.jakina.ejiedes.net/n38rWar/N38rFachadaGRCServlet</valor></parametro><parametro id=\"n38grupoorganicouid\"><valor/></parametro><parametro id=\"n38orgunituid\"><valor/></parametro><parametro id=\"n38urlfinal\"><valor>http://www.euskadi.net</valor></parametro><parametro id=\"n38uidsesionglobal\"><valor>desarrollo-produccion-1291040952330</valor></parametro><parametro id=\"n38cadenaconfianza\"><valor>desarrollo-produccion</valor></parametro><parametro id=\"n38politicauid\"><valor>P2</valor></parametro></elemento></elementos></n38>";

			resulTokenOk = true;
		}
		return resulTokenOk;
	}

	/**
	 * @param args
	 */
	/*
		public static void main(String[] args) {
			try {
				URL url = new URL("http://svc.intra.integracion.jakina.ejiedes.net/ctxapp/Y31JanoServiceXlnetsTokenCreatorServlet?login_app=p12g");
		        URLConnection urlCon;
				urlCon = url.openConnection();
		        BufferedReader in = new BufferedReader(new InputStreamReader(urlCon.getInputStream()));
		        String inputLine;
		        String xml = "";

		        while ((inputLine=in.readLine())!=null) xml+=inputLine;
		        	
		        System.out.println(xml);

		        in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	*/

}
