package p12f.exe.pasarelapagos.utils.sms.client;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import p12f.exe.pasarelapagos.objects.sms.latinia.AuthenticationLatinia;

import com.ejie.r01f.xml.marshalling.XOMarshallerException;

public class LatiniaTokenHelper {

	/**
	 * Metodo que genera  el XML para poder acceder a Latinia desde aplicaciones 
	 * que no tienen Token de Sesion N38
	 * 
	 * @param userLatinia
	 * @param passwordLatinia
	 * @param refProduct
	 * @param idContract
	 * @param loginEnterprise
	 * @param password
	 * @return Document con el formato del Usuario Latinia
	 * @throws ParserConfigurationException
	 */
	private Document tokenAuthenticationLatinia (String userLatinia, String passwordLatinia, String refProduct, String idContract, String loginEnterprise, String password) throws ParserConfigurationException {
		  
		  DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		  DocumentBuilder builder = dbf.newDocumentBuilder();
		  Document tokenLatinia = builder.newDocument();

	/* XML que llega para poder acceder a Latinia desde aplicaciones que no tienen Token 
	 * de Sesion N38
	 * <authenticationLatinia><userLatinia>a</userLatinia>
	 * <passwordLatinia>b</passwordLatinia>
	 * <refProduct>c</refProduct>
	 * <idContract>d</idContract><loginEnterprise>e</loginEnterprise>
	 * <password>f</password></authenticationLatinia>
	 */
		  Element authentication = tokenLatinia.createElement("authenticationLatinia");

		  Element elUserLatinia = tokenLatinia.createElement("userLatinia");
		  elUserLatinia.appendChild(tokenLatinia.createTextNode(userLatinia));
		  authentication.appendChild(elUserLatinia);

		  Element elPasswordLatinia = tokenLatinia.createElement("passwordLatinia");
		  elPasswordLatinia.appendChild(tokenLatinia.createTextNode(passwordLatinia));
		  authentication.appendChild(elPasswordLatinia);  

		  Element elRefProduct = tokenLatinia.createElement("refProduct");
		  elRefProduct.appendChild(tokenLatinia.createTextNode(refProduct));
		  authentication.appendChild(elRefProduct); 

		  Element elIdContract = tokenLatinia.createElement("idContract");
		  elIdContract.appendChild(tokenLatinia.createTextNode(idContract));
		  authentication.appendChild(elIdContract); 

		  Element ellLoginEnterprise = tokenLatinia.createElement("loginEnterprise");
		  ellLoginEnterprise.appendChild(tokenLatinia.createTextNode(loginEnterprise));
		  authentication.appendChild(ellLoginEnterprise); 

		  Element elPassword = tokenLatinia.createElement("password");
		  elPassword.appendChild(tokenLatinia.createTextNode(password));
		  authentication.appendChild(elPassword); 

		  Node root = (Node)authentication;
		  tokenLatinia.appendChild(root);

		  return tokenLatinia;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		AuthenticationLatinia authLatinia = new AuthenticationLatinia();

		LatiniaTokenHelper h = new LatiniaTokenHelper();
		Document d;

		try {
			System.out.println("AUTH LATINIA: " + authLatinia.toXML());

			d = h.tokenAuthenticationLatinia(
							authLatinia.userLatinia,
							authLatinia.passwordLatinia,
							authLatinia.refProduct,
							authLatinia.idContract,
							authLatinia.loginEnterprise,
							authLatinia.password);

			//System.out.println("TOKEN LATINIA: " + d. .toString());

		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (XOMarshallerException e) {
			e.printStackTrace();
		}
	}

}
