package p12f.exe.pasarelapagos.v1.objects;

/**
 * Clase que define una anulacin de pago
 */





public class AnulacionPago extends AbstractPagoObj {    
// Codigos de modos de pago
    public static final int ANULACION_LIQUIDACION = 1;
    public static final int ANULACION_INSOLVENCIAS = 2;
    public static final int ANULACION_PRESCRIPCION = 3;
    public static final int ANULACION_FRACCIONAMIENTO_APLAZAMIENTO = 4;
    
    
	public String emisor;				 // Codigo de emisor + sufijo (CSB57)
    public String referencia;           // Referencia (CSB57)
    public String fechaLimitePago;      // Identificacin del pago (CSB57)  
    public double importe;             // Importe (CSB57)
    public String fechaOperacion;		 // Fecha de la operacion en formato DDMMAAAA
    public String ejercicioContable;    // Ejercicio contable
    public int tipoAnulacion = 1;		// Tipo de anulacion

    /** Constructores */
    public AnulacionPago() {      
    }
//____________________________________________________________________________\\
	/** Obtiene el codigo del emisor desde un emisor con formato cif-sufijo */
	public String getEntidadEmisora() {
		return Emisor.getEmisor(this.emisor);
	} 
	/** Obtiene el sufijo del emisor desde un emisor con formato cif-sufijo */
	public String getSufijo() {
		return Emisor.getSufijo(this.emisor);
	}
    
}
