package p12f.exe.pasarelapagos.v1.objects;


/**
 * Elemento individual del desglose de conceptos de una peticion de pago 
 */

public class ConceptoPeticionPago extends AbstractPagoObj implements java.io.Serializable {
    public String euskera;      // Descripcion en euskera
    public String castellano;   // Descripcion en castellano
    public double importe;      // Importe individual    
    public int numeroLinea;     // Numero de la linea en la que aparece el concepto    
    public String codigoIngreso;            // SIPCA
    public String aplicPresupuestaria;      // SIPCA
    public String numInmovilizado;          // SIPCA
    public double baseImponible;            // Base imponible sobre la que se repercute el iva
    public float tipoIVA;                   // Tipo de iva que se aplica - porcentaje
    public boolean ivaRepercutido = false;  /* 1- IVA SI Deducible-Repercutido: El IVA va como un concepto individual (en caso de un alquiler, etc...)
    												A SIPCA se le pasan la baseImponible, tipoIVA, territorioIVA y conceptoIVA.
    										 2- IVA NO Deducible-Repercutido: El IVA va incluido en el importe del concepto. 
    										 			- SI hay base imponible y tipoIVA (precios pblicos, como venta de libros, etc):
    										 				el IVA se desglosa en la liquidacin.
    										 			- NO hay base imponible ni tipoIVA (tasas): no hay IVA.
    										*/
    public double importeIVA;              // importe del iva, se enva si el IVA es NO Deducible-Repercutido y se quiere mostrar el IVA desglosado.
    public String conceptoIVA;              // Concepto del iva que se enva a SIPCA
    public String territorioIVA;            // Territorio IVA

    
    
    /** Constructores */
    public ConceptoPeticionPago() {
    }
    
    public ConceptoPeticionPago(String inCastellano,String inEuskera,double inImporte) {
        this.euskera = inEuskera;
        this.castellano = inCastellano;
        this.importe = inImporte;
    }
    
}
