package p12f.exe.pasarelapagos.v1.objects;


/**
 * Datos auxiliares para el pago
 * Inicialmente no tienen una funcion prevista, pero valen para incluir cualquier
 * dato que no se ha previsto.
 * Para catalogar los datos se utilizan dos identificadores, con lo que hay 2x2=4 
 * combinaciones posibles.
 * Un ejemplo de utilizacion de los indicadores seria para enviar un dato no previsto
 * en euskera y castellano.
 *      - id1: Identificaria el dato no previsto: ej: tamao letra
 *      - id2: Identificaria el idioma: ej: castellano
 * de esta forma se podra enviar el tamao de letra para ser utilizado en
 * euskera y castellano
 */

public class DatoAdicional extends AbstractPagoObj {
    public String id;           // Identificador
    public String euskera;      // Descripcion del dato adicional en castellano
    public String castellano;   // Descripcion del dato adicional en euskera
    public String valor;        // valor del dato adicional
	
    
    
    /** Constructores */
    public DatoAdicional() {
    }
    public DatoAdicional(String inId,String inCastellano,String inEuskera,String inValor) {
        this.id = inId;
        this.castellano = inCastellano;
        this.euskera = inEuskera;
        this.valor = inValor;
    }
    
}
