package p12f.exe.pasarelapagos.v1.objects;


/**
 * Datos auxiliares para el pago
 * Inicialmente no tienen una funcion prevista, pero valen para incluir cualquier
 * dato que no se ha previsto.
 * Para catalogar los datos se utilizan dos identificadores, con lo que hay 2x2=4 
 * combinaciones posibles.
 * Un ejemplo de utilizacion de los indicadores seria para enviar un dato no previsto
 * en euskera y castellano.
 *      - id1: Identificaria el dato no previsto: ej: tamao letra
 *      - id2: Identificaria el idioma: ej: castellano
 * de esta forma se podra enviar el tamao de letra para ser utilizado en
 * euskera y castellano
 */

public class DatoAux extends AbstractPagoObj {
    public String id1;          // Identificador 1
    public String id2;          // Identificador 2
    public String valor;        // Valor del identificador
    
    
    /** Constructores */
    public DatoAux() {
    }
    public DatoAux(String inId1,String inId2, String inValor) {
        this.id1 = inId1;
        this.id2 = inId2;
        this.valor = inValor;
    }    
    

    
}
