package p12f.exe.pasarelapagos.v1.objects;

/**
 * Objeto con los datos de la operacin devueltos por la entidad financiera a la
 * pasarela en el resultado del pago
 */



public class DatosOperacion extends AbstractPagoObj {
    public String codigoEmisor;     // Emisor del CSB57
    public String referencia;       // Referencia del CSB57
    public String identificacion;   // Identificacin del CSB57
    public String importe;          // Importe del CSB57
    public EntidadFinanciera entidadFinanciera;		// Entidad financiera en la que se efectua el pago	
    public String fecha;            // Fecha de la operacion
    public String hora;             // Hora de la operacion
    public String numeroOperacion;  // Numero de operacion para la EF    
    public String cuentaAbono;      // Cuenta a la que se ha cargado la deuda del ciudadano
        
    public DatosOperacion(){
        super();
    }
    
    public DatosOperacion(String newCodigoEmisor,String newReferencia,String newIdentificacion,String newImporte) {
        super();
        this.codigoEmisor = newCodigoEmisor;
        this.referencia = newReferencia;
        this.identificacion = newIdentificacion;
        this.importe = newImporte;
    }
    public DatosOperacion(String newCodigoEmisor,String newReferencia,String newIdentificacion,String newImporte,
                          String newFecha,String newHora,String newNumeroOperacion,String newCuentaAbono) {
        this(newCodigoEmisor,newReferencia,newIdentificacion,newImporte);                              
        this.fecha = newFecha;
        this.hora = newHora;
        this.numeroOperacion = newNumeroOperacion;
        this.cuentaAbono = newCuentaAbono;
    }
            
}
