package p12f.exe.pasarelapagos.v1.objects;

import java.util.List;
import java.util.Map;

import p12f.exe.pasarelapagos.v1.objects.config.Color;

/**
 * Datos de configuracion de la pasarela de pagos
 */

public class DatosPasarela {
    public String oid;              // Identificador de la pasarela
    public Descripcion titulo;      // Titulo de la pasarela
    public String idioma;           // Idioma por defecto
    public Map imagenes;            // Imagenes de la pasarela
    public String tipoLetra;        // Tipo de letra a utlizar 
    public Map colores;             // Colores de la pasarela
    public String copyRight;        // Texto del copyRight 
    public Map urls;                // URL de la pasarela
    public Map acceptedCIFs;        // Lista de CIFs aceptados para su pago en la pasarela
    public List headerPath;         // Path para llegar a la pasarela que se muestra en la cabecera
    public Map configuracionesPagoCSB;		// Configuraciones de pago por CSB
    
    /** Constructores */
    public DatosPasarela() {       
    }   
    
    
//____________________________________________________________________________\\
    public String getColor(String colorID) {
        if (this.colores == null) return "#FFFFFF";
        Color color = (Color)this.colores.get(colorID);
        if (color != null) {
            return color.code;
        } else {
            return "#FFFFFF";
        }       
    }
    
}
