package p12f.exe.pasarelapagos.v1.objects;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;


/**
 * Datos de protocolo en la comunicacin entre una entidad financiera y 
 * la pasarela de pagos de la administracin
 * Estos son los datos que se intercambian los servidores y que sirven 
 * para controlar la comunicacion y el flujo de datos
 */

public class Protocolo extends AbstractPagoObj {
    public String pagoID;           // Identificador del pago en la pasarela     
    public String numeroOperacion;  // Numero de operacion asignado por la plataforma
    public String timeStamp;        // Marca de tiempo
    public String token;            // Token   
    public String sessionID;        // Identificador de la sesion
    public String urlVuelta;        // URL a la que el banco debe enviar al cliente despues de pagar
    public String urlValidacion;    // URL en la cual el banco debe validar los datos recibidos del cliente
    public String urlResultado;     // URL en la cual el banco debe comunicar los resultados del pago
    
    
    /**
     * Convierte un Objeto Pago a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
    
    
    /**
     * Convierte un XML en un objeto Pago.
     * @return
     * @throws XOMarshallerException
     */
    public static Protocolo getObject(String xml) throws XOMarshallerException {    
        return (Protocolo)XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"), xml);
    }
    
    
    
}
