/**
 * Objeto que sirve para comunicar algo entre aplicaciones
 * (entre la pasarela y los servidores de la entidad financiera, etc)
 */
package p12f.exe.pasarelapagos.v1.objects;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;



public class ResultadoOperacion extends AbstractPagoObj {
    public boolean resultado;       // true o false dependiendo del resultado
    public int codigoResultado;     // Un codigo numerico con el resultado
    public String detalle;          // El detalle del resultado
    
    
    /** Constructores */
    public ResultadoOperacion() {
    }  
    public ResultadoOperacion(boolean newResultado) {
        this.resultado = newResultado;
    }
    public ResultadoOperacion(boolean newResultado,int newCodigoResultado, String newDetalle) {
        this.resultado = newResultado;        
        this.codigoResultado = newCodigoResultado;
        this.detalle = newDetalle;
    }
    
    /**
     * Convierte un Objeto Pago a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
    
    /**
	 * Convierte un XML en un objeto Pago.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ResultadoOperacion getObject(String xml) throws XOMarshallerException {    
	    return (ResultadoOperacion)XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"), xml);
	}
}
