package p12f.exe.pasarelapagos.v1.objects;

/**
 * Objeto con el resultado de un pago
 * Este objeto lo envia la entidad financiera a la pasarela de pagos
 */
import java.util.List;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ResultadoPago extends AbstractPagoObj {
	public boolean resultado; // El resultado del pago
	public Estado estadoPago;
	public Estado estadoSIPCA; // Indica si el pago se ha pasado a SIPCA    
	public DatosOperacion datosOperacion; // Los datos de la operacion
	public List mensajes; // Mensajes del resultado del pago
	public Protocolo protocolo; // Datos de protocolo
	public List datosAuxiliares; // Datos auxiliares

	/** Constructores */
	public ResultadoPago() {
	}
	public ResultadoPago(boolean inResultado) {
		this.resultado = inResultado;
	}
	public ResultadoPago(
		boolean inResultado,
		Estado inEstado,
		List inMensajes) {
		this.resultado = inResultado;
		this.estadoPago = inEstado;
		this.mensajes = inMensajes;
	}	
	
	/**
	 * Convierte un Objeto ValidacionPago a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
        //String xml_header = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>"; 
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ValidacionPago.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ResultadoPago getObject(String xml) throws XOMarshallerException {    
	    return (ResultadoPago)XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"), xml);
	}
}
