package p12f.exe.pasarelapagos.v1.objects;

/**
 * Objeto con el resultado de la validacin de un pago
 */
import java.util.ArrayList;
import java.util.List;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;


public class ResultadoValidacionPago extends AbstractPagoObj {
    public boolean resultado;   // El resultado de la validacin
    public Pago pago;           // El pago validado
    public List mensajes;       // Mensajes de la validacin
    
    
    /** Constructores */
    public ResultadoValidacionPago() {
    }
    public ResultadoValidacionPago(boolean inResultado,Pago inPago) {
        this.resultado = inResultado;
        this.pago = inPago;
    }
    public ResultadoValidacionPago(boolean inResultado,Pago inPago, String msgCastellano, String msgEuskera) {
        this.resultado = inResultado;
        this.pago = inPago;
        if (msgCastellano != null || msgEuskera != null) {
            Mensaje msg = new Mensaje(msgCastellano,msgEuskera);
            if(this.mensajes==null)
                this.mensajes = new ArrayList();
            this.mensajes.add(msg);
        }
    }
    public ResultadoValidacionPago(boolean inResultado,Pago inPago,List inMensajes) {
        this.resultado = inResultado;
        this.pago = inPago;
        this.mensajes = inMensajes;       
    }    
    
    /**
	 * Convierte un Objeto ResultadoValidacionPago a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
        //String xml_header = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>"; 
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ResultadoValidacionPago.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ResultadoValidacionPago getObject(String xml) throws XOMarshallerException {    
	    return (ResultadoValidacionPago)XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"), xml);
	}
}
