package p12f.exe.pasarelapagos.v1.objects;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Objeto de validacin del pago
 * Simplemente contiene un pago...
 */

public class ValidacionPago extends AbstractPagoObj {
    public Pago pago;       // El pago a validar
    public String urlResultadoValidacion;       // URL a la que comunicar el resultado de la validacin
    
    
    /** Constructores */
    public ValidacionPago() {
    }    
    public ValidacionPago(Pago newPago) {
        this.pago = newPago;
    }
    public ValidacionPago(Pago newPago,String newURL) {
        this(newPago);
        this.urlResultadoValidacion = newURL;
    }
    
    /**
	 * Convierte un Objeto ValidacionPago a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
        //String xml_header = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>"; 
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ValidacionPago.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ValidacionPago getObject(String xml) throws XOMarshallerException {    
	    return (ValidacionPago)XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"), xml);
	}
}
