package p12f.exe.pasarelapagos.v1.objects.config;

import java.util.Map;

import p12f.exe.pasarelapagos.v1.objects.Descripcion;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Define un color
 */

public class ConfigEntidad {
    public String oid;       	// Identificador del cif (ej. dpto.educacion, gv, etc)
    public String cif;    		// El codigo del cif
    public int orden;       	// El order con que aparece el cif en el combo
    public boolean activa;	// Indica si la entidad est activa
    public boolean esEntidadPorDefecto = false; // Indica si es el cif que se muestra por defecto en el combo
    public Descripcion descripcion;
    public Map configSufijos;	// Configuracin de los sufijos admitidos para pago en este emisor    
    

    
    /** Constructores */
    public ConfigEntidad() {
    }   
    public ConfigEntidad(String newOID, String newCif) {
        this.oid = newOID;
        this.cif = newCif;
        this.esEntidadPorDefecto = false;
    }

    
   /**
     * Convierte de un String xmlPeticionPago a un Objeto 
     * @param xmlPeticionPago : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static ConfigEntidad getObject( String xml) throws XOMarshallerException {
        //System.out.println(xml);
        ConfigEntidad  entityConfig = (ConfigEntidad) XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"),xml);   
        return  entityConfig;
    }
    
    /**
     * Convierte un Objeto Emisor a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
}
