package p12f.exe.pasarelapagos.v1.objects.config;

/**
 * Clase que define un pago
 */


import java.util.List;
import java.util.Map;

import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

import p12f.exe.pasarelapagos.v1.objects.Aplicacion;
import p12f.exe.pasarelapagos.v1.objects.Descripcion;
import p12f.exe.pasarelapagos.v1.objects.Emisor;
import p12f.exe.pasarelapagos.v1.objects.Liquidacion;
import p12f.exe.pasarelapagos.v1.objects.Presentacion;




public class ConfigSufijo { 
	public String oid;					 // OID del sufijo    
    public Emisor emisor;               // Datos del emisor del pago
    public Descripcion descripcion;     // Descripcion del pago
    public boolean informarSIPCA;		 // Indica si hay que informar a SIPCA
    public String entidadSIPCA;         // Entidad emisora de dos posiciones
    public boolean exentoPago;         // Datos para SIPCA
    public boolean gastoGV;            // Indicador de gasto del GV
    public String modoPago;             // Modo pago: fraccionado / contra deposito / TPV Virtual
    public String expedienteAsociado;   // Expediente asociado en atea
    public String ejercicioContable;    // Ejercicio contable para SIPCA
    public List conceptosPeticionPago;  // Conceptos del pago (en teoria solo uno pero se podran meter mas...)... a falta de poner el importe (modulo ia)
    public Map imagenes;                // Imagenes para el recibo
    public Map mensajes;                // Mensajes auxiliares
    public List datosAdicionales;
    public List datosAuxiliares;
    public Aplicacion aplicacion;       // Aplicacin origen (si la hay)
    public Presentacion presentacion;   // Datos de presentacion en la pasarela de pagos
    public Liquidacion liquidacion;	 // Datos para imprimir la liquidacion
 
    /** Constructores */
    public ConfigSufijo() {
    }
   /**
     * Convierte de un String xmlPeticionPago a un Objeto 
     * @param xmlPeticionPago : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static ConfigSufijo getObject( String xml) throws XOMarshallerException {
        //System.out.println(xml);
        p12f.exe.pasarelapagos.v1.objects.config.ConfigSufijo entityConfig = (p12f.exe.pasarelapagos.v1.objects.config.ConfigSufijo) XOManager.getObject(XMLProperties.get("p12f","objectMapPathV1"),xml);   
        return  entityConfig;
    }
    /**
	 * Convierte un Objeto Pago a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPathV1"),this);
    }
 

    
    
    
}
