/*
 * Created on Sep 21, 2010
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search;

import java.io.Serializable;

import p12f.exe.pasarelapagos.objects.Estado;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas.
 */
public class PaymentHistoricDataItem implements Serializable, Initializable {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public String operationDateTimestamp; // fecha y hora
    public Estado stage ; // estado
	public String paymentMode; // modo de pago
	public String finantialOrgCode; // cdigo de la Entidad Financiera

	public PaymentHistoricDataItem() {
        ObjectUtils.initialize(this);
    }
   
    /**
     * Convierte un Objeto PaymentHistoricDataItem a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
     * Convierte un XML en un objeto PaymentHistoricDataItem.
     * @return Objeto PaymentHistoricDataItem construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentHistoricDataItem getObject(String xml) throws XOMarshallerException {    
        return (PaymentHistoricDataItem)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
    
}
