/*
 * Created on May 29, 2007
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search;

import java.io.Serializable;
import java.util.Date;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas.
 */
public class PaymentSearchResult implements Serializable, Initializable {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public String expCode ;
    public String nrcCode ;
    public String stateCode ;
    public String dni ;
    public String pagoIdField ;
    public String expFamily ;
    public String adminField ;
    public String typoField ;
    public long importe;
    public Date initDate;
	public Date paymentDayDate;
	public Date paymentHourDate;
	
	public String paymentMode;
	public String finantialOrgCode;
	
	public PaymentHistoricDataItemList historicData;
    
    public String backendStatus;
	
    public PaymentSearchResult() {
        ObjectUtils.initialize(this);
    }
   
    /**
     * Convierte un Objeto PaymentSearchResult a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
    	//System.out.println("@paymentDayData="+paymentDayDate);
    	//System.out.println("@paymentHourDate="+paymentHourDate);
    	
    	//System.out.println("Classmap="+XMLProperties.get("p12f","objectMapPath"));
    	
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
     * Convierte un XML en un objeto PaymentSearchResult.
     * @return Objeto PaymentSearchResult construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentSearchResult getObject(String xml) throws XOMarshallerException {    
        return (PaymentSearchResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
    
    
    
}
