package p12f.exe.search;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas por entidad financiera
 */
public class PaymentStatsFinantialOrgResult {

//    <finantialOrg>EF.FINANTIALORG AS ENTIDAD</finantialOrg> <!-- 2095/3035/... -->
//    <nIniciados>ESTADO02.NPAGOS AS INICIADOS</nIniciados>
//    <importeIniciados>ESTADO02.IMPORTE AS IMPORTEINICIADOS</importeIniciados>
//    <nCompletados>ESTADO04.NPAGOS AS COMPLETADOS</nCompletados>
//    <importeCompletados>ESTADO04.IMPORTE AS IMPORTECOMPLETADOS</importeCompletados>
//    <nErroneos>ESTADO05.NPAGOS AS ERRONEOS</nErroneos>
//    <importeErroneos>ESTADO05.IMPORTE AS IMPORTEERRONEOS</importeErroneos>

	private static final long serialVersionUID = 1L;
    public String finantialOrg;     // 3035, 2095, ...
    public long nIniciados;         // numero de pagos iniciados en la EF
	public long importeIniciados;   // importe total de pagos iniciados contra la EF
    public long nCompletados;       // numero de pagos completados en la EF
	public long importeCompletados; // importe total de pagos completados contra la EF
    public long nErroneos;          // numero de pagos errneos en la EF
	public long importeErroneos;    // importe total de pagos erroneos contra la EF

    public PaymentStatsFinantialOrgResult() {
        ObjectUtils.initialize(this);
    }

    /**
     * Convierte un Objeto PaymentStatsFinantialOrgResult a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {

    	System.out.println("Classmap="+XMLProperties.get("p12f","objectMapPath"));

        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }

    /**
     * Convierte un XML en un objeto PaymentStatsFinantialOrgResult.
     * @return Objeto PaymentStatsFinantialOrgResult construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentStatsResult getObject(String xml) throws XOMarshallerException {    
        return (PaymentStatsResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
}
