package p12f.exe.search;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas.
 */
public class PaymentStatsResult implements Serializable, Initializable {

    /**
	 * 
	 */
//    <formatField>INICIADOS.FORMATFIELD AS FORMATFIELD</formatField> <!-- 507/502/521/522 -->
//    <adminField>INICIADOS.ADMINFIELD AS ADMINFIELD</adminField> <!-- 04833001/486000/... -->
//    <typoField>INICIADOS.TYPOFIELD AS TYPOFIELD</typoField> <!-- 800/... -->
//    <nIniciados>INICIADOS.NPAGOIDFIELD AS NINICIADOS</nIniciados>
//    <importeIniField>INICIADOS.SIMPORTEFIELD AS SIMPORTEINIFIELD</importeIniField>
//    <nCompletados>COMPLETADOS.NPAGOIDFIELD AS NCOMPLETADOS</nCompletados>
//    <importeField>COMPLETADOS.SIMPORTEFIELD AS SIMPORTEFIELD</importeField>

	private static final long serialVersionUID = 1L;
    public String adminField;
    public String typoField;
	public String formatField;
	public String detalle;    // "TOTAL" o desglose (p.ej. "3035", "2095" si por EF
    public long nIniciados;   // numero de pagos iniciados
	public long importeIni;   // importe total de pagos iniciados para el tributo
    public long nCompletados; // numero de pagos completados
	public long importe;      // importe total de pagos completados para el tributo

    public PaymentStatsResult() {
        ObjectUtils.initialize(this);
    }

    /**
     * Convierte un Objeto PaymentStatsResult a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {

    	System.out.println("Classmap="+XMLProperties.get("p12f","objectMapPath"));

        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }

    /**
     * Convierte un XML en un objeto PaymentSearchResult.
     * @return Objeto PaymentSearchResult construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentStatsResult getObject(String xml) throws XOMarshallerException {    
        return (PaymentStatsResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
}
