/*
 * Created on May 29, 2007
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search;

import java.io.Serializable;
import java.util.HashMap;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.MarshallerArrayContainer;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas.
 */
public class PaymentStatsResultMap implements Serializable, Initializable {

	
	public HashMap results = new HashMap();
	
	
	private static final long serialVersionUID = 1L;
	
	
    
    public PaymentStatsResultMap() {
        ObjectUtils.initialize(this);
    }
   
    /**
     * Convierte un Objeto PaymentSearchResult a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
    
    	
    	System.out.println("Classmap="+XMLProperties.get("p12f","objectMapPath"));
    	
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
     * Convierte un XML en un objeto PaymentSearchResult.
     * @return Objeto PaymentSearchResult construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentStatsResultMap getObject(String xml) throws XOMarshallerException {    
        return (PaymentStatsResultMap)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
    
	public static void main(String[] argv) throws XOMarshallerException{
		
		String[] prueba1 = new String[] { "0","1","2" };
		String[] prueba2 = new String[] { "3","4","5" };		
		
		MarshallerArrayContainer array1 = new MarshallerArrayContainer();
		array1.setArray(prueba1);
		MarshallerArrayContainer array2 = new MarshallerArrayContainer();
		array2.setArray(prueba2);
		
		PaymentStatsResultObject obj1 = new PaymentStatsResultObject();
		obj1.result = array1;
		obj1.oid = "Elemento 1";
		PaymentStatsResultObject obj2 = new PaymentStatsResultObject();
		obj2.result = array2;
		obj2.oid = "Elemento 2";
		
		PaymentStatsResultMap p = new PaymentStatsResultMap();
		p.results.put(obj1.oid, obj1);
		p.results.put(obj2.oid, obj2);
		System.out.println(p.toXML());
		String kk = p.toXML();
		PaymentStatsResultMap pp = PaymentStatsResultMap.getObject(kk);
		System.out.println(pp.toXML());
	
	}
    
}
