/*
 * Created on May 29, 2007
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.MarshallerArrayContainer;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Resultado de Busquedas.
 */
public class PaymentStatsResultObject implements Serializable, Initializable {

	
	public MarshallerArrayContainer result;
	public String oid;
	
	
	private static final long serialVersionUID = 1L;
	
	
    
    public PaymentStatsResultObject() {
        ObjectUtils.initialize(this);
    }
    
    public PaymentStatsResultObject(String oid, String[] result) {
        ObjectUtils.initialize(this);
        this.oid = oid;
        this.result = new MarshallerArrayContainer(result);
    }
   
    /**
     * Convierte un Objeto PaymentSearchResult a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
    
    	
    	System.out.println("Classmap="+XMLProperties.get("p12f","objectMapPath"));
    	
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
     * Convierte un XML en un objeto PaymentSearchResult.
     * @return Objeto PaymentSearchResult construido a partir del XML.
     * @throws XOMarshallerException
     */
    public static PaymentStatsResultObject getObject(String xml) throws XOMarshallerException {    
        return (PaymentStatsResultObject)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
    }
    
}
