/*
 * Created on May 29, 2007
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search.parameters;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 *  Parmetros de bsqueda relativos al Pago.
 */
public class PaymentDataSearchedParam implements Serializable, Initializable {
   
    public String oidPago ; //  Oid Pago ::: Trama CSB
    
    /**
     *  Parametros bsicos para la identificacin de un tipo de Pago.
     */
    public String admin  ; //   Oid Admin
    public String typo  ; //    Sufjo/tributo
    public String format  ; //  Formato. 
    public String reference; // Referencia
    public String identification; // Identificacion
    public String importe; // Importe
    
    /**
     * Constructor vacio.
     *
     */
    public PaymentDataSearchedParam() {
        
    }
    
    
    
    /**
     * Parametros de bsqueda por campos inherentes al Pago.
     * @param admin
     * @param typo
     * @param format
     */
    public PaymentDataSearchedParam (String admin, String typo , String format) {
        
        this.admin = admin ; 
        this.typo = typo; 
        this.format = format;        
    }
    
    /**
     * Parametros de bsqueda por campos inherentes al Pago.
     * @param oid
     * @param admin
     * @param typo
     * @param format
     */
    public PaymentDataSearchedParam (String oidPago, String admin, String typo , String format) {
        
        this.oidPago = oidPago;
        this.admin = admin ; 
        this.typo = typo; 
        this.format = format;        
    }
    
    /**
     * Parametros de bsqueda por campos inherentes al Pago.
     * @param oid
     * @param admin
     * @param typo
     * @param format
     * @param reference
     * @param identification
     */
    public PaymentDataSearchedParam (String oidPago, 
            String admin, 
            String typo , 
            String format, 
            String reference,
            String identification) {
        
        this.oidPago = oidPago;
        this.admin = admin ; 
        this.typo = typo; 
        this.format = format;        
        this.reference = reference; 
        this.identification = identification;        
    }
    
    /**
     * Parametros de bsqueda por campos inherentes al Pago.
     * @param oid
     * @param admin
     * @param typo
     * @param format
     * @param reference
     * @param identification
     */
    public PaymentDataSearchedParam (String oidPago, 
            String admin, 
            String typo , 
            String format, 
            String reference,
            String identification,
            String importe) {
        
        this.oidPago = oidPago;
        this.admin = admin ; 
        this.typo = typo; 
        this.format = format;        
        this.reference = reference; 
        this.identification = identification;   
        this.importe = importe;
    }
    
    
    
    /**
     * Convierte un Objeto PaymentData a XML.
     * @return String que contiene el XML.
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {  
        return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
  

}
