package p12f.exe.search.sqlutils;

import java.text.SimpleDateFormat;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import p12f.exe.search.PaymentQuery;
import p12f.exe.search.XMLSearchProperties;
import p12f.exe.search.parameters.EXPSearchedParam;
import p12f.exe.search.parameters.PaymentDataSearchedParam;
import p12f.exe.search.parameters.PaymentStateSearchedParam;
import p12f.exe.search.parameters.ThirdPartySearchedParam;

import com.ejie.r01f.util.StringUtils;

public class PaymentQuerySQLGroupByViewComposerHelper {


    public String viewId = "888";

    /*
     *  Clase de lectura de Configuracin de Properties : p12x.searcher.properties.xml     */
    private XMLSearchProperties  searchProperties  = XMLSearchProperties.getInstance();
    
    
    public PaymentQuerySQLGroupByViewComposerHelper() {
        
    }

    public HashMap doInitializeQueryViewTypes(PaymentQuery paymentQuery) {
        HashMap mapQuery = new HashMap();

        if ((paymentQuery.getpaymentDataParameterList() != null) &&
            (!paymentQuery.getpaymentDataParameterList().isEmpty())){

            for (Iterator it= paymentQuery.getpaymentDataParameterList().iterator(); it.hasNext() ;) {
                PaymentDataSearchedParam dataSearch= (PaymentDataSearchedParam) it.next();
                mapQuery.put(viewId,_initFormatQueryView(Integer.parseInt(viewId)));
            }//for  

         } else { //System.out.println("NO SEARCH DATA");
             if (! mapQuery.containsKey(viewId)) mapQuery.put(viewId,_initFormatQueryView(Integer.parseInt(viewId)));
         }
       System.out.println(mapQuery.toString());
       // mapQuery.toString()
       // {502=Select PAGOID11_01 pagoIdField,IDENTI11 identificationField,EMISOR11 adminField,REFERE11 referenceField,TRIBU11 typoField,IMPORT11 importeField,DNINIF31 dni,RAZONSOCIAL31 razonSocial,HORAPAGO20 paymentHourDate,FECHAPAGO20 paymentDayDate,NRC20 nrcCode,FECHAINI20 initDate,ENTFIN20 finantialOrg,ESTADO20_25 stateCode,FAMEXP30 expFamily,OIDEXP30 expCode from P12G11T00 , P12G20T00, P12G30T00 , P12G31T00 where,
       //  507=Select PAGOID10_01 pagoIdField,IDENTI10 identificationField,EMISOR10 adminField,REFERE10 referenceField,SUFIJO10 typoField,IMPORT10 importeField,DNINIF31 dni,RAZONSOCIAL31 razonSocial,HORAPAGO20 paymentHourDate,FECHAPAGO20 paymentDayDate,NRC20 nrcCode,FECHAINI20 initDate,ENTFIN20 finantialOrg,ESTADO20_25 stateCode,FAMEXP30 expFamily,OIDEXP30 expCode from P12G10T00 , P12G20T00, P12G30T00 , P12G31T00 where
       // }
       return mapQuery;
    }

    /***
     * Inicializa las querys SELECT $PARAMS$ FROM $PAYMENT_DATA_VIEW$ WHERE
     * @param format
     */
    private PaymentSQL  _initFormatQueryView(int format) {
        
        PaymentSQL paymentSql = new PaymentSQL(Integer.toString(format));   

        String basicQuery = searchProperties.get("p12f","searchPaymentConfig/basicQueryViewConfig/query");

        Map variables = new HashMap();        

        // Tabla dependiente del tipo de Formato.
        variables.put("PAYMENT_DATA_VIEW", searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + format + "]//name")); 

        // Parametros
        variables.put("PARAMS",getParametersToSelect(Integer.toString(format)));

        paymentSql.hasBeeInitialized = true;

        // Inicializar la clausulas select.
        paymentSql.selectClause = StringUtils.replaceVariableValues(basicQuery,'$',variables);
        paymentSql.id = Integer.toString(format);
        
        return paymentSql;
    
    }

    /***
     * Aade Condiciones propias del Bloque de Expedientes.
     * @param third
     * @param paymentSQL
     * @return
     */    
    public PaymentSQL addExpBlockClause(EXPSearchedParam expediente ,PaymentSQL paymentSQL) {

        if (paymentSQL==null)
            return null;

        String expCondition = null;
        String blockExpedCod = null;
        //String blockExpFamily = null;

        String expCodeFieldName   = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/expCode");
        String expFamilyFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/expFamily");

        if (expediente.codExp!=null)
            blockExpedCod = expCodeFieldName + "='" + expediente.codExp + "'";

        if (expediente.codFamily!=null)
        	blockExpedCod = expFamilyFieldName + "='" + expediente.codFamily + "'";
        	//blockExpFamily = expFamilyFieldName + "='" + expediente.codFamily + "'";


        if (blockExpedCod != null) {
            expCondition = blockExpedCod;
//            if (blockExpFamily != null) {
//                expCondition = "(" + blockExpedCod + " AND " + blockExpFamily + ")";
//            }
        }

        // Aadir a las sucesivas condiciones Third.
        if (expCondition!=null) {
            if (paymentSQL.expDATAconditionClause == null)
                paymentSQL.expDATAconditionClause = expCondition;
            else 
                paymentSQL.expDATAconditionClause += " OR " + expCondition;
        }

        return paymentSQL;
    }

    /**
     * Aade condiciones del Bloque de datos del CSB
     * @param dataSearched Condiciones a aadir
     * @param paymentSQL : SQL a la que se le aadiran las condiciones.
     * @return
     */
    public PaymentSQL addPaymentDataBlockClause(PaymentDataSearchedParam dataSearched, PaymentSQL paymentSQL ) {

        if (paymentSQL==null)
            return null;
        
        //System.out.println("TRAZA (formato):" + paymentSQL.id);

        String paymenDataCondition = null;
        String blockOidPago  = null;
        String blockEmisor  = null;
        String blockTributo  = null; 
        String blockFormato  = null; 
        String blockReference  = null; 
        String blockIdentification  = null; 
        String blockImporte  = null; 

        String oidPago = dataSearched.oidPago;
        String emisor = dataSearched.admin;
        String tributo = dataSearched.typo;
        String format = dataSearched.format;
        String reference = dataSearched.reference;
        String identification = dataSearched.identification;
        String importe = dataSearched.importe;

        //System.out.println("TRAZA (format): " + format);

        String pagoIdFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/pagoIdField");
        String adminFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/adminField");
        String typoFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/typoField");
        String formatFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/formatField");
        String referenceFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/referenceField");
        String identificationFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/identificationField");
        String importeFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/importeField");

        if (oidPago!=null) {
            blockOidPago = pagoIdFieldName + "='" + oidPago + "'";
            paymenDataCondition = blockOidPago;
        }            
        if (emisor != null) {
            blockEmisor  =   adminFieldName + "='" + emisor +  "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockEmisor;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockEmisor;
            }
        }
        if (tributo != null ) {
            blockTributo =   typoFieldName  + "='" +  tributo + "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockTributo;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockTributo;
            }
        }
        if  (format != null ) {
            blockFormato =   formatFieldName  + "='" +  format + "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockFormato;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockFormato;
            }
        }
        if  (reference != null ) {
            blockReference =   referenceFieldName  + "='" +  reference + "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockReference;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockReference;
            }
        }
        if  (identification != null ) {
            blockIdentification =   identificationFieldName  + "='" +  identification + "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockIdentification;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockIdentification;
            }
        }
        if  (importe != null ) {
            blockImporte =   importeFieldName  + "='" +  importe + "'";
            if(paymenDataCondition==null) {
                paymenDataCondition = blockImporte;
            } else {
                paymenDataCondition = paymenDataCondition + " AND " + blockImporte;
            }
        }

        /*if(paymenDataCondition!=null) {
            paymenDataCondition = "(" + paymenDataCondition + ")";
        }*/

        if(paymenDataCondition!=null) {
            if (paymentSQL.csbDATAconditionClause == null)
                paymentSQL.csbDATAconditionClause = paymenDataCondition;
            else {
                paymentSQL.csbDATAconditionClause += ") OR (" +  paymenDataCondition; 
            }
        }

        return paymentSQL;
    }

    /***
     * Aade Condiciones propias del Bloque de Estado : PAGADO, NO_PAGADO, NRC......
     * @param third
     * @param paymentSQL
     * @return
     */
    public PaymentSQL addStatusBlockClause( PaymentStateSearchedParam statusParam ,PaymentSQL paymentSQL ) { 

        if ( paymentSQL  ==  null )
            return null;

        String statusCondition = null;
        String blockStatusCode = null;
        String blockNRC  = null; 
        String blockDate  = null;
        String blockFinantialOrg  = null;

        String statusCodeFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/stateCode");
        String nrcCodeFieldName =  searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/nrcCode");
        String initDateFieldName =  searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/initDate");
        String finantialOrgFieldName =  searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/finantialOrg");

        if ( statusParam.stateCode != null) {
            blockStatusCode  =   statusCodeFieldName + "='" + statusParam.stateCode  +  "'";
            statusCondition = blockStatusCode;
        }

        if  (statusParam.nrc != null ){
            blockNRC =   nrcCodeFieldName  + "='" + statusParam.nrc + "'";
	        if ( statusCondition != null) {
	            if (blockNRC !=  null) 
	                statusCondition += " AND " + blockNRC;
	        } else if (blockNRC!=null) {
	            statusCondition = blockNRC;
	        }
        }
        
        // Gestion de Fechas.

        SimpleDateFormat newFormatter = new SimpleDateFormat("MM/dd/yyyy");

 		// Hay que incluir la hora, si no se pierden ciertos pagos...
        // AND FECHAINI20 BETWEEN to_date('01/09/2008 00:00:00','DD/MM/YYYY HH24:MI:SS')
        //                    AND to_date('30/09/2008 23:59:59','DD/MM/YYYY HH24:MI:SS')

        if (statusParam.dateFrom!=null) {
            String dateFromString = newFormatter.format( statusParam.dateFrom);        
        	//blockDate =   initDateFieldName  + " >= TO_DATE('" + dateFromString+ "','MM/DD/YYYY')";               
        	blockDate =   initDateFieldName  + " >= TO_DATE('" + dateFromString.replaceAll("( [0-9]{2}:[0-9]{2}:[0-9]{2})?$", " 00:00:00") + "','MM/DD/YYYY HH24:MI:SS')";               
	        if ( statusCondition != null) {
	            if (blockDate !=  null) 
	                statusCondition += " AND " + blockDate;
	        } else if (blockDate!=null) {
	            statusCondition = blockDate;
	        }
        }
           
        if (statusParam.dateTo!=null) {
        	String dateToString = newFormatter.format( statusParam.dateTo );   
        	//blockDate =   initDateFieldName + " <= TO_DATE('" + dateToString + "','MM/DD/YYYY')";     
        	blockDate =   initDateFieldName + " <= TO_DATE('" + dateToString.replaceAll("( [0-9]{2}:[0-9]{2}:[0-9]{2})?$", " 23:59:59") + "','MM/DD/YYYY HH24:MI:SS')";     
	        if ( statusCondition != null) {
	            if (blockDate !=  null) 
	                statusCondition += " AND " + blockDate;
	        } else if (blockDate!=null) {
	            statusCondition = blockDate;
	        }
        }
        
        if (statusParam.finantialOrg!=null) {
        	blockFinantialOrg =   finantialOrgFieldName  + " = '" + statusParam.finantialOrg + "'";               
	        if ( statusCondition != null) {
	            if (blockFinantialOrg !=  null) 
	                statusCondition += " AND " + blockFinantialOrg;
	        } else if (blockFinantialOrg!=null) {
	            statusCondition = blockFinantialOrg;
	        }
        }
        
        // Aadir a las sucesivas condiciones Third.
        if(statusCondition!=null) {
            if ( paymentSQL.statusDATAconditionClause == null)
                paymentSQL.statusDATAconditionClause = statusCondition;        
            else 
                paymentSQL.statusDATAconditionClause +=   " OR " +  statusCondition;
        }
        
        return paymentSQL;       
    }

    /**
     * Aade condiciones del Bloque de datos de Tercero.
     * @param third
     * @param paymentSQL
     * @return
     */
    public PaymentSQL  addThridPartyBlockClause( ThirdPartySearchedParam third ,PaymentSQL paymentSQL ) {
        
        if ( paymentSQL  ==  null )      
            return null;
        
        String dni = third.dniNIF;
        String razonSocial  = third.razonSocial;

        String thirdCondition = null;
        String blockDNI  = null;
        String blockRazonSocial  = null; 

        String dniFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/dni");
        String razonSocialFieldName = searchProperties.get("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + viewId + "]/clauseFields/razonSocial");

        if (dni != null)
            blockDNI  =  "UPPER(" + dniFieldName + ")" + "='" + dni.toUpperCase() +  "'";
        if  (razonSocial != null )
             blockRazonSocial = "UPPER(" + razonSocialFieldName + ")" + " LIKE '%" +  razonSocial.toUpperCase() + "%'";

        if ( blockDNI != null) {
            thirdCondition = blockDNI;
            if (blockRazonSocial !=  null) 
                thirdCondition = "(" + thirdCondition + " AND " + blockRazonSocial + ")";
        } else if (blockRazonSocial!=null) {
            thirdCondition = blockRazonSocial;
        }

        // Aadir a las sucesivas condiciones Third.
        if(thirdCondition!=null) {
            if ( paymentSQL.thirdPartyDATAconditionClause == null)
                paymentSQL.thirdPartyDATAconditionClause = thirdCondition;        
            else 
                paymentSQL.thirdPartyDATAconditionClause +=   " OR " +  thirdCondition;
        }
        return paymentSQL;       
    }


    /**
     * Inserta paramtros en la Query de Consulta  : Select ID  X.ID_1 ,  ID Y. ID_2 
     */
    public String getParametersToSelect(String id) {

       // Tomamos los nombres de atributos de la view a partir de las properties...
       Properties csbCodeList = searchProperties.getProperties("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + id + "]/fields");

       // solo los aliases (key), no los nombres en tabla, ahora van contra vista...
       // Parametros CSB
       String csbParams ="";
       for  (Enumeration enum = csbCodeList.keys(); enum.hasMoreElements(); ) {
           String key = (String) enum.nextElement();
           //if (csbParams != "") csbParams += ", " + key; //"," + csbCodeList.getProperty(key) + " " + key;
           //else csbParams  += " " + key; // csbCodeList.getProperty(key) + " " + key;
           if (csbParams != "") csbParams += ", " + csbCodeList.getProperty(key);
           else csbParams  += " " + csbCodeList.getProperty(key);
        }

       return csbParams;
    }

    public String getParametersToGroup(String id) {

        // Tomamos los nombres de atributos de agrupacin de la view a partir de las properties...
        Properties groupByCodeList = searchProperties.getProperties("p12f","searchPaymentConfig/viewList/formatViews/FormatView[@id=" + id + "]/groupByFields");

        String groupByParams = "";
        for  (Enumeration enum = groupByCodeList.keys(); enum.hasMoreElements(); ) {
            String key = (String) enum.nextElement();
            if (groupByParams != "") groupByParams += ", " + groupByCodeList.getProperty(key);
            else groupByParams += " " + groupByCodeList.getProperty(key);
        }

        return groupByParams;
     }

    
    public PaymentSQL addGroupByAttributes(PaymentSQL paymentSQL) {
    	//paymentSQL.groupByClause = "GROUP BY " + getParametersToGroup(viewId);
    	
    	return paymentSQL;
    }

    // ------------------------------------------------------------------------
    // MAIN - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    // ------------------------------------------------------------------------
    /*** Testeo de Metodos */
    public static void main (String[] argv) {

        PaymentQuerySQLGroupByViewComposerHelper helper= new PaymentQuerySQLGroupByViewComposerHelper();        
        //helper.getParametersToSelect("888");
        helper.getParametersToGroup("888");
        System.out.println(helper.getParametersToGroup("888"));

    }

}
