package p12f.exe.search.sqlutils;

import java.util.Iterator;
import java.util.List;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import p12f.exe.pasarelapagos.objects.Estado;
import p12f.exe.search.PaymentQuery;
//import p12f.exe.search.XMLSearchProperties;
import p12f.exe.search.parameters.EXPSearchedParam;
import p12f.exe.search.parameters.PaymentDataSearchedParam;
import p12f.exe.search.parameters.PaymentStateSearchedParam;
import p12f.exe.search.parameters.ThirdPartySearchedParam;

public class PaymentQuerySQLViewComposer implements PaymentQuerySQLComposerInterface {

	private PaymentSQL viewPaymentSQL = null;

    public String viewId = "999";

    /*
     *  Clase de lectura de Configuracin de Properties : p12x.searcher.properties.xml
     */
    //private XMLSearchProperties searchProperties = XMLSearchProperties.getInstance();
    private PaymentQuerySQLViewComposerHelper sqlHelper = new PaymentQuerySQLViewComposerHelper();


	public String composeQuery(PaymentQuery paymentQuery) {

		// Inicializar la select con los nombre de parmetros de la vista...
		//   SELECT PAGOIDFIELD, PAYMENTDAYDATE, EXPCODE, FORMATFIELD, EXPFAMILY, IMPORTEFIELD, INITDATE, NRCCODE,
		//          PAYMENTHOURDATE, RAZONSOCIAL, FINANTIALORG, TYPOFIELD, ADMINFIELD, REFERENCEFIELD, IDENTIFICATIONFIELD, DNI, STATECODE
		//     FROM VALLPAYMENTS WHERE
		this.viewPaymentSQL = (PaymentSQL)sqlHelper.doInitializeQueryViewTypes(paymentQuery).get(viewId);
								// SELECT $PARAMS$ FROM $PAYMENT_DATA_VIEW$ WHERE

		// Las clausulas de join van implicitas en la vista, pero hay que aadir las de la propia consulta...

        // Bloque de datos referentes al CSB : ADMIN, TYPE ...
        List parameterCSBDataList = paymentQuery.getpaymentDataParameterList();
        for (Iterator it= parameterCSBDataList.iterator(); it.hasNext() ;) {
            PaymentDataSearchedParam dataSearch = (PaymentDataSearchedParam) it.next();
            viewPaymentSQL = sqlHelper.addPaymentDataBlockClause(dataSearch, viewPaymentSQL);
			//System.out.println("TRAZA (composeQuery-viewPaymentSQL): " + viewPaymentSQL.toString());
			//System.out.println("TRAZA (composeQuery-viewPaymentSQL): " + viewPaymentSQL.id + "/dsf:"+ dataSearch.format);
        }
        if (viewPaymentSQL.csbDATAconditionClause!=null) // Agrupar entre parntesis: ( () OR ... OR () )
        	viewPaymentSQL.csbDATAconditionClause = "(" + viewPaymentSQL.csbDATAconditionClause + ")";

        // Bloque de datos referentes al Tercero : DNI, RAZON SOCIAL, ETC...
        List parameterThirdPartyList = paymentQuery.getThirdPartyList();
        for (Iterator it= parameterThirdPartyList.iterator(); it.hasNext() ;) {
            ThirdPartySearchedParam third = (ThirdPartySearchedParam) it.next();
            viewPaymentSQL = sqlHelper.addThridPartyBlockClause(third,viewPaymentSQL);
        }

        // Bloque de datos referentes al Expediente : Cdigo, Familia ...
        List expList = paymentQuery.getExpList();
        for (Iterator it= expList.iterator(); it.hasNext() ;) {
            EXPSearchedParam exp = (EXPSearchedParam) it.next();
            viewPaymentSQL = sqlHelper.addExpBlockClause(exp,viewPaymentSQL);
        }
        if (viewPaymentSQL.expDATAconditionClause!=null) // Agrupar entre parntesis: ( () OR ... OR () )
        	viewPaymentSQL.expDATAconditionClause = "(" + viewPaymentSQL.expDATAconditionClause + ")";

        // Bloque de datos referentes al Estado : Cdigo, Familia...
        List statusList = paymentQuery.getStateParameterList();
        for (Iterator it= statusList.iterator(); it.hasNext() ;) {
            PaymentStateSearchedParam status = (PaymentStateSearchedParam) it.next();
            viewPaymentSQL = sqlHelper.addStatusBlockClause(status,viewPaymentSQL);
        }

        String strFinalQuery = null;

        if (viewPaymentSQL != null) {
        	strFinalQuery = viewPaymentSQL.toString();
        }

    	return strFinalQuery;
	}

    /**
     * Testeo  de XML a SQL
     * @param arg
     * @throws XOMarshallerException
     */
    public static void main (String[] arg) throws XOMarshallerException {

        PaymentQuery  paymentQuery = new PaymentQuery();

        /*Buscar del tributo 504 del Gobierno Vasco todos los recibos pagados */
        paymentQuery.addPaymentDataSearchedParam("04833001","501","507");
        paymentQuery.addPaymentDataSearchedParam("486000","001","502");
        paymentQuery.addPaymentDataSearchedParam("486000","047","521");
        paymentQuery.addPaymentDataSearchedParam("486000","051","522");
        // -------------------------------------------------------------------
        paymentQuery.addThirdPartyDNIData("15391987l");
        paymentQuery.addThirdPartyDNIData("12345678Z");
        paymentQuery.addThirdPartyRazonSocialData("Enjuto Mojamuto");
        paymentQuery.addThirdPartyRazonSocialData("Condemor");
        // -------------------------------------------------------------------
        paymentQuery.addEXPCodeData("1234567890123456789012345");
        paymentQuery.addEXPCodeData("1234567890123456789012346");
        paymentQuery.addEXPFamilyData("99999999");
        // -------------------------------------------------------------------
        paymentQuery.addPaymentStateCodeData(Estado.PAGADO);
        paymentQuery.addPaymentStateCodeData(Estado.NO_DATA);
        paymentQuery.addPaymentStateNRCData("QWERTY1234567890");
        paymentQuery.addPaymentStateNRCData("ASDFGH1234567890");

        //System.out.println("TRAZA: paymentQuery: " + paymentQuery.toXML());
        //System.out.println(XOConstants.xmlHeaderDirective + paymentQuery.toXML());

        PaymentQuerySQLViewComposer sqlHelper = new PaymentQuerySQLViewComposer();

        String strFinalQuery  = sqlHelper.composeQuery(paymentQuery);

        System.out.println("============================" );
        System.out.println("FINAL QUERY =\n" + strFinalQuery);
        System.out.println("============================" );

        /*
        SELECT PAGOIDFIELD, PAYMENTDAYDATE, EXPCODE, FORMATFIELD, EXPFAMILY, IMPORTEFIELD, INITDATE, NRCCODE,
               PAYMENTHOURDATE, RAZONSOCIAL, FINANTIALORG, TYPOFIELD, ADMINFIELD, REFERENCEFIELD, IDENTIFICATIONFIELD,
               DNI, STATECODE
          FROM VALLPAYMENTS
         WHERE ((ADMINFIELD='04833001' AND TYPOFIELD='501' AND FORMATFIELD='507') OR
                (ADMINFIELD='486000' AND TYPOFIELD='001' AND FORMATFIELD='502') OR
                (ADMINFIELD='486000' AND TYPOFIELD='047' AND FORMATFIELD='521') OR
                (ADMINFIELD='486000' AND TYPOFIELD='051' AND FORMATFIELD='522'))
           AND (UPPER(DNI)='15391987L' OR UPPER(DNI)='12345678Z' OR UPPER(RAZONSOCIAL) LIKE '%ENJUTO MOJAMUTO%' OR UPPER(RAZONSOCIAL) LIKE '%CONDEMOR%')
           AND (STATECODE='04' OR STATECODE='06' OR NRCCODE='QWERTY1234567890' OR NRCCODE='ASDFGH1234567890')
           AND (EXPCODE='1234567890123456789012345' OR EXPCODE='1234567890123456789012346' OR EXPFAMILY='99999999')
         */
        
    }
}
