/*
 * Created on Jun 6, 2007
 * 
 * @author ie00191m - Alex Lara
 * (c) 2007 EJIE: Eusko Jaurlaritzako Informatika Elkartea
 */
package p12f.exe.search.sqlutils;

/***************************************************************************************/
/*          Clase que representa una Query Bsica de consulta Contra la BD        
/***************************************************************************************/


public class PaymentSQL {
    
    /*  Parametros Basicos */
    public String id = null;
    public String selectClause = null;
    public String csbDATAconditionClause = null;
    public String thirdPartyDATAconditionClause = null;
    public String statusDATAconditionClause = null;
    public String expDATAconditionClause = null;
    public String finantialOrgDATAconditionClause = null; // 3035, 2095, 2097. ...
    public String paymentModeDATAconditionClause = null; // ventanilla, online, movil...
    public String joinClause = null;
    public String groupByClause = null;
    public String statusCodeClause = null; // para forzar consulta solo sobre cierto estado (Estado.PAGADO)
    
    
    /*  Una query se inicializar cuando se detecta que hay datos para ese formato. */
   
    public boolean hasBeeInitialized = false;
    
    
    public PaymentSQL() {
        
        
    }
   
    public PaymentSQL( String id ) {
        this.id = id;
    }
    
    
    /**
     * Devuelve un String con la SQL parseada
     */
    public String toString() {
        
        
        if ( this ==  null) 
              return null;
        
        boolean conditionInitialized = false;
        String completeSql =  selectClause + "\n";
        // Datos de CSB
        if ( csbDATAconditionClause != null   ) { 
            if (conditionInitialized)
                completeSql +=  " AND (" + csbDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + csbDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }
        } 
        // Datos de Tercero.
        if ( thirdPartyDATAconditionClause != null   ) {
            if (conditionInitialized)
                completeSql +=  " AND (" + thirdPartyDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + thirdPartyDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }              
        }       
        // Datos de Estado
        if ( statusDATAconditionClause != null   ) {
            if (conditionInitialized)
                completeSql +=  " AND (" + statusDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + statusDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }            
        } 
        // Datos de Expediente
        if ( expDATAconditionClause != null   ) {
            if (conditionInitialized)
                completeSql +=  " AND (" + expDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + expDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }            
        }
        // Datos de entidad financiera: AND (3035 OR 2095 OR ...)
        if ( finantialOrgDATAconditionClause != null   ) {
            if (conditionInitialized)
                completeSql +=  " AND (" + finantialOrgDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + finantialOrgDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }            
        }
        // Datos de modo de pago: AND (ventanilla OR mvil OR ...)
        if ( paymentModeDATAconditionClause != null   ) {
            if (conditionInitialized)
                completeSql += " AND (" + paymentModeDATAconditionClause + ")\n"  ;
            else {
                completeSql += "(" + paymentModeDATAconditionClause + ")\n" ;
                conditionInitialized = true;
            }            
        }
        // Datos de estado de pago
        if (statusCodeClause != null) {
        	completeSql += " AND (" + statusCodeClause + ") \n";
        }
        // Datos de Join.
        if ( joinClause != null   ) {
            if (conditionInitialized)
                completeSql += joinClause + "\n"  ;
            else {
                completeSql += joinClause + "\n" ;
                conditionInitialized = true;
            }                
        }
        // Group by
        if ( groupByClause != null   ) {                 
            if (conditionInitialized)
                completeSql +=  groupByClause + "\n"  ;
            else {
                completeSql += groupByClause + "\n" ;
                conditionInitialized = true;
            }                
        }
       return  completeSql;
    }
}   
