package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Map;

import p12f.exe.thirdsgateway.objects.config.ThirdsRegistryConfiguration;
import p12f.exe.thirdsgateway.objects.config.VariableConfig;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class RegistryItem implements Initializable, Serializable {

	public ThirdData thirdData;	
	public Map data;
	public String validationsOk;
	
	public RegistryItem() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto RegistryItem a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto RegistryItem.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static RegistryItem getObject(String xml) throws XOMarshallerException {    
	    return (RegistryItem)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
    /**
	 * Convierte un objeto ThirdsRegistryConfiguration en un objeto RegistryItem.
	 * @return
	 */
	public static RegistryItem getObject(ThirdsRegistryConfiguration registroConf, String id) {
	    RegistryItem registro = new RegistryItem();
	    // Vamos aadiendo las variables
	   	Iterator itVariables = registroConf.variablesConfig.keySet().iterator();
	   	while (itVariables.hasNext()) {
	   		String keyVar = (String)itVariables.next();
	   		VariableConfig varConfig = (VariableConfig)registroConf.variablesConfig.get(keyVar);
	   		Variable variable = new Variable();
	   		variable.id = varConfig.id;

	   		registro.data.put(variable.id, variable);
	   	}
		return registro; 
	}
	
	public static void main(String[] args) throws XOMarshallerException, Exception {
		
		RegistryItem registro = new RegistryItem();
		
		ThirdData thirdData = new ThirdData();
		thirdData.id = "12345678Z";
		registro.thirdData = thirdData;
		
	
		System.out.println(registro.toXML());
		
	}
	
}