package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ThirdData implements Serializable, Initializable {

	public String id;
	public String transactionId;
	public Map signatorys;
	
	public ThirdData() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ThirdData a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ThirdData.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ThirdData getObject(String xml) throws XOMarshallerException {    
	    return (ThirdData)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}