package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ThirdsGatewayAuthorization implements Initializable, Serializable {

	public String signText;	
	public Map requestText;
	public Map signatorys;
	public String timestamp;
	public String authorizationType;
	public String signature;
	
	public ThirdsGatewayAuthorization() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto Authorization a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto Authorization.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ThirdsGatewayAuthorization getObject(String xml) throws XOMarshallerException {    
	    return (ThirdsGatewayAuthorization)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}