package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ThirdsGatewayRequest implements Initializable, Serializable {

	public String id;
	public String idioma;
	public String thirdsRegistryId;	
	public String urlCallBack;
	public Map description;
	public ThirdsGatewayAuthorization thirdsGatewayAuthorization;
	
	public ThirdsGatewayRequest() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ThirdsGatewayRequest a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
	public String toXML() throws XOMarshallerException {   
		return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
	}
	
	/**
	 * Convierte un XML en un objeto ThirdsGatewayRequest.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ThirdsGatewayRequest getObject(String xml) throws XOMarshallerException {    
		return (ThirdsGatewayRequest)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}