package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ThirdsRegistryOperationResult implements Initializable, Serializable {

	public static final int RESULTADO_OK = 1;
	public static final int RESULTADO_NULL = 0; // No hay resultado
	
	public static final int RESULTADO_ERROR = -1; // Vendra mensaje
	public static final int RESULTADO_ERROR_NO_COMUNICACION = -2;
	public static final int RESULTADO_ERROR_RESPUESTA_INDETERMINADA = -3;
	public static final int RESULTADO_ERROR_EN_REGISTRO = -4;
	public static final int RESULTADO_ERROR_RESPUESTA_NO_ESPERADA = -5;
	public static final int RESULTADO_ERROR_PROCESANDO_RESPUESTA_REGISTRO = -6;
	
	/**
	 * Indica si la operacin se ha podido realizar (true/false). 
	 */
	public boolean resultadoOK;
	/**
	 * Resultado de la operacin. Puede ser cualquier valor, incluido un XML. 
	 */
	public RegistryItem registryItem;
	/**
	 * Cdigo numrico del resultado de la operacin: cdigo de operacin o cdigo de error.
	 */
	public int returnCode;
	/**
	 * Mensajes acerca del proceso (errores, informacin, etc.).
	 */
	public Map mensajes;
	
	public ThirdsRegistryOperationResult() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ThirdsRegistryOperationResult a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ThirdsRegistryOperationResult.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ThirdsRegistryOperationResult getObject(String xml) throws XOMarshallerException {    
	    return (ThirdsRegistryOperationResult)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
