package p12f.exe.thirdsgateway.objects;

import java.io.Serializable;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class Variable implements Initializable, Serializable {

	public String id;	
	public String value;
	public String validations;
	
	public Variable() {
		ObjectUtils.initialize(this);
		value = "";
	}
	
	/**
	 * Convierte un Objeto Variable a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto Variable.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static Variable getObject(String xml) throws XOMarshallerException {    
	    return (Variable)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

	
}