package p12f.exe.thirdsgateway.objects.config;

import java.util.Map;

import p12f.exe.pasarelapagos.objects.security.SecurityContextConfig;

import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos basicos e configuracion de una administracion
 */

public class BasicThirdsRegistryConfiguration extends BaseThirdsConfigObject{

	/**
     * OID de la ent-.
     */
    public String oid;
    /**
     * Claves de la Entidad Financiera para la generacin del NRC.
     */
    public Map claves;
    /**
     * Datos adicionales que pueda tener la Entidad Financiera.
     */
    public Map datosAdicionales;
    
    public SecurityContextConfig securityContextConfig;
    
    public BasicThirdsRegistryConfiguration(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml: XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static BasicThirdsRegistryConfiguration getObject( String xml) throws XOMarshallerException {
        return (BasicThirdsRegistryConfiguration) XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto FinantialOrgConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
}
