package p12f.exe.thirdsgateway.objects.config;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class EmailServiceConfig implements Initializable, Serializable {
	
	public List emailsTo;
	public List emailsToCC;
	public List emailsToCCO;
	public String emailSubject;
	public String emailTemplate;
	public Map emailTemplateParams;
	
	public EmailServiceConfig() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ServiceConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ServiceConfig.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static EmailServiceConfig getObject(String xml) throws XOMarshallerException {    
	    return (EmailServiceConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}

