package p12f.exe.thirdsgateway.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ReportGenerator implements Serializable, Initializable {

	public static final Integer DEFAULT_VALIDITY_PERIOD = new Integer(14);
	
	public Map templates;
	public Map instructions;
	public Integer validityPeriod;
	
	public ReportGenerator() {
		ObjectUtils.initialize(this);
	}
	
	/**
	 * Convierte un Objeto ReportGenerator a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ReportGenerator.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ReportGenerator getObject(String xml) throws XOMarshallerException {    
	    return (ReportGenerator)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}
