package p12f.exe.thirdsgateway.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ServiceConfig implements Initializable, Serializable {
	
	public static final String RPC_SERVICE = "rpc";
	public static final String WEB_SERVICE = "ws";
	public static final String EMAIL_SERVICE = "email";
	
	public boolean internal;
	public String tipoServicio;
	public EmailServiceConfig emailServiceConfig;
	public String clase;
	public Map urls;
	
	public ServiceConfig() {
		ObjectUtils.initialize(this);
		this.internal = false;
	}
	
	/**
	 * Convierte un Objeto ServiceConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ServiceConfig.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ServiceConfig getObject(String xml) throws XOMarshallerException {    
	    return (ServiceConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}
	
}

