package p12f.exe.thirdsgateway.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class Template implements Serializable, Initializable {

	public String id;
	public String templateXsl;
	public String classGenerator;
	public Map aditionalDataList;
	
	public Template(){
        ObjectUtils.initialize(this);
    }
	
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static Template getObject( String xml) throws XOMarshallerException {
        return (Template)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto RenderConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
	
}
