package p12f.exe.thirdsgateway.objects.config;


import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

/**
 * Estructura que define los datos de un render de variable de terceros
 */
public class ThirdsRender extends BaseThirdsConfigObject{
	
	public static final String REGISTRO_DEFECTO = "DEFECTO";
	
	public static final String CLASS_FORM = "01";
	public static final String CLASS_CONFIRM = "02";
	public static final String CLASS_VALIDATION = "03";
	
	public static final String TYPE_HTML = "01";
	public static final String TYPE_CSS = "02";
	public static final String TYPE_JS = "03";
	
    /**
     * OID de la Variable.
     * registro+"_"+renderType+renderClass+Variable
     */
    public String oid;

    /**
     * Registro.
     */
    public String registro;
    
    /**
     * Variable.
     */
    public String variable;
    
    /**
     * Clase de render
     */
    public String renderClass;
    
    /**
     * Tipo de render
     */
    public String renderType;
    
    /**
     * Cdigo del render
     */
    public String render;
    
    
    public ThirdsRender(){
        ObjectUtils.initialize(this);
    }
    
    /**
     * Convierte de un String xml a un Objeto 
     * @param xml : XML de objeto.
     * @return Objeto convertido.
     * @throws XOMarshallerException
     */
    public static ThirdsRender getObject( String xml) throws XOMarshallerException {
        return (ThirdsRender)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"),xml);   
    }

    /**
     * Convierte un Objeto RenderConfig a XML.
     * @return
     * @throws XOMarshallerException
     */
    public String toXML() throws XOMarshallerException {   
         return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
}
