package p12f.exe.thirdsgateway.objects.config;

import java.io.Serializable;
import java.util.Map;

import com.ejie.r01f.util.Initializable;
import com.ejie.r01f.util.ObjectUtils;
import com.ejie.r01f.xml.marshalling.XOManager;
import com.ejie.r01f.xml.marshalling.XOMarshallerException;
import com.ejie.r01f.xmlproperties.XMLProperties;

public class ValidatorConfig implements Initializable, Comparable, Serializable {

	public static final String CLASE = "class";
	public static final String URL = "url";
	
	public static final String THIRDS_REGISTRY_ID = "thirdsRegistryId";
	public static final String THIRD_ID = "thirdId";
	public static final String VARIABLE_ID = "variableId";
	public static final String VALIDATION_ID = "validationId";
	public static final String TRANSACTION_ID = "transactionId";
	public static final String MULTIPLE_ID = "multipleId";
	//public static final String TRANSACTION_TST = "transactionTst";
	public static final String VALIDATION_RESULT = "validationResult";
	public static final String RESULT = "result";
	public static final String VALOR = "value";
	
	public String id;
	public Map description;
	public boolean enabled;	
	public int order;
	public boolean internal;
	public boolean hasDataResult;
	public boolean isMultiple;
	public String type;
	public String typeImplement;
	public boolean synchronous;
	public Map aditionalData;
	
	public ValidatorConfig() {
		ObjectUtils.initialize(this);
		this.internal = false;
		this.enabled = false;
		this.isMultiple = false;
		this.hasDataResult = false;
		this.synchronous = false;
	}
	
	/**
	 * Convierte un Objeto ValidatorConfig a XML.
	 * @return
	 * @throws XOMarshallerException
	 */
    public String toXML() throws XOMarshallerException {   
    	return XOManager.getXML(XMLProperties.get("p12f","objectMapPath"),this);
    }
    
    /**
	 * Convierte un XML en un objeto ValidatorConfig.
	 * @return
	 * @throws XOMarshallerException
	 */
	public static ValidatorConfig getObject(String xml) throws XOMarshallerException {    
	    return (ValidatorConfig)XOManager.getObject(XMLProperties.get("p12f","objectMapPath"), xml);
	}

	public int compareTo(Object o) {
		ValidatorConfig other = (ValidatorConfig)o;
		return this.order - other.order;
	}

}
